Crystal Space detailed change log.
http://www.crystalspace3d.org/

The overall history is in reverse (descending) chronological order, so that
each new day's entries apears before the previous day's entries.  The
individual changes for each given day, however, are in normal (ascending)
chronological order.

23-Jul-2007
	- res fixed crystal.m4 to use the right test order when a development
	  resp. stable version is requested (previously, the orders actually
	  tested where swapped in comparison to the described desired
	  behaviour).
18-Jul-2007
	- res changed the cs-config wrapper to emit a better error message
	  when no cs-config-* scripts are found. Also, the directory from
	  which the wrapper was started is now searched as well.
	- res replaced the unportable use of 'dirname' in the cs-config 
	  wrapper with a custom (but portable) function, as suggested by Eric.
	  Also made the "no cs-config-* ..." error message output to stderr
	  instead of stdout.
24-Jun-2007
	- res made "jam install" install not just "history.txt" but
	  "history*.txt" - this way the branch-specific histories (e.g.
	  for release branches) are installed as well.
1-Jun-2007
	- res changed the cs-config wrapper script to use '=' instead of '==' 
	  for more POSIX compliancy.
	- res changed the cs-config wrapper script to use shell built-ins
	  instead of external utilities to construct the initial list of
	  cs-config-* scripts.
30-May-2007
	- res made the manual and API docs include the version number in their
	  respective titles.  One idea is to make the different versions more
	  distinguishable in e.g. search results.
21-May-2007
	- res committed a patch by 'whirm' to replace the use of pushd/popd
	  when building CS with cd/cd -: pushd/popd is a bashism while cd/cd -
	  works on a wider range of shells.
2-May-2007
	- res changed the cs-config wrapper to also look into $CRYSTAL/bin
	  for wrapped cs-config-X.Y scripts.
25-Apr-2007
	- res fixed Jam "using independent target <sometarget>.dbg" messages.
	- res made the application symlink installation respect DESTDIR.
21-Apr-2007
	- res changed the installation of applications to install apps with a
	  suffix of the version number and to create a symlink for the
	  undecorated name.
	- res made the cs-config wrapper script be installed by the install_bin
	  jam target as well.
20-Apr-2007
	- res tweaked the cs-config wrapper script to work better on MSYS.
16-Apr-2007
	- res changed the cs-config wrapper to not use -executable (which is
	  apparently not supported by older 'find's) but -perm /500 instead.
14-Apr-2007
	- res added a cs-config wrapper script that scans for cs-config-X.Y
	  scripts in CRYSTAL and PATH and picks the latest version.
	- res changed cs-config to also check a CRYSTAL_x_y env var for a 
	  CS installation.
	- res changed the cs-config jam target to copy the cs-config wrapper
	  script to the build dir.
16-Mar-2007
	- res changed the installation directory and cs-config naming to
	  include the version number in order to allow parallel installations
	  of multiple CS versions.
6-Mar-2007
	- res changed csStringBase::Upcase() and Downcase() to not use
	  toupper()/tolower() but csUnicodeTransform::MapToLower() and 
	  MapToUpper(). An issue with the to*() functions is that they respect
	  locale; this led to problems on systems that have a Turkish locale
	  set - there, the lower case of I (U+0049) 'i dotless' (U+0131) which
	  caused problems with XML parsing. Also, these strings now accept
	  UTF-8 (like most of CS) instead of the system's codepage. On the
	  downside, locale-aware casing is lost - however, support for this 
	  can (and should) be added to the csUnicodeTransform Map*() functions
	  once a need arises.
4-Mar-2007
	- res changed gmeshldr to save the "manualcolors" flag for objects
	  if it differs from the factory's setting. Also, previously it was
	  only written when manualcolors was disabled - which was wrong since
	  the default is exactly that.
3-Mar-2007
	- res added the X Window System and OpenGL to the list of "External
	  Libraries" in the manual.
	- res made a couple of tweaks to the API docs.
	- res changed CS_VERSION_NUMBER to properly contain a version
	  number in the "x.y.z" scheme (and not "x.yz").
1-Mar-2007
	- Marten fixed a serious bug in bruteblock terrain where it would
	  never cull any terrain blocks.
20-Feb-2007
	- res fixed old syntax being used in one of the manual tutorials.
	  (Spotted by IRC user runix.)
16-Feb-2007
	- res fixed an issue in xmlshader where conditions were incorrectly
	  folded away.
15-Feb-2007
	- res fixed the reflect and reflectsphere shaders to actually map the
	  diffuse texture coordinates. (Reported in CS-forum:1557.)
12-Feb-2007
	- res slightly expanded the manual section on smart pointers with
	  information on translation to and from normal pointers as well as
	  information on csWeakRef<> and how to deal with references in
	  function parameters.
	- res replaced the csPtr<> API docs with an excerpt from the user
	  manual description. Also added pointer to section in manual.
	- res fixed an inclusion of a non-existant header in the bullet 
	  plugin. (Probably went undetected due a blunder in cs-win32libs 
	  which actually ships this header [which was removed between bullet 
	  versions]...)
	- res made more Windows SDK 6.0 compatibility fixes.
8-Feb-2007
	- Marten made two tweaks to particles:
	    - Exposed initial angular velocity setting on emitters to xml.
	    - Made sure rotation-mode resets the texcoord vectors. Fixes
	      problem when switching from texcoord rotation to none.
4-Feb-2007
	- res worked around an apparent incompatibility between one of VC8's 
	  headers and a header from the latest Windows SDK 6.0. 
2-Feb-2007
	- res worked around Cg not being properly detected on Linux when
	  -Wl,--as-needed was passed in LDFLAGS.
	- res correctly placed a comment in compiler.m4 and fixed the response
	  file support test. (Previously it didn't work - the used @ sign
	  is internally used by the CS build test macros as a separator.
	  Worked around by not using the CS build macros but the relevant AC_
	  macros directly.)
1-Feb-2007
	- Marten made sure genmesh doesn't return any rendermeshes when
	  there is no triangles. Fix bug #224.
27-Jan-2007
	- res fixed separate debug info to be properly installed.
24-Jan-2007
	- res fixed configure to also emit the directory variable 
	  'datarootdir', as required by autoconf 2.60+. Should address #239.
	- res committed a patch from Ryan Thorik to resolve ambiguities in the
	  ELF reader. Addresses #231.
	- res fixed a compiler error in xmlshader with gcc 3.2.
23-Jan-2007
	- res fixed some documentation in hash.h.
	- res added a note on iTextureHandle::Blit() behaviour to the docs.
	- res fixed genmeshify to print command line help twice when run
	  with --help.
	- res changed tokenlist.h to mention its csstring.h dependency.
18-Jan-2007
	- res fixed the genmesh 3DS loader to allocate a correctly sized index
	  buffer. Addresses #236.
17-Jan-2007
	- Genjix added fix for iGeneralFactory::AddTriangle() crash in
          Invalidate().
11-Jan-2007
	- res committed a number of patches from Ryan Thorik to allow building
	  on Solaris and IRIX:
	    * finite() is declared in ieeefp.h on Solaris 10.
	    * Add MIPS, SPARC, and Alpha to the IEEE float arch list.
	    * Allow dlmalloc to get IRIX's pagesize (otherwise it would be 
	      complaining about _PAGESZ being undefined).
	    * Fix "va_list' has not been declared" issue on Solaris.
9-Jan-2007
	- res fixed the clipping rectangle for walktest's "cubemapshots"
	  command.
3-Jan-2007
	- res tweaked the MSVC build guide to reflect that multiple 
	  directories for projects for different VC versions exist.
2-Jan-2007
	- res renamed 'imagetool' to 'csimagetool', as suggested by Eric
	  (Since the pretty generic name 'imagetool' can easily collide with 
	  other packages when installed in locations like /usr/bin).
31-Dec-2006
	- Eric Sunshine made minor grammatical and mark-up corrections to the
	  new event system documentation (CS/docs/texinfo/usingcs/events).
	  Also fixed some other mark-up errors reported by 'makeinfo'.
28-Dec-2006
	- res dropped CEGUI 0.4 support.
27-Dec-2006
	- res added some documentation on the new event system (essentially the
	  appendix entry on the event system changes, somewhat reworded).
	- res renamed "gfxtest" to "imagetool".
14-Dec-2006
	- res removed the CS_FORMATTER_TYPENAME_QUALIFIER hack from
	  formatter.h. Instead, 'typename' is used everywhere. Together with
	  a missing 'template', this works on VC 7.0, VC 8.0, gcc 3.4 and
	  gcc 4.1; hence very likely on all compilers we support. Addresses
	  trac #197.
13-Dec-2006
	- res fixed the gl3d texture manager to upload Blit()ted data with the
	  right target format.
12-Dec-2006
	- res fixed a bug in csPoly3D::SplitWithPlane(): when an empty poly 
	  was split, the result polies stayed unchanged. So when a non-empty
	  polygon was used to receive a result of an empty polygon splitting,
	  it retained it's old vertices. The proper result values when 
	  splitting an empty polygon are empty polygons.
6-Dec-2006
        - Erroroman fixed copy/paste error in vproc skinning, also optimized 
          it by removing allocation of transform array for bones per 
        - Erroroman fixed problem in vproc skinning where it could fail if
          the weight of the first bone is 0 and the others weights are 
          greater than 0.
4-Dec-2006
	- Jorrit fixed csEngine::CreatePortal() so that it works as
	  intended.
3-Dec-2006
	- res fixed an issue in OpenGL R2T: the canvas clipping rect was only
	  updated when all coordinates are different in comparison to the rect
	  needed for the texture, while the rect needs to change when only
	  one coordinate is different.
2-Dec-2006
	- res fixed a crash in csEngine::CreatePortal() introduced in r25992.
	- res fixed the "search existing portal container" logic in 
	  csEngine::CreatePortal() to actually work. Previously it would 
	  always create a portal container since the found mesh would be 
	  stored in the wrong variable.
	- res fixed genmesify to handle <library path="..." file="..." />-
	  style library tags. Fixes trac #201.
28-Nov-2006
	- Andrew Dai fixed a bug that's been lurking in csColliderActor::Move
	  from the beginning of time. This occasionally allowed actors to pass
	  through walls. This should now be impossible no matter what the
	  framerate is.
	- Andrew Dai made improvements to the collision response algorithm to
	  prevent actors occasionally becoming stuck on sharp inclines.
	- Jorrit fixed a memory leak with the graveyard plugin leaking.
	- Jorrit changed the license on the castle level in CS from
	  Creative Commons by-nc to by-sa which is a less restrictive
	  license and allows commercial usage. This is done with permission
	  from Anders Wisur.
	- res updated the docs for the new winlibs version.
	- res fixed a couple of VC deprecation warnings (collection and scene
	  node array related).
	- Jorrit fixed a bug in the glx2d canvas. It used 'putenv' to
	  change the force_s3tc_enable environment variable. However
	  'putenv' directly puts the given input string into the environment
	  (it doesn't make a copy). So when later the glx2d canvas is
	  unloaded the environment still points to that string (which
	  is now unloaded and pointing to invalid memory). Replaced the
	  'putenv' with a 'setenv'. 'setenv' makes an actual copy of the
	  string so when the glx2d plugin is unloaded the environment
	  is not corrupted. This fixes a problem in celstart which would
	  crash after CS is destroyed and created again.
27-Nov-2006
	- Jorrit fixed a bug in the terrain engine. It would incorrectly
	  try to get the size from the alphamaps by using 'alphamap '
	  as string ID instead of 'alphamap 0'.
25-Nov-2006
	- res disabled RECT textures for NVIDIA cards completely since they
	  seem to cause a lot of crashes.
	- res updated the dejavu fonts to version 2.12.
24-Nov-2006
	- Jorrit fixed some compile errors caused by yesterday's
	  commit.
	- res added tweaks to the GL driver database to disable texture
	  compression and AFP for the Intel DRI driver, since both are broken
	  there.
	- caedes fixed ice.looknfeel for cegui 0.5 since it was broken from
	  last update (at least on linux), due to not updated Falagard.xsd and
	  some incorrect elements on xml. All apps using this layout would 
	  crash.
23-Nov-2006
	- Jorrit added iLoaderContext parameter to shader and shader
	  variable loading functions. That way shader variables will
	  correctly find textures using the loader context.
        - Piotr fixed track Ticket #193 (terrain collision problem)
22-Nov-2006
	- Jorrit marked collections as deprecated and obsolete. They are
	  never used and are also not useful.
	- Jorrit made the warnings when lightmaps are not up-to-date a
	  little bit less verbose.
	- res made the csDog SCF example code in the manual a bit nicer.
	- res changed the Win32 window proc to set the requested mouse cursor 
	  upon the WM_SETCURSOR message and not WM_MOUSEMOVE.
	- res fixed a deprecation warning in sndmanager.
	- res fixed a cut'n'paste error in xmlshader, likely causing memory
	  corruption. Reportedly fixes trac #194.
	- caedes fixed csVFS::LoadMountsFromFile so it allows variable
	  assignments in the loaded file to function correctly (rather than
	  being ignored).
	- res fixed a deprecation warning in 
	  csColliderHelper::InitializeCollisionWrapper().
20-Nov-2006
	- Jorrit changed the mingw building doc to use 'jam' by default
	  instead of 'make'.
18-Nov-2006
	- Marten fixed the SCF example in manual section 4.3.1.10.
17-Nov-2006
	- Marten fixed a bug in particles loader where the lincolor wouldn't
	  load alpha. Fixes trac #190.
16-Nov-2006
	- Jorrit fixed the 3D sound source implementation so that it now
	  also implements iSndSysSourceSoftware as it should.
15-Nov-2006
	- res fixed some deprecation warnings in walktest.
	- caedes added a check on csODECollider::CreateMeshGeometry, so it
	  doesnt crash if there is no collision polygon mesh on the object.
11-Nov-2006
	- Genjix corrected spelling mistake vfs.h and changed the years here.
10-Nov-2006
	- Jorrit again disabled techniques 150 for character2 and
	  character_bump2 since they are still giving problems:
	  	- Not working lighting on linux/ATI
		- Corrupted lighting on Intel Graphics
	- Jorrit changed iSndSysWrapper to keep track of iSndSysData
	  instead (but see later) of iSndSysStream. The idea is that
	  a sound object should only care about the sound data and
	  the stream should be created later. For compatibility
	  reasons a stream is still created however. All methods
	  taking care of streams in iSndSysWrapper are marked
	  deprecated. Also in iLoader the version of LoadSoundWrapper()
	  that takes a mode3d parameter is now deprecated as this
	  version creates a stream. Using the 'mode3d' attribute
	  in maps is now also deprecated.
9-Nov-2006
	- Eric Sunshine worked around problem in configure.ac caused by
	  unintentional side-effect of recent change to detect newer vs. older
	  X11 installations.  Autoconf delays performing certain tests until
	  the test is actually required. In this case, the CPP test was first
	  needed inside the "old" branch of the X11 check.  For machines with a
	  newer, modular X.org installation, this resulted in the CPP test
	  never being run. Fixed by adding an explicit and unconditional
	  AC_PROG_CPP invocation to configure.ac.
	- Marten added a preadvance option to particles xml-loader that allows
	  you to advance the particle system on load.
	- res fixed the perl bindings to compile again.
	- res fixed SetVertexCount in genmesh to not set all normals and 
	  colors to null but only those that were newly added.
8-Nov-2006
	- Erroroman changed bones indices render buffer type to ushort. Also 
	  changed indices type to short in all animation vertex shaders.
	- Erroroman made Cg skinning default again.
	- Erroroman dopted max animation exporter script to export ushort bones
	  indices.
	- Erroroman fixed speed problem in shader animation by changing bones 
	  indices type from ushort to short. Also fixed max exporter again.
7-Nov-2006
	- Eric Sunshine changed CS_CHECK_PROG_VERSION() in progver.m4 to export
	  shell variables `cs_prog_PROG_version' and `cs_prog_PROG_version_ok'
	  indicating the discovered version of PROG and whether the version
	  check succeeded, respectively. These variables are available to the
	  ACTION-IF-OKAY and ACTION-IF-NOT-OKAY code fragments.
	- Eric Sunshine clarified and further elaborated
	  CS_CHECK_PROG_VERSION() documentation.
	- Eric Sunshine augmented CS_CHECK_CSWIN32LIBS() in checkcswin32libs.m4
	  to export also the result of the new `cslibs-config --incpath' option
	  if available.
	- Eric Sunshine fixed r25803 bug in CS_CHECK_LIB_WITH() in checklib.m4
	  which resulted in exported variables being named incorrectly, thus
	  causing later tests and dependent code which relied upon those
	  variables to fail.
	- res augmented the particle system to allow manually advancing it
	  a given duration.
6-Nov-2006
	- caedes added some templates to swig interface files that allow
	  python bindings to declare python properties (they work for
	  external projects also).
	- caedes changed the python property wrappers interface file so it
	  can really be used from external projects. Also fixed commenting
	  a bit.
	- Eric Sunshine performed minor cleanup and normalization of
	  configure.ac.
5-Nov-2006
	- res worked around an apparent VC7 compiler bug causing trouble with
	  csArray: compiler-generated assignment operators seem to 
	  errorneously copy a single byte for empty classes.
	- res fixed shader variables and program parameters filled from
	  shader expressions to be forced to type VECTOR4.
	- Eric Sunshine fixed CS_CHECK_LIB_WITH() Autoconf macro
	  (mk/autoconf/checklib.m4) to generate valid shell variable names even
	  when the LIBRARY name contains "special" characters, such as hyphens,
	  periods, etc.  (A similar problem had been fixed for the ALIASES
	  argument of CS_CHECK_LIB_WITH() in SVN r19486, but that patch
	  neglected to address the issue for the LIBRARY argument.)
        - caedes made the following changes in swig interface files:
            - added iODEHinge2Joint to interface list.
            - added wrapping of csVector4, csImageBase and csImageMemory.
            - added an output typemap for csKeyModifiers, and list like
              interface to fetch the modifiers.
            - added extended python function GetValue for getting shadervar
              values as python objects.
            - added some ifdef so _csPyEventHandler does not get exported to
              other modules %importing cspace.i (so now theyre not required
              to declare it).
            - removed csPixmap %ignore declaration.
            - removed the _csPyEventHandler declaration from pycscegui.
3-Nov-2006
	- Jorrit fixed nullmesh factory so that it has a sensible
	  default bounding box (from -1,-1,-1 to 1,1,1). That prevents
	  crashes in the kdtree when people forget to initialize this.
	- Jorrit fixed nullmesh factory SetRadius() call so that it
	  actually calculates the bounding box correctly from the radius.
	- Jorrit worked around a very old problem with the kdtree when
	  it receives objects with empty or illegal bounding boxes. This
	  could cause assertion errors (i.e. leaf_replaced and such). The
	  work around simply tests for illegal bounding boxes and replaces
	  that box internally with a very small legal one.
	- caedes fixed an mistype in csgeom/vector4.h (csVector4 incorrectly
	  referenced from inside csVector4T).
	- res fixed a couple of VC7 errors and warnings.
	- res fixed a couple of gcc issues after the VC7 fixes.
1-Nov-2006
	- Genjix removed redundant ShapeChanged () calls in
	  iGeneralFactoryState::SetTriangle/VertexCount ().
30-Oct-2006
	- caedes added some %ignore directives in cspace.i to avoid wrapping
	  deprecated members from cspath.
	- caedes removed the exclusion of gmeshskel2.h from master headers,
          as the old conflicting gmeshskel.h is already gone.
	- res tweaked the CS_CHECK_LIB_WITH autoconf macro to fix the
	  m4_foreach invocations to not have an empty entry in the list if no
	  lib aliases were given. Apparently, earlier m4 versions skipped the
	  empty entry. Newer versions don't and caused weird checks for the
	  "empty lib" in configure.
	- res augmented vproc_std to deal with the absence of a "light 
	  position object" SV which is not provided by the standard render 
	  steps. Fixes occuring floating point exceptions and also probably
	  makes lighting actually work right.
	- res fixed some VC warnings.
	- caedes added gmeshkel2.h and skeleton.h interfaces to cspace.i.
29-Oct-2006
	- res changed scfFactory::IncRef() to always get the symbol for the
	  factory function after the plugin shared lib has been loaded. The
	  reasons is that the address of that symbol may change if the shared
	  lib happens to be unloaded in between attempts to get an instance
	  of the component.
	- res augmented the lightiter render step to provide a "light count"
	  SV with constant value 1. (This makes it possible to use vproc_std
	  with it.)
	- res fixed some crashes in the software renderer occuring when 
	  drawing without BeginDraw() being called (occurs when the engine 
	  does PrecacheDraw()).
	- res augmented the software shader plugin to also support 
	  multiplication by a constant color in addition to multiplication by 
	  the interpolated vertex color.
	- res added software renderer techniques to the ambient, light, 
	  light_spec_bumpmap shaders.
	- res made the light_bumpmap shader fall back to light.
	- res changed the "castle" level to have Z buffer clearing enabled
	  (needed for SR).
	- Eric Sunshine fixed a quoting problem in configure.ac which caused
	  X11 check to barf for old-style installations.
27-Oct-2006
	- res updated the docs for the new winlibs version.
	- Daniel Fryer added HasNext() to the Mac OS X "defaults" 
	  iConfigFileIterator implementation and also fixed the non-standard
	  behavior of returning a null iterator instead of an 
	  empty iterator.  
26-Oct-2006
	- Genjix added a flat 1px X 1px normalmap texture inside standard.zip
	- Jorrit fixed a problem with physics plugin. The iODEJointState
	  interface was defined wrong (GetLowStop() instead of GetLoStop()
	  for example) and also the odedynam plugin was no longer
	  implementing that interface.
	- res fixed the bullet plugin to build with somewhat newer bullet
	  versions.
25-Oct-2006
	- Jorrit fixed a bug in iSector->HitBeamPortals(). If it would
	  traverse a portal then the returned intersection point would not be
	  correct.
	- res adjusted the X11 detection such that the pkgconfig packages, as
	  provided by newer X.org versions, are looked for first before
	  falling back to the autoconf X detection macro.
24-Oct-2006
	- res bumped the version numbers for the CS and CEL version checks in
	  jamtemplate's configure template to 1.1.
	- res fixed install.jam to support file names with spaces.
	- res updated the "external libraries" section in the manual to also
	  state versions of the dependencies.
	- Vincent updated rpm/cs.spec. Also added missing files to be
	  installed.
23-Oct-2006
	- Jorrit fixed a bug in the skeletal animation loader. It would
	  incorrectly test if it could load the skeleton file and if it
	  couldn't load it it would not give an error.
	- res fixed the genmesh autonormals support to properly support 
	  submeshes.
	- res changed the genmesh saver to not write out triangles when
	  a factory has submeshes.
	- res added iGeneralFactoryState::DisableAutoNormals().
20-Oct-2006
	- PK fixed a small bug in the parallax shaders.
	- res added some issue reporting to the static plugin linking Jam
	  code.
	- res changed the python detection code to separately check whether 
	  the pythonX.X/config dir must be specified to link the python lib.
	  The reason is that this directory seems to contain a static library
	  which gets preferred over the shared version, however, this static
	  lib seems to work somewhat worse than the shared version. Hence,
	  adjust the lib dir search strategy such that a path with a shared
	  version is preferred.
18-Oct-2006
	- Jorrit forced the character2 shaders to use software animation
	  since that works better on all hardware and also is faster
	  in most cases.
	- Eric Sunshine updated CS manual to refer to new Trac bug database
	  rather than the deprecated SourceForge bug tracker. Also updated URL
	  in manual for browsing sources in SVN rather than CVS.
	- res removed some leftovers from the earlier "compatibilisms"
	  cleanup.
	- res changed the "Resources" manual page to point to the trac SVN
	  browser and not the SF one.
17-Oct-2006
	- Jorrit fixed a memory leak in the engine (with camera
	  positions).
	- res fixed a compile error in ptpdlight.
	- res fixed compile errors with memtracker enabled (fixes trac #135,
	  #173).
13-Oct-2006
	- mdmkolbe fixed a few warnings.
	- res changed ptpdlight to use fixed point math and to upload textures
	  as BGRA (faster on NV).
12-Oct-2006
	- mdmkolbe commited part of the Cygwin path patch forgotten before.
	- mdmkolbe added support for Cygwin mount points to VFS.
	- mdmkolbe forced vfs.cfg to always be regenerated on install
	  since they may be overridden at install time (e.g. using GNU stow)
	  and to prevent old "$(appdatadir)" and "$(appconfdir)" being used.
	- Jorrit changed the spiral particle system in partsys to use
	  the new particles plugin.
	- Jorrit removed the spiral mesh object plugin.
	- Jorrit fixed walktest for the removal of spiral. Simply removed
	  the spiral command. It isn't that useful.
	- res changed genmeshify to detect when a level name passed is a
	  directory.
11-Oct-2006
	- res fixed genmesh to also support Compress() when submeshes are
	  present.
	- res fixed csConfigIterator::Rewind() not working properly.
10-Oct-2006
	- mdmkolbe fixed searching of Cygwin paths.
	- mdmkolbe added CS_CONFIGDIR to configuration search paths on Cygwin.
	- Marten added a "outward spiral" term to spiral particle effector.
9-Oct-2006
	- res fixed a problem in the iConfigIterator::HasNext() which
	  manifested itself in scrambled "could not load plugin" messages
	  and subsequent crash on startup.
	- res updated the documentation transform script for the new site
	  search URL.
	- res slightly tweaked the API docs search box style.
	- Marten added a "velocity-field" particle effector.
8-Oct-2006
	- res added iConfigIterator::HasNext(), loosely based on a patch by
	  Timothy "kiolakin" Whitfield.
7-Oct-2006
	- Jorrit added a test to csPhysicalFile so that it no longer
	  succeeds on directories.
	- res fixed the font cache to more gracefully handle nested 
	  CacheGlyph() calls. Fixes trac #164.
	- res changed the reporter to avoid nested calls into listeners (ie
	  when Report() is called while being inside Report()) since that may
	  "confuse" the listeners and lead to weird side effects. Instead,
	  queue up messages that are reported while in the reporter.
6-Oct-2006
	- caedes added kwartz and castle to Jamfiles.
	- Marten added a RK45 ODE solver to be used in particle effector.
	- res slightly reworded the section on procedural textures. Also added
	  "performance hints".
	- res changed the genmesh loader and saver to also accept factory 
	  submeshes without a material.
5-Oct-2006
	- Marten changed win32 version resource generation so it strips
	  any RCxxx tags, appearantly they trip the mingw resource
	  compiler.
	- Erroroman changed render buffer "bones indices" elements type from
	  int to float because of slow hardware animation reported by people
	  that uses Windows and ATI video cards. Nvidia cards doesn't have
	  such problem so probably cases about driver problem.
	- Erroroman adopted kwartz model and the animation shaders to the new
	  type of the render buffer.
	- Erroroman improoved the script for exporting skeletal meshes from
	  3ds max (still not fully finished)and added some more info to 
	  the README file.
4-Oct-2006
	- Jorrit updated startme:
	    - Made the icons show from top to bottom.
	    - Removed particles and awstest demos.
	    - Changed screenshot for walktest to castle screenshot.
	- Marten hopefully fixed the particle "clumping" when emitting 
	  particles with velocity.
	- mdmkolbe eliminated improper reinterpret_cast calls with extreme
	  prejudice.  (Casting from a 'void*' should use static_cast.)
        - Piotr added angular constraint axis joint parameter which should
          be anchored to specyfied body (it lets angular stops to be effective
          when joint have free rotation along all axes in ode dynamics 
          implementation - "ball joint" limitation).
        - Piotr cleaned iODEJointState interface (it lets user to change ode
          specyfic parameters for joints made via iJoint interface).

3-Oct-2006
	- mdmkolbe fixed an uninitialized variable that broke procedural
	  textures on Cygwin.
	- Jorrit committed a new extrudeGlow shader from Anders Wisur.
	  Still experimental.
	- Jorrit added a few missing Jamfile's in the data/shader directory.
	- Jorrit changed all the attenuation based shaders (parallaxAtt,
	  specular, character, ...) to calculate attenuation a bit
	  differently so that the resulting lighting is brighter for the
	  same radius of the light. This makes the lighting intensity
	  more matched up with the lighting as calculated by the lightmapper.
	  Another benefit of this change is that it improves speed as
	  you can now reduce the light radius with same visual effect.
	- Jorrit reduces the light radius in castle level.
	- Marten fixed a corner case in csQuaternion::Exp and 
	  csQuaternion::Log as well as some accuracy and efficiency parts in
	  skeleton spline calculation.
	- Jorrit added a fallback for light_bumpmap to the light specular
	  shader. That means that parallaxAtt will also correctly fallback
	  to light_bumpmap if CG is not available or fails.
	- Marten fixed a bug in the shader manager which caused shader manager
	  (the global) SVs not to be properly pushed to the SV stack.
2-Oct-2006
	- res removed the resolution and windowed vs fullscreen message from
	  null3d.
	- Marten fixed csQuaternion::Exp and csQuaternion::Log to actually be
	  the exponential and logarithmic functions.
1-Oct-2006
	- res silenced more MSVC deprecation warnings.
	- res fixed some locals in CS::TriangleIndicesStream to use the 
	  template parameter.
	- res added iShaderVariableContext::RemoveVariable (csShaderVariable*).
	- caedes removed stdtex from data Jamfile.
30-Sep-2006
	- res fixed some MSVC warnings.
	- res fixed some wrong GL extension function declarations and added
	  the GL_EXT_packed_depth_stencil ext.
	- res changed scfImplementationPooled to use C++ cast operators and
	  the CS memory allocator.
	- res changed makeGLMatrix to optionally convert to a row-major 
	  matrix.
	- res changed the Cg plugin to define a preprocessor macro
	  PROGRAM_TYPE_FRAGMENT or PROGRAM_TYPE_VERTEX, depending on the type.
29-Sep-2006
	- res removed the following compatiblity hacks for older compilers
	  (which would likely not be able to cope with CS' use of advanced
	  C++ features anyway): 'typename_qualifier', fake 'explicit' 
	  keyword, CS_SPECIALIZE_TEMPLATE instead of template<>, 
	  CSARRAY_INHIBIT_TYPED_KEYS. Adresses trac #16.
	- Jorrit added a workaround for GetTuple() in windows so that
	  it at least compiles. MacOS/X is still broken and the GetTuple()
	  implementation in Windows just returns 0.
	- Jorrit changed flarge to use the new kwartz model. The kwartz
	  model is also updated to work nicely with software lighting.
	- Jorrit added kwartz model to isotest app. Unfortunatelly it is not
	  yet lit there though. Still have to check why.
	- Jorrit added textures from new castle level to CS. Castle level
	  will soon follow.
	- Jorrit merged stdtex.zip into standard.zip.
	- Jorrit added the indoor castle level from Anders Wisur to svn
	  and made it default.
	- Jorrit added license note to castle level and castle textures.
	  Castle uses Creative Commons NC:
	  http://creativecommons.org/licenses/by-nc/2.5
	- Jorrit made castle default level in walktest now.
	- Erroroman optimized character_bump2.cgvp by calculating bitangent
	  as cross product of normal and tangent. Also removed bitangent
	  from tehnique 150 in character_bump2.xml.
	- Jorrit added a 'arb128_limit' tag to gldrivers.xml and enabled
	  it for Intel Graphics. This tag means that the 3D card will
	  not support ARB assembly programs of more then 128 instructions.
	  The character2 shaders use this tag in the 150 technique (hardware
	  animation). This means that on Intel Graphics software animation
	  will be used.
	- Jorrit got a patch from res2k which makes sure that CG techniques
	  that generate programs that are too big for the card will really
	  fail now. That means that the workaround in gldrivers.xml is
	  no longer required.
	- Erroroman added more API docs in skeleton.h
28-Sep-2006
	- mdmkolbe changed walktest to exit with code 0 on normal exits.
	- mdmkolbe blind committed a change by Timothy "kiolakin" Whitfield
	  that will allow for skyboxes by letting each mesh specify its own
	  zbuffer mode.
	- mdmkolbe converted plugins/bugplug to the new SCF.
	- caedes added std_character2 and std_character_fixed2 shaders so
	  genmesh animation system can be used with standard lighting.
	- Erroroman added Log, Exp and Squad methods to csQuaternion.
	- Erroroman made spline rotatin of skeleton animation and 
	  improved a bit the skeleton the code. 
	- Erroroman added basic API docs to the skeleton interface.
	- res changed the Cg plugin to cache the profile of a program.
	- res devised an alternative workaround for corruption occuring on
	  ATI cards. Further investigation leads to that the corruption shows 
	  up after ARB programs are disabled; apparently this does not work 
	  correctly. A workaround is to change a fixed function state and call 
	  glBegin()/glEnd() without specifying any vertices. Hopefully helps
	  for trac #18.
27-Sep-2006
	- mdmkolbe enabled separate debug info by default on compatible
	  versions of Cygwin's binutils.
	- Jorrit removed the particles level after merging the particles
	  there with partsys.
	- Jorrit removed the fountain mesh object.
	- Jorrit removed csNewParticleSystem since this class is no longer
	  being used.
26-Sep-2006
	- Timothy Whitfield (kiokalin) fixed the paging former so that it
	  actually works now. It is also seamless.
	- Jorrit removed the fire particle system.
	- res disabled strict aliasing for wxgl and wxtest (some WX headers
	  cause aliasing warnings in optimize mode with gcc 4.1.1).
	- res committed a patch from <oh.hello.joe@gmail.com> to add a
	  driver DB entry to work around a crash on some old version of the
	  i810 DRI driver.
25-Sep-2006
	- Jorrit added the new kwartz.zip to vfs.
24-Sep-2006
        - Piotr did some tweaks to phystut app, now walls colliders should
          work better with ode engine.
	- Jorrit changed the flame command in walktest to use new particles.
	- Jorrit replaced the two fire particle systems in partsys
	  with new particles.
23-Sep-2006
	- Marten disabled global overridden malloc and free.
22-Sep-2006
	- Jorrit changed the built-in force effector for new particles so
	  that the random acceleration is now a vector. That means you can
	  get different magnitude for the random acceleration in x, y, and
	  z direction. This affects the method
	  iParticleBuiltinEffectorForce->SetRandomAcceleration().
	  The loader is also changed. The old syntax of using a single value
	  is still supported (and will automatically be interpreted as using
	  a vector with three identical values). If you specify x, y, and z
	  attributes in the <randomacceleration> tag then it will be
	  interpreted as a vector.
	- Jorrit fixed rain so that the particles start at the top and also
	  made sure that the time to live is exactly long enough for the
	  height of the current sector.
	- Jorrit changed the snow in partsys to use new particles.
	- Jorrit changed the snow in walktest (snow console command) to use
	  new particles.
	- Jorrit added documentation about converting snow to new particles.
	- Jorrit removed the old snow mesh object.
21-Sep-2006
	- Jorrit added a new section to the API mod doc which explains how
	  to convert old particle systems to the new particle system.
	  Only the explosion particle system is documented for now.
	- Jorrit removed the explosion particle system from CS.
	- Marten fixed the box emitter in the new particle system so that it
	  isn't double as big as it should be.
	- Jorrit converted the rain particle system in partsys and the
	  code in walktest to create rain to use the new particle system.
	- Jorrit removed the rain particle system and documented how to convert
	  from rain to new particles.
20-Sep-2006
	- Marten disabled the global overrides of operator new and operator
	  delete due to the interoperability problems it causes.
	- Marten fixed unit tests to compile and run, trac #85.
	- Marten fixed circular ref problem in particles, trac #143.
	- res changed the configure platform check to normalize powerpc* to
	  powerpc. Adresses trac #137.
	- res fixed the Cg shader plugin to also take compiler options from
	  the configuration when fragment program routing is used.
	- res added the definition of a preprocessor macro that contains the
	  fragment program version when compiling fragment progtams to the Cg
	  shader plugin.
19-Sep-2006
        - Genjix documented a little csIntersect3 behaviour.
18-Sep-2006
	- caedes changed cegui plugin name to cscegui.
	- Jorrit made csComparatorString safe with regards to null strings.
	  This is now needed since a recent fix in csHash is using this
	  comparator to compare keys and keys can sometimes be 0 (empty
	  string).
	- Jorrit fixed another bug in csString::GetHash(). This function
	  would also crash if the string was empty (i.e. null pointer).
	- Jorrit fixed a misplaced 'break' in ParseMixMode() of the syntax
	  services plugin. This would cause MESH mixmode to be interpreted
	  as ALPHATEST instead.
	- caedes fixed some warnings on cspace.i generation:
	  - instantiated iArrayReadOnly<iSceneNode*> using %template.
	  - %ignore ShaderVarName from csgfx/shadervar.h.
17-Sep-2006
	- res fixed a bug in the software renderer vertex transformer that
	  caused the output vertex buffers to be underfilled.
	- res updated a gldrivers tweak to include certain NV Quadro chips.
	- res updated a gldrivers tweak to include GF2 GTS chips.
	- Marten augmented SCF docs with some info about inheritance of
	  interfaces and implementations.
	- PK changed SimpVS to use CEGUI instead of AWS.
	- res added an overview of the shader system to the manual (based off
	  his conference talk).
16-Sep-2006
	- res declared the weak event listener functions as exported and put
	  them into the CS namespace.
	- res fixed shared library creation for cygwin with -mno-cygwin using
	  the solution from Peter Amstutz stated in trac #132.
	- Erroroman fixed a bit the new animation shaders.
	- PK upgraded the ice skin to work with CEGUI 5.0RC2.
	- PK improved the viewmesh standard dialog a little.
15-Sep-2006
	- Jorrit fixed viewmesh so that it starts at the current dir instead
	  of an internal CEGUI directory.
	- Erroroman did the following:
	  - added Update() function to genmesh animation interface. It is a
	    general update function that is not related to updating render
	    buffer data.
	  - updating bones mapping in gmeshskelanim2 is now in Update method.
	  - changted gmeshskelanim2 bones mapping data
	    - the buffer "bone data" that represents bone mapping is
	      replaced with 2 new render buffers:
	      "bones indices" - contains the indices of bones for the vertex.
	      "bones weights" - contains the weights of every bone.
	  - adopted vproc_std to access bones and handle skinned vertices.
	  - added new shaders for animating genmeshes - character2.xml and
	    character_bump2.xml.The new shaders provides 4 bones per vertex
	    mapping and software animation using vproc_std. The old shaders
	    will be removed after improving of the new ones.
	- res changed CS_DEPRECATED_TYPE to be useable on MSVC as well.
	- res fixed the doxygen settings to correctly handle the
	  CS_DEPRECATED_..._MSG macros.
	- res marked some types and methods that were deprecated as per the
	  API docs with the deprecation macros. Also changed some instances
	  to use the _MSG variant. Lastly, fixed some deprecation warnings.
	- res removed some unneeded members from csGraphics3DCaps.
	- res noted some compiler versions on the requirements manual page.
	- res updated the docs for the new cs-win32libs version.
	- res added -mno-cygwin support to configure.
12-Sep-2006
	- Jorrit fixed a bug with iSector->HitBeamPortals(). It was
	  broken and failed to detect the correct destination sector.
	- Marten fixed csColor4 for operators + - * and /.
	- Jorrit changed walktest to use new particles for explosion.
	- PK extended the ice-skin for tabbuttons.
11-Sep-2006
	- Marten fixed (hopefully) the script building (with Swig) on both
	  older swigs and for jobber.
	- Jorrit fixed a bug in particles and particlesldr. It would
	  initialize start time to -1 which caused particles to fail on
	  particle systems with very small duration.
	- Jorrit added a new system in the CS engine so that objects can have
	  themselves removed after a specific interval. Call
	  iEngine->DelayedRemoveObject() with an object (any object that can
	  be removed through the normal iEngine->RemoveObject()) and a delay.
	  This new system is more general then the old iEngine->WantToDie()
	  method that is called by some particle systems.
	- Jorrit added a commented out version of the explosion in walktest
	  using the new particle system. Doesn't yet work 100% (fading is
	  broken).
10-Sep-2006
	- PK changed ViewMesh to use CEGUI instead of AWS.
	- PK fixed a bug in csHash::Delete (const K& key, const T &value).
9-Sep-2006
	- Marten changed particles to have a transform-mode instead of just
	  a boolean localmode. This makes it possible to have world-space
	  particles with local space emitter.
8-Sep-2006
	- res added tests for some more GL types.
	- caedes updated cspace.i for the new particles.
	- res added some more GL extensions and missing GL versions up to 2.1
	  to the extension manager.
	- res fixed the glshader_fixed plugin to depend on GL 1.4 for texture
	  crossbar support and not 1.3.
	- res fixed a couple of gcc 4.1 optimize warnings.
	- res fixed _cspace.so.dbg being tried to be split off before
	  _cspace.so is built when installing. Fixes trac #11.
	- res added debug info splitting for the CS JNI library.
	- res changed ptpdlight to #include <limits.h> as per SFbug:1546141.
	- David Bronke fixed some warnings about unused variables and member
	  initialization order, and added const keyword to
	  csArray::Iterator::HasNext() and csArray::ConstIterator::HasNext().
6-Sep-2006
	- Jorrit fixed a bug in csGraphics2DOpenGL::SetMouseCursor().
	  It would assert (in debug mode) or crash (in release mode) in
	  case the iWin32Assistant was gone already. Instead of that it
	  now just does a test and returns false in case the assistant
	  is gone. That way stuff can reset the mouse cursor during
	  destruction of Crystal Space.
	- res fixed an issue with the Java bindings where symbols didn't get
	  exported properly from the JNI glue shared library due being hidden
	  by -fvisibility=hidden. Worked around that by also specifying
	  -fvisibility=default when compiling the JNI glue, causing the
	  symbols to get exported correctly again.
	- res disabled strict aliasing when compiling the Java JNI glue. This
	  fixes some issues in release builds.
	- res fixed some errors having crept into SimpleRoom.java when it was
	  updated to work with latest CS.
	- Marten made a small SWIG-tweak to shut up an error from newer
	  SWIG versions.
	- Marten made partconv not crash.
	- Marten converted nullmesh to new SCF syntax.
5-Sep-2006
	- res fixed the Java bindings to build again.
4-Sep-2006
	- res changed the configure program version check to support checking
	  the same program with different version numbers.
	- res separated the configure binutils recency check into it's own
	  macro.
	- res changed the --as-needed check to (a) only use --as-needed for
	  newer binutils versions (b) disable it by default.
2-Sep-2006
	- Marten fixed [ticket:7], invalid alpha modifier in shader
	  light.xml technique 150.
	- Marten rewrote the OpenGL pixel format picker to enumerate
	  all the values in strictly decreasing order. This should solve
	  ticket:1.
31-Aug-2006
	- Marten updated version numbers on trunk to reflect the fact that
	  the 1.0 branch have been created.
30-Aug-2006
	- Marten fixed csIntersect3::TriangleTriangle to return a correct
	  intersection line even for coplanar case. Also rewrote it a bit
	  for clarity.
	- res fixed a number of compile warnings and soft3d compilation
	  in optimize mode.
	- res added support for the --as-needed linker flag.
	- Erroroman fixed missing shader bump_attn.cgvp in r3dsmtest
29-Aug-2006
	- res changed the software renderer vertex processing to make it more
	  flexible. Though not pluggable, that'd be at least easier than
	  before.
	- res added portal near plane clipping to the software renderer.
	- res added some missing includes to trianglestream.h.
	- res worked around mixmode alpha not working in std_lighting on newer
	  NV hardware.
	- res added an option to link libgcc and libstdc++ statically to
	  configure.
	- res tweaked the Python detection such that the $sysprefix/lib path
	  is not always added as a library search path. This may cause issues
	  when the user manually specifies paths for some libraries, since
	  then the Python linker flags cause e.g. /usr/lib to be scanned and
	  libraries errorneously taken from there. Instead, only add
	  sysprefix-based paths when needed.
	- res added support for response files when shared libs are enabled.
	  They're used if supported by the linker.
	- res fixed some gcc warnings when compiling for shared libraries.
28-Aug-2006
        - Piotr added additional geom existence check in odedynam.
	- mdmkolbe added event-order constraints for standard console.
	- Marten reverted his csRefArray fix from yesterday as it introduced
	  more problems than it solved.
	- Jorrit fixed 'walkall' target so that it no longer attempts to
	  compile partphys_simple.
	- Jorrit added missing SCF_IMPLEMENT_FACTORY for the saver classes
	  in the particlesldr plugin. Without these it is impossible to
	  static link.
	- Jorrit removed it again since it doesn't seem to solve the problem
	  for some reason.
	- Jorrit removed the commented Saver section from
	  particlesldr.csplugin since even stuff inside XML comments is
	  considered for static linking (uses a simple sed expression).
	- res2k fixed a problem with static compilation and cleanup
	  of static variables (using CS_IMPLEMENT_STATIC_VAR_EXT and
	  related). The problem manifested itself if you use
	  DestroyApplication() and then after that initialize CS again.
27-Aug-2006
	- Fossi fixed the longstanding brute bug that kept materialmaps with
	  a size bigger than 512 pixels from working. Now these should work,
	  but they are still internally interpolated to 512 pixels.
	- Marten fixed csRefArray so that operator[] and Get (..) works
	  as intended and don't cause refcounting errors. Bug 1487132.
	- Marten fixed his last commit to work on gcc too. One caveat with
	  current approach is that you cannot assign directly from a
	  csRefArray::operator[] to a new csRef, you need to construct it
	  (provide an explicit construction). No inefficiency, just some extra
	  syntax.
26-Aug-2006
	- Vincent fixed apps/tools/Jamfile so that 'partconv' gets built. Also
	  made a few fixes to the particle mesh object manual page.
25-Aug-2006
	- res changed the logic used by glshader_cg to determine whether
	  routing is used or not. Instead of using routing all the time when
	  ARB_f_p is not available or disabled, non-routing profiles are
	  preferred, if these are available. Routing can be preferred by
	  choosing a maximum fragment program profile that is ps1_x.
24-Aug-2006
	- Jorrit fixed a serious bug in the generic renderloop code
	  with regards to light culling. This bug could cause flickering
	  and other bad artifacts.
	- Marten integrated newparticles branch revisions 24389-25212 into
	  trunk.
	- Marten added a note to apimod100 for new particles.
23-Aug-2006
	- Jorrit deprecated iObjectModel->GetObjectBoundingBox(csBox3).
	  Instead there is now iObjectModel->GetObjectBoundingBox() which
	  returns a reference to the box. This is more optimal and it is
	  better to use a return value anyway.
	- Jorrit changed standard diffuse renderloop so that it now culls
	  objects in object space (for lights). So the light center is
	  transformed into object space and then the object bounding
	  box is tested. This is faster (no need to transform the object
	  bounding box to world space) and also more accurate as we
	  are essentially testing against the OBB instead of the AABB (so
	  this should in some cases speed up lighting at runtime).
	- Jorrit added a new syntax for loading vertices and triangles
	  from genmesh. You can now say instead of:
	      <v x="1" y="2" z="2" u="3" v="4" nx="5" ny="7" nz="8"
	       red="9" green="10" blue="11" alpha="12" />
	      <v x="1" y="2" z="2" u="3" v="4" nx="5" ny="7" nz="8"
	       red="9" green="10" blue="11" alpha="12" />
	      <v x="1" y="2" z="2" u="3" v="4" nx="5" ny="7" nz="8"
	       red="9" green="10" blue="11" alpha="12" />
	      ...
	  the following:
	      <vertices format="vunc">
	      1 2 3 4 5 6 7 8 9 10 11 12
	      1 2 3 4 5 6 7 8 9 10 11 12
	      1 2 3 4 5 6 7 8 9 10 11 12
	      ...
	      </vertices>
	  Similar for triangles:
	      <t v1="1" v2="2" v3="3"/>
	      <t v1="1" v2="2" v3="3"/>
	      <t v1="1" v2="2" v3="3"/>
	      ...
	  becomes:
	      <triangles>
	      1 2 3
	      1 2 3
	      1 2 3
	      ...
	      </triangles>
	  This loads faster and is also a lot smaller (note: even better
	  would be the streaming loader).
	- Jorrit and Hristo worked a bit further on parallaxAtt. Technique
	  150 is now more correct and actually works on intel graphics now.
	  So that means that the intel graphics specific rule to forbid 150
	  can now be removed. Technique 130 is kept because it can work
	  on cards with only 4 texture units.
	- Jorrit fixed stencil2 plugin to compile again after latest
	  changes to GetObjectBoundingBox().
	- Hristo did some additional fixes on the specular shader.
22-Aug-2006
	- Jorrit fixed a bug with the new genmesh submesh system.
	  HitBeamObject() and HitBeamOutline() were broken because they
	  tested on the first triangle all the time.
	- Jorrit changed the standard renderloop object/light culler to
	  use bounding box instead of bounding radius (for the meshes).
	  While that is slightly slower to calculate it gives a much
	  more accurate test and thus a big speedup at runtime for the
	  lighting calculations. This also fixes visibility of particle
	  systems on maps using diffuse renderloop since apparently
	  the particle systems report a wrong bounding sphere but the
	  bounding box is correct.
	- Jorrit and Hristo did several changes to the parallaxAtt and
	  specular changes to get attenuation right. This makes levels
	  darker but it fixes flickering and provides the correct
	  attenuation results now. Also the priority 130 technique
	  has been replaced with a two-pass technique that does proper
	  attenuation.
21-Aug-2006
	- caedes added SCF_IMPLEMENT_FACTORY to movierecorder plugin.
	- res added a helper to iterate over triangles from an index buffer
	  (also supporting e.g. strips and quads).
	- res changed the software renderer to use aforementioned helper.
	- Jorrit fixed the bullet plugin so that it compiles again.
	- caedes added pythmod.jam file with a rule for building python
	  modules for crystalspace and made cspython use it.
	- caedes added tooltip skin to the ice cegui theme (only for 0.5+).
	- res made the xmlshader wrapper document properly keep track of node
	  parents.
20-Aug-2006
	- res added texture crossbar support to glshader_fixed.
	- res fixed an initialization bug in engseq.
	- res moved the dynamic ambient application in case of lightmapping
	  from code to shaders.
18-Aug-2006
        - res worked around some issues with wx in wxtest.
	- Jorrit augmented the iDynamicsCollisionCallback with a position
	  of collision, the normal of the collision and the penetration
	  depth.
	- res removed the legacy diffuse/ambient/reflection options from
	  iMaterial.
	- res made sectors be shader variable contexts as well. Fog and
	  dynamic ambient SVs are now provided by the sector itself. Also
	  streamlined csFog.
15-Aug-2006
	- res committed a patch from Timothy Whitfield <whitfieldts@gmail.com>
	  to add csBaseEventHandler::UnregisterQueue ().
14-Aug-2006
	- res changed the way libraries are handled by genmeshify: instead
	  of collecting them first and converting them after the main file
	  was converted they're now converted as encountered, as this seems
	  more robust.
	- res re-used the standard loader context from genmeshify to better
	  deal with "sloppy" maps that rely on the "try to load texture with
	  name" and "create material from texture with name" features.
	- res added the ability to override submesh materials in the mesh
	  object to genmesh.
	- res added a method to query material replacements from a Thing
	  object.
	- res added support for material replacements to genmeshify.
	- res fixed tangent + bitangent generation for genmeshes with
	  submeshes.
13-Aug-2006
	- res added CS_REQUEST_PLUGIN_TAG.
	- res made genmeshify use the document plexer plugin.
	- res made genmeshify properly handle the <settings> tag (fixes
	  conversion of maps with custom lightmap cell sizes).
12-Aug-2006
	- res changed ptpdlight to not just update the light map the next
	  frame after it's initially needed.
	- res fixed some flaws in ptpdlight.
	- res fixed genmeshify to always write a new factory for
	  hardtransformed meshes.
	- res added PD light support to genmeshify.
	- res fixed csRect::Extend() to truly ensure that the given point is
	  inside the rectangle (it didn't adhere to csRect's exclusivity of
	  xmax/ymax).
	- res fixed a crash when polygons from a polygonmesh of a genmesh with
	  submeshes are requested.
	- res csODECollider::CreateMeshGeometry() to use the polymesh
	  triangles directly instead of csPolygonMeshTools::Triangulate().
	- Jorrit fixed compilation of the DDS image loader.
	- Jorrit fixed compilation of walktest.
	- Vincent fixed compilation of a few apps with GCC (GNU/Linux).
	- res fixed some more XK_MISCELLANY warnings.
	- res changed the way the TinyXML classes are wrapped: instead of
	  defining a set of macros to change their classnames put them into
	  the CS namespace instead.
11-Aug-2006
	- mdmkolbe fixed some minor warnings.
	- mdmkolbe tweaked the signature of RemoveWeakListener.
	- mdmkolbe mass converted to RegisterWeakListener.
	- mdmkolbe fixed compilation problems in x2d and sdl2d due to the
	  RemoveWeakListener conversion of csGraphics2D.  Reported by vknecht.
	- res added the ability to query lightmaps for PD lights to Thing.
	- res fixed the proctex event handler to properly work across modules.
	- res renamed csgfx/memimage.h to csgfx/imagememory.h; this better
	  reflects the name of the class defined withing and is in line with
	  the other image-related image*.h headers.
	- res added a plugin namespace to the ptanimimg sources.
	- res fixed a potential crasher in ptanimimg.
	- res added a texture plugin for lightmaps that are affected by PD
	  lights.
10-Aug-2006
	- caedes changed CS_REQUEST_PLUGIN wrapper in pythpost.i so it works
	  also with interfaces provided by other python modules.
9-Aug-2006
	- Jorrit extended parallaxAtt with a technique at priority 130.
	  This technique is exactly the same as priority 150 but it
	  doesn't handle attenuation correctly. This is useful on
	  intel graphics hardware where the 150 technique is not working
	  properly.
	- Jorrit added a new 'crappyintelgraphics' config to gldrivers.xml.
	  This config will add a 'crappy_intel_graphics' tag so that
	  the technique 150 of parallaxAtt can disable itself.
	- caedes fixed a problem that would make the python tutorials fail.
	- mdmkolbe cleaned up miscellaneous warnings.
	- mdmkolbe added RegisterWeakListener and RemoveWeakListener to
	  handle registration and removal of event handlers that should
	  be proxied through a weak reference.
	- mdmkolbe converted libs/csplugincommon/canvas/graph2d.cpp and
	  plugins/engine/3d/engine.cpp to use RegisterWeakListener.
8-Aug-2006
	- res re-added support for triangle-based submeshes in genmesh objects
	  in order to provide backwards compatibility.
	- Jorrit renamed the type class in the old gmeshanim so that it no
	  longer conflicts with the new gmeshanim in static builds.
	- Jorrit fixed a problem in csEngineTools::FindScreenTarget(). If
	  the maximum distance was very large it wouldn't work very well
	  due to inaccuracy problems.
	- caedes moved all swig interface files to include/bindings.
7-Aug-2006
	- res added ability to convert referenced libraries to genmeshify.
	- Jorrit fixed a bug in the skeleton loader. It would return a
	  reference to a factory (as a csPtr) without doing an IncRef.
	  That would cause crashes at exit.
	- Jorrit also made the event handler in the skeleton graveyard
	  embedded to try to fix a leak there.
6-Aug-2006
	- Anders separated csHash iterators into const and non-const, like
	  csArray. This may lead to compile errors in user code. In most
	  cases the solution to these is to change "GlobalIterator" to
	  "ConstGlobalIterator".
	- Vincent made the following changes:
	    - Changed csInputDefinition::InitializeFromEvent() to get/set
	      changed axis number for both mouse and joystick. It will use the
	      first axis found that changed...
	    - Fixed csJoystickEventHelper::GetButtonState().
	    - Changed eventtest to get csInputDefinition constructed from
	      event, and to only print changed joystick axis value (not x/y).
	- res changed genmesh to preserve user-set poly meshes when switching
	  between "standard"/"submesh" poly meshes.
	- res added writing of of polymeshes to genmeshify.
5-Aug-2006
	- mdmkolbe removed a redundant check of do_infinite in walktest.
	- res added the iSelfDestruct interface to the csSaverFile,
	  csLibraryReference and csAddonReference so they can be removed from
	  regions.
	- res made cssynldr's WriteMixmode() output a bit nicer.
	- res made <move> tags written by cssaver's less redundant.
	- res made cssaver correctly write portal flags, warping and mirror
	  portals.
	- res fixed a flipped condition in the genmesh saver.
	- res made genmeshify's command line help a bit better.
	- res made genmeshify better support libraries.
	- res made genmeshify support Things created from factories.
	- mdmkolbe removed an outdated 'friend' declaration.
	- Vincent fixed joystick button string construction in inputdef.cpp,
	  which seem to need more work for parsing them correctly (mouseButton
	  vs. joystickButton)...
	- mdmkolbe eliminated a few embedded classes in genmesh and spr3d.
	- mdmkolbe reverted his change to genmesh and spr3d because there
	  was some weak referencing going on that he failed to notice
	  before that made the change incorrect.
4-Aug-2006
	- res fixed the default csRenderBufferLock<> storage to
	  iRenderBuffer*: it seems to be the rule rather than the exception
	  that a render buffer is valid while a lock is instantiated.
	- res split up csShaderVariableContext into
	  CS::ShaderVariableContextImpl, which contains an
	  iShaderVariableContext implementation but no SCF goop, and
	  csShaderVariableContext on top of that, which continues to be a full
	  SCF class. This way the simple iShaderVariableContext implementation
	  can be reused by other SCF classes without having to resort to
	  manual forwarding.
	- res changed iSyntaxService->ParseShaderVar() to also parse the
	  shader variable name.
	- res changed the genmesh submeshes to be accessed via an interface.
	- res added some initial support for per-submesh shader vars to
	  genmesh.
	- res tweaked the Cg shader framework to shuffle the primaryColor from
	  vertex to fragment programs with COLOR semantics.
	- Jorrit added an option to stdrep so that you can now specify
	  'silent' mode in a config file too ('Reporter.Silent').
	- Jorrit fixed stdrep so that the reading 'Reporter.AppendFile'
	  actually works now.
        - Jorrit fixed compilation of the python plugin (not linking,
          that's still broken due to -Wl,Symbolic flag) so that it compiles
          again.
	- res changed the way genmesh submeshes work. Now, meshobjects can't
	  contain completely custom submeshes; however, certain aspects of the
	  submesh as defined in the factory can be overridden (right now only
	  shader variables, but in the future probably at least materials and
	  mixmodes as well). Basically, you can't have different sets of
	  triangles in the mesh object.
	- res added methods to query lightmap-related data from Thing meshes.
	- res moved the lightmap-on-superlightmap texture coordinate
	  computation from the renderer(s) to the Thing plugin.
	- res added support for static lightmaps to genmeshify.
3-Aug-2006
	- Jorrit fixed a small problem which caused CS not to compile
	  in optimize mode.
2-Aug-2006
	- res added operator+= to csRenderBufferLock<>.
	- res fixed a stupid typo in the gmeshldr index buffer check.
	- res added proper object model support to genmeshes when submeshes
	  are used.
	- res changed csRenderBufferLock<> to lock/unlock on construction/
	  destruction, as opposed to checking for being locked and locking on
	  demand on every access. This is somewhat less overhead, and most
	  (if not all) of the current usage does not unlock a buffer in the
	  middle of some operations.
	- Jorrit fixed compilation of genmesh on gcc.
	- res changed the saver plugin to also expose the portal saving
	  method.
	- res changed iSceneNode to also return the children in an SCF array
	  (keep in mind, references to csArray<>s in interfaces are not safe).
	- res fixed an instance of a stack-based SCF object in thingldr.
	- res changed the csRenderBufferLock<> ++ and += operators to only
	  check whether the returned element is in range when it's really
	  used.
	- res added portal support to genmeshify.
1-Aug-2006
	- res changed the csRenderBufferLock pre-increment operator to return
	  the element after incrementation.
	- res added a post-increment operator to csRenderBufferLock, allowing
	  to iterate over render buffers pointer-style.
	- res changed the genmesh submesh support somewhat: now takes a render
	  buffer with indices instead of a pointer to a triangle array. Also
	  added some management methods - submeshes can be given a name,
	  enumerated, and selectively deleted.
	- res updated the genmesh loader to support index buffer specification
	  for genmeshes.
	- res added submesh saving to the genmesh saver.
	- res started work on genmeshify, a tool to convert Things in world
	  files to genmeshes.
	- res fixed genmesh's index buffer creation for submeshes.
	- res fixed genmesh's submesh class to properly copy itself.
	- res fixed cssynldr to correctly mark index buffers when writing
	  render buffers.
31-Jul-2006
	- Jorrit fixed compilation of xmlshader. It was using a wrong
	  CS_GNUC_PRINTF.
	- Jorrit added a new function csEngineTools::FindScreenTarget().
	  This function performs the commonly used operation of finding
	  the object that was clicked upon with the mouse. It can work
	  both in accurate mode (using iSector->HitBeamPortals) or
	  faster mode (using csColliderHelper::TraceBeam).
	- Jorrit changed WalkTest and BugPlug to use the new
	  FindScreenTarget() function.
30-Jul-2006
	- res added some comments to the new shader snippets.
	- res changed std_lighting_detail over to use Cg.
	- res added support for "unused" buffer bindings for VPs (ununsed
	  vertex attribs are not invalid but shouldn't be bound either).
	- Vincent added joystick support to eventtest. Needs more work for
	  correct reporting... Also changed inputdef.cpp assert to not choke
	  on joystick buttons Up/Down events, and print the faulty event name.
	- res added a bit of optional debug output to peek into the inner
	  workings of xmlshader's instruction processor.
	- res fixed conditional resource sharing in the Cg framework.
	- res improved passing of params with spaces and quotes to xmlshader
	  templates.
	- res updated the extension registry URL in the extension manager
	  docs.
	- res made it possible to disable all extensions by default, by
	  setting "Video.OpenGL.UseExtension.ALL = false".
	- res added a couple of configuration files to emulate certain
	  hardware. The idea is to use these with the new "configuration file
	  on command line" feature to easily emulate older HW, e.g. a GeForce3
	  by running an application with "-cfgfile=/config/emulate_gf3.cfg"
	  on the command line. Settings covered right now are basically just
	  those for Cg.
	- res added the ability to explicitly disable VP or FP support to the
	  Cg shader plugin.
29-Jul-2006
	- res augmented xmlshader to support template arguments with spaces.
	- res fixed an assertion in xmlshader when using buffer mappings with
	  custom variable names.
	- res fixed some assorted xmlshader issues.
	- res fixed the standard shader loading in the engine to conserve
	  whitespaces.
	- res added support for the TEXCOORD instruction to the glshader_ps1
	  PS1.x-to-1.4 converter.
	- res fixed compiler argument parsing for the glshader_cg plugin.
	- res updated the contained DejaVu fonts to version 2.8.
	- res started work to improve the shader snippets.
27-Jul-2006
	- res changed an array in glshader_ps1 that is never changed from
	  dynamic to compile-time creation.
	- res added some true static conditionals to xmlshader.
	- caedes changed the scattering shaders so they keep their nice
	  previous defaults while preserving xotic's changes.
25-Jul-2006
	- mdmkolbe converted the following plugins to the new SCF:
	    - plugins/physics/loader/
	    - plugins/culling/frustvis/
	    - plugins/engine/3d/
	    - plugins/engine/renderloop/
	    - plugins/sequence/
	- res reworked the "Mesa DRI DXT upload only" support.
	- res unmerged the changes from r24885:24886 ("res disabled
	  RTLD_GLOBAL for unix plugin loading again...") since the original
	  issue was solved in a different way. RTLD_GLOBAL is at least needed
	  for python as well.
	- mdmkolbe converted plugins/culling/dynavis/ to the new SCF.
	- David Bronke added a patch from contingencyplan (Brian DeVries) which
	  adds a copy constructor and an assignment operator to csVariant, which
	  allows it to be used in a csHash, among other things.
24-Jul-2006
	- Jorrit documented the new -cfgfile and -cfgset commandline
	  options and also added documentation for a few other commonly
	  used options.
	- Jorrit fixed a crash in the handling of the new -cfgfile
	  option. If you didn't use that option then applications would
	  crash.
23-Jul-2006
	- mdmkolbe converted the following plugins to the new SCF:
	    - plugins/csparser/
	    - plugins/documentsystem/
	    - plugins/proctex/standard/
	    - plugins/terraformer/
	    - plugins/reporter/
	- res added the ability to specify configuration settings via the
	  command line. Accepted are two new switches, -cfgset=<key=value>,
	  which adds a single setting to the configuration manager, and
	  -cfgfile=<file>, which adds a complete file to the configuration
	  manager.
	- res fixed a crash on VC due ptmalloc being shut down before some
	  global variables were destructed.
	- res fixed a destruction issue of xmlshader's TempString.
	- res augmented the shader conditionaly to support "weak templates"
	  which don't override existing templates of the same name.
	  Instruction is <?TemplateWeak ...?>.
	- res fixed xmlshader to correctly deal with sub-conditions of
	  conditions always being false.
	- res fixed a bug in the PS1.x to 1.4 where texture registers as the
	  destination were not handled correctly.
	- res enhanced the PS1.x to 1.4 converter to track register usage more
	  finely.
	- res added the ability to specify an upper cap for program profiles
	  to the Cg plugin.
	- res committed a patch from Gellule <gellule.xg@free.fr> to add
	  csStringBase::FindLast (const char*, size_t).
22-Jul-2006
	- Oktal fixed the order of some declaration qualifiers in spinlock.h;
	  CS_FORCEINLINE must come *before* the method's return type, at least
	  on gcc3. This is my first commit by SVN, so I hope it doesn't break.
	- res fixed the configure freetype check to not reference an internal
	  header (doesn't work with FreeType2.2 any more).
	- mdmkolbe applied a (modified) patch from res2k that fixes a crash
	  caused by the interaction between ptmalloc and Cygwin.
21-Jul-2006
	- res fixed an assertion triggered by csBaseEventHandler that could
	  occur when the destruction occured after
	  iEventQueue->RemoveAllListeners() was already called.
	- res fixed csEventHandlerRegistry::ReleaseID(iEventHandler*) to
	  not ignore the "refcount" of an ID (and thus prematurely releasing
	  an ID even though not all RegisterID() calls are balanced with a
	  ReleaseID() call).
	- res changed the CEGUI resource provider to use platform new (since
	  it sometimes is freed with the platform delete).
20-Jul-2006
	- Andres added the svn:eol-style property to all text files lacking
	  it (set to native). This is needed to have the eol set to the
	  native version of the platform (eg \r\n on win, \n on linux).
	  Without it eg. cross building and manual generation doesnt work
	  properly. All people adding new text files should look that the
	  property is set to native. (There is a mechanism called autoprops
	  which does this for you)
	- Jorrit added a section in the manual explaining several tricks
	  you can use to speed up map loading and runtime performance.
	- iceeey added "normal scale" shadervar to splatting_scattering.
	  This can be used to separately scale the normal texture on terrain.
	  When not specified, the "texture scale" is used by default.
	  The Marble material in 'terrain' level demonstrates this.
	- iceeey updated cegui plugin to work with CEGUI 0.5.0 while
	  retaining compatibility with older versions.
	- iceeey added a CEGUI 0.5.0 compatible version of the 'ice' skin which
	  ceguitest will use depending on which version of CEGUI you have.
	- res worked around a FreeType2.2.1 issue where it would return an
	  error when rendering an empty glyph (e.g SPACE).
19-Jul-2006
	- Jorrit simplified viewmesh a lot. It no longer attempts to do
	  any path handling automatically. So the ':' notation is gone
	  and it no longer attempts to automatically guess the VFS dir
	  to use as the current directory. Instead there are two new
	  commandline options:
	      -R: this option takes a real path and it will mount it to
	          /tmp/viewmesh. Then it makes that directory the current
		  directory.
	      -C: this option takes a VFS path and it will make that directory
	          the current directory. If this option is used together
		  with -R then you can change the VFS dir to be relative
		  to the location mounted with -R.
	  The filename itself will be used as-is.
	- Jorrit added a documentation section for viewmesh (under the new
	  'rule' that every new feature that is added to CS should now
	  be immediatelly documented :-)
	- Jorrit updated the documentation about Blender (removed the
	  mention of the obsolete old blend2cs tool).
	- Jorrit added a reference to the new ViewMesh documentation
	  from the overview.
17-Jul-2006
	- res changed csSpinLock to use a non-volatile pthread_mutex_t.
	- res applied a patch from Joerg Fischer to fix the offsets in
	  plugins/device/joystick/windows/dinputdefs.h.
12-Jul-2006
        - res added a check for the -Bsymbolic linker option to configure.
          This binds "references to global symbols to the definition within
          the shared library" (from man ld). If this flag is not set, it can
          happen that symbols in plugins get bound against symbols from other
          modules (including the application executable itself), causing
          side-effects such as violating the "memory allocation and freeing in
          the same module" rule.
	- res once more tweaked the objcopy version check to also work with
	  X.Y.Z style versions again.
11-Jul-2006
	- res fixed a crash in bugplug related to empty commands.
	- res augmented csPathLists to have a non-const operator[].
	- res fixed a crash bug in csPathsList when dealing with empty
	  paths.
10-Jul-2006
	- Jorrit fixed a fundamental problem with the engine sequence
	  manager and timed operations. This problem would cause timed
	  operations to remain in memory even after the sequence was
	  destroyed. The result was crashes when unloading maps using
	  these kinds of sequences. Fixed it by using the unique sequence_id
	  that is already assigned to engine sequences and attaching
	  that id to every timed operation in the engine sequence manager.
	  When the sequence wrapper is destroyed it will then remove
	  the timed operations.
	- res moved the "numbered filename" logic out of bugplug/movierecorder
	  into its own class, CS::NumberedFilenameHelper.
	- res fixed csImageMemory::Copy() to ensure that an image buffers
	  is available as well as converting the source image to the
	  format of the destination image.
	- res converted the movierecorder plugin to new SCF.
	- res added a helper for "uberscreenshots", to create screenshots
	  larger than the framebuffer resolution.
	- res tweaked the uberscreenshot helper to facilitate customization.
9-Jul-2006
        - res disabled RTLD_GLOBAL for unix plugin loading again, since it has
          undesireable side effects; for one, static libraries are suddenly
          not static anymore, as e.g. symbols may be taken from other plugins.
          Approached the original reason for adding this (DRI drivers failing
	  to load otherwise) by a workaround in glx2d: it now manually loads
	  libGL.so with the RTLD_GLOBAL flag. This is sufficient to make DRI
	  drivers happy.
	- res fixed a crash in the GL driver db when it was closed without
	  being opened.
	- res fixed XK_MISCELLANY redefined warnings.
8-Jul-2006
	- res changed the event handler ID registration. Since the handler
	  registry keeps a reference to registered handlers, handlers have to
	  be unregistered properly to ensure none are leaking. Changed GetID()
	  to not auto-register handlers; instead, RegisterID() has to be used
	  (where each call must be balanced with a call to ReleaseID() for
	  proper housekeeping).
	- res fixed some errors to not cause crashes any more.
	- res fixed apparently incorrect handling of the removal of a
	  currently called event handler.
7-Jul-2006
	- res fixed the engine default shader loading to not reuse the same
	  document, but create a new one instead. Fixes some crashing.
6-Jul-2006
	- res added the ability to override the default and portal shader with
	  config file settings (instead of being purely hardcoded in the
	  engine).
	- mdmkolbe converted the following plugins to the new SCF:
	    - plugins/csparser/prshtgen.cpp (other parts of csparser remain)
	    - plugins/console/
	    - plugins/bugplug/
	    - plugins/cssaver/
	    - plugins/collide/
	- res worked around a gcc 3.4 bug where __attribute__((always_inline))
	  is not always supported.
	- res augmented the CS python module building to also split debug info
	  off.
5-Jul-2006
	- Fossi made a small bugfix to the sequence manager header
	- res re-enabled the ATI "hidden NPOTS" support as it seems to be
	  supported properly with the latest drivers.
	- res added a gcc version of CS_FORCEINLINE.
	- res declared the overridden operator new etc. as forced inline.
	  This also seems to fix some issues with ptmalloc for external
	  projects.
	- res changed the aligned alloc functions to use ptmemalign if
	  ptmalloc is enabled.
4-Jul-2006
	- res fixed an issue in ptmalloc where one of dlmalloc's internal
	  structures would not be always initialized properly.
	- res completely converted engseq to new SCF.
3-Jul-2006
	- caedes corrected an error in the swig list wrapper extensions
	  that would make them unusable for wrapping interfaces in cel.
	- Philip Wyett fixed eliminated error when using 'alt-r' to start
          recording a movie with the movie recorder plugin. Plugin was
          starting and stopping and only recording one frame.
	- caedes added swig wrapper helper for csSet template, it allows
	  using len(set), set.append(id), a in set (test only), del set[id].
	  This introduces a new %define for extending csSet in language
	  specific ways. Only implemented for python but other languages can
	  implement their own extensions.
	- caedes declared csSet<csStringID> for wrapping in cspace.i.
	- mdmkolbe fixed a mistake in his previous commit.
	- res fixed the binutils version detection to also work with the
	  latest version (which reports "2.17").
	- res added a detection for __attribute__((visibility("hidden"))) to
	  configure (to complement the detection for default visibility).
	- res updated the doxygen stylesheets for doxygen 1.4.7.
2-Jul-2006
	- caedes added wrappers so cspace Lists (like iMeshList) can be used
	  as python lists where applicable. Allows search by index and name by
	  using [], also can iterate normally over their contents, and use
	  len(list) and list.append.
	- caedes added dummy templates for list wrapping to the java and perl
	  interface files.
	- caedes fixed or silenced most warnings on generation of python
          interfaces (tested on linux_x86, swig .24, and from .27 to .29):
	    - removed reference to cspoint.h (deprecated).
	    - silenced scfImplementation* warnings, now we can wrap this but
	      should not be done in all situations, the silenced warnings can
	      be controlled at include/ivaria/scf.i.
	    - declared csShaderVariable and csSprite2DVertex necessary array
	      templates.
	    - made some workaround for the situation where swig would need
	      directives in the middle of csutil/array.h to understand the
	      templated class hierachy.
	    - declare iSCF::SCF as immutable.
29-Jun-2006
	- res split csFixedSizeAllocator off csBlockAllocator, which only
	  allocates blocks of fixed size. csBlockAllocator now builds upon
	  csFixedSizeAllocator; handling of unfreed objects is now handled
	  via a template parameter.
	- Vincent fixed build error with gcc about extra semicolon.
	- Marten fixed some compilation errors introdu9ced by res recent
	  split of csBlockAllocator.
	- mdmkolbe fixed some of the event handlers in plugins/mesh so they
	  the listeners are only removed if they have already been added.
27-Jun-2006
        - Arianna fixed other warnings: size_t/int issues, mainly.
	- res took another jab at the operator new issues:
	    - Removed "static" again since that makes gcc complain (and wasn't
	      very clean either).
	    - Pragmatically implemented the platform-specific new by using
	      platform_malloc() instead of trying to employ trickery to use the
	      platform's default operator new.
	- caedes added initial interface code for the scfImplementation macros
	  to the swig wrappers (file ivaria/scf.i).
	- caedes made a workaround in cspace.i so python bindings can also be
	  generated using swig 1.3.28.
	- res renamed timemeasure.h to measuretime.h.
	- res split the CS::MeasureTime time printing code out into a separate
	  source file to avoid a warning in -ansi -pedantic.
25-Jun-2006
        - Piotr Obrzut added setting color feature for flare halo components.
	- res made CS' own overriding operator new/delete static to avoid
	  having them used by other object files.
	- res added operator new overloads to call the platform-specific
	  operator new.
	- res fixed sprcal3d to use those new overloads.
24-Jun-2006
	- Peter Amstutz deleted the vos plugin from the Crystal Space tree,
	  as it will now be maintained directly as part of the VOS tree.
	- Peter Amstutz modified the cs-config script to search for the
	  CS link libraries under several different possible names, so
	  as to support finding and linking with the shared library
	  version of libcrystalspace.
23-Jun-2006
	- res fixed spinlock.h compilation for Intel Macs.
	- res (blindly) fixed the core audio driver reinterpreting pointers
	  to 32bit values as strings which is problematic since quite a bit
	  of random data may appear before the saving null terminator.
	- res converted csconout to new SCF.
	- res changed csconout to use RGBA instead of RGB colors for
	  foreground/background/shadows.
	- caedes added floor operation to shader expressions.
	- Jorrit fixed csQuaternion::SetMatrix() so that gmeshskelanim2
	  again works correctly.
	- Marten reverted jorrits change to csQuaternion as it is wrong.
	  csQuaternion::SetMatrix was correct as it is, it must be
	  gmeshskelanim2 that is buggy. Please people, do not change the
	  basic math classes unless you know the maths there.
	- caedes fixed skeleton and gmeshskelanim2 to work again correctly
	  with the good quaternion math.
	- caedes added a more finished version of the ambient with additive
	  layer (pulse is still not handled totally correctly though).
	- caedes removed glow from parallax.xml and related files as its now
	  handled in a more general way in ambient.
	- caedes removed ambient2.xml and specifyambient.xml files as they
	  don't seem to have any useful difference with ambient.xml.
22-Jun-2006
        - Philip Wyett eliminated _POSIX_C_SOURCE redefinition warning in
          python plugin on GNU Linux with Python 2.3.
        - Philip Wyett continued changes to docs.
	- Jorrit fixed handling of the ':' in path names with viewmesh.
	- Jorrit fixed several problems in the genmeshanim2 plugin related
	  to the recent convertion to new SCF. The problem is that it is
	  unsafe to do this in a header:
	    virtual iBla* GetBla ()
	    {
	      return (iBla*) bla;
	    }
	  When the definition of 'bla' is not known this will cause the
	  cast to go wrong with bad results. To avoid this problem better
	  use static_cast<iBla*> so that the compiler can catch this.
	  The correct fix is then to not inline that method and put the
	  implementation in the cpp file instead.
20-Jun-2006
	- mdmkolbe converted the following plugins to the new SCF:
	    - plugins/mesh/lghtng/
	    - plugins/mesh/particles/
	    - plugins/mesh/genmesh/
	    - plugins/mesh/haze/
	    - plugins/mesh/terrain/
	- mdmkolbe made a few messages more informative.
	- mdmkolbe changed iEventHandlerRegistry so it doesn't
	  use csStrings in the interface.
        - Philip Wyett corrected a copy and paste error he made in documents.
        - Philip Wyett edited Jorrits genesis for the youngsters to let
          them know that comp.graphics.algoritms is a newsgroup.
	- mdmkolbe tweaked the previous message change for compatibility with
	  dialog boxes.
	- David H. Bronke fixed an error in libs/csutil/eventhandlers.cpp
	  where a const char* was being used as a csString.
	- David H. Bronke committed a patch by lindquist to fix the CEGUI plugin
	  for the latest SVN version of CEGUI.
	- David H. Bronke added a missing #include to include/iengine/sector.h.
	- res merged the ptmalloc branch.
	  The main change is that an implementation of ptmalloc3 is used as
	  the default memory allocator throughout CS (and also external
	  projects).
	  Use of ptmalloc can be disabled for the whole project by passing
	  --enable-ptmalloc=no to configure, or defining CS_NO_PTMALLOC in
	  include/csutil/win32/csconfig.h for MSVC.
	  The platform-default memory allocation can be access by using the
	  platform_malloc() etc. functions. CS' default allocator - ptmalloc3,
	  or the platform's default, depending on the users choice - can be
	  accessed by using cs_malloc() etc. All memory allocations in CS
	  itself should use the cs_ functions.
	  By default, malloc() etc. are overridden with the cs_malloc() etc.
	  functions. To disable that for individual source files, define
	  CS_NO_MALLOC_OVERRIDE	before including cssysdef.h.
	  Likewise, new and delete are overridden to use cs_malloc()/cs_free()
	  by default, this can be disabled by defining CS_NO_NEW_OVERRIDE
	  before including cssysdef.h. This is useful to interface with some
	  3rd party libraries that take ownership of pointers passed into the
	  library (and later attempt to free it with the default allocator).
19-Jun-2006
	- Philip Wyett made Quick Start more explanatory for the CS newcomers.
	- res changed csRectRegion to use a csArray<> for rectangle storage.
	- res fixed fallout from the csRectRegion change.
	- mdmkolbe converted the following plugins to the new SCF:
	    - plugins/mesh/bezier/
	    - plugins/mesh/fountain/
	    - plugins/mesh/skeleton/
	    - plugins/mesh/fire/
	    - plugins/mesh/snow/
	    - plugins/mesh/explo/
	    - plugins/mesh/rain/
	    - plugins/mesh/instmesh/
	    - plugins/mesh/spiral/
	    - plugins/mesh/spr2d/
	    - plugins/mesh/emit/
	- Jorrit fixed compilation of csGradient.
        - Philip Wyett continued docs cleanup.
        - Philip Wyett began adding more of the bundled CS applications with
          basic descriptions to the application overview section of the
          documentation.
	- res changed the configure optimization flag detection to try
	  -march=prescott before -march=i686 on Intel Macs.
	- res excluded the custom new enabling/disabling headers from the
	  master headers.
18-Jun-2006
        - Arianna fixed some warnings: size_t/uint conversions and some
          deprecated method.
	- mdmkolbe converted the remainder of of apps/ to the new SCF.
	- Eric Sunshine performed project-wide spelling corrections:
	    conveniance --> convenience
	    conveniant	--> convenient
	- res fixed spr2d's SetColor() to actually do something again.
	- res added convenience includes to disable/enable CS' 'new' and
	    'delete' overrides when the memtracker is enabled.
	- res added some missing custom new re-enablings.
	- res augmented the scfArray* classes with constructors that also take
	  and SCF parent argument.
	- res made an interface version iGradient of csGradient, so you can
	  pass them across plugins.
	- Philip Wyett changed his email address in docs. Changed 'written by'
	  to 'originally written by' for Windows related documentation as I
	  will no longer being working with the Windows codebase daily (as I
	  have not done for a long time) and will be concentrating on Linux.
	- Philip Wyett starts some maintenance work and changes to
	  documentation.
17-Jun-2006
        - Piotr Obrzut fixed phystut crash on exit problem (when running
          with bullet plugin)
        - Piotr Obrzut fixes bullet plugin unused parameter/variable warnings
	- mdmkolbe converted libs/csplugincommon/opengl to the new SCF.
16-Jun-2006
	- AndyDude fixed the MacOSX menu bug and launching in background bug.
	- AndyDude changed the non-error CoreAudio messages to be not so
	  'loud'. The two CoreAudio messages that I changed were Report()'d
	  at very high severity levels, when it wasn't really that severe.
	- res fixed msvcgen.jam to use the "common" directory to generate
	  the relative path for icon resources, not the version-specific one.
	- mdmkolbe fixed a few unused parameter warnings.
15-Jun-2006
	- thebolt fixed a bug in csQuaternion which caused matrix to
	  quaternion to go wrong.
	- Jorrit fixed a bug in genmesh GetRadius() function. This would
	  return the correct radius but an incorrect center (i.e. center
	  was always 0,0,0).
	- Jorrit (with the help of Erroroman) fixed
	  flat_ppl_attenuation.avp so that bumpmapping no longer flickers.
	  This fixes at least light_bumpmap technique 220. Not sure
	  about the others. The bug still appears present in case glow
	  is used however.
	- mdmkolbe brought the Java SWIG bindings a little closer to working.
14-Jun-2006
	- caedes fixed cspace.i for changes in spr2d.
	- caedes fixed cspython.cpp for dissaparition of evenhandler.h.
	- res fixed an apparent typo in aws2's gradient code.
	- res changed wxtest to also include wx.rc.
	- Jorrit did the following to csEngineTools::FindShortestDistance().
	    - It now returns the result in a csShortestDistanceResult
	      structure.
	    - In addition to the squared distance it now also returns
	      the direction to follow (starting from the source position)
	      which would make you end up at the destination. Usually
	      that will be equal to 'destination-source' but if there are
	      space warping portals involved then this can be different.
	    - Added an optional 'accurate' parameter so that the calculation
	      of the distance between the start point and the portal is
	      more accurate.
	    - Cleaned up the code considerably and also optimized it
	      slightly by using a csSet for visited sectors.
13-Jun-2006
	- Jorrit slightly optimized iEngine->GetNearbyMeshes() and related
	  by using a csSet for visited sectors instead of an array.
	- Jorrit removed the ugly sector iterator pool in the engine.
	  Also cleaned up the other iterators that are implemented
	  internally in engine.cpp.
	- Jorrit removed the unused csLightIt in the engine.
	- Jorrit implemented iEngine->GetNearbySectors().
	- Jorrit added a new version of iEngine->GetNearbySectors() that
	  accepts a box instead of a sphere.
	- Jorrit changed the csBox3 version of GetNearbyMeshes() and
	  GetNearbySectors() so that it actually tests if the portal
	  intersects with the given box. That way it makes the routine
	  more optimal by not traversing useless portals.
	- Jorrit cleaned up the GetNearbyBla() code in the engine a lot.
12-Jun-2006
	- Jorrit fixed the handling of 'ww' and 'wv' in space warping
	  portals. If 'ww' was specified before 'wv' then 'wv' would
	  overwrite whatever the user specified in 'ww'. This no longer
	  happens. If you don't specify 'ww' then 'wv' will still set
	  'ww' equal to 'wv' but not when 'ww' is already specified.
	- Jorrit converted iCameraSectorListener to new scf.
	- res changed the assert-in-assert handling to print the assert using
	  the runtime functions as opposed to CS functions again. Also
	  debug-break on first nested assert.
	- res updated spr2d to use new SCF.
	- res changed configure to apply -fvisibility=hidden not only to C++
	  but also to C sources.
	- res changed the spr2d to use an iArray instead of a csArray for the
	  "colored vertices".
	- res changed csShaderVariable::GetType() to call the accessor if a
	  value has not yet been set.
	- res converted iPortalCallback implementations to new SCF.
	- res fixed fixed cleaning of separate debug info.
11-Jun-2006
	- mdmkolbe factored into separate files parts of
	  plugins/video/render3d/software/pixspecifica.cpp that were
	  causing GCC to exhaust memory and crash.
	- mdmkolbe reduced header dependencies and fixed several warnings.
	- res converted csjoylin to new SCF.
	- res changed csShaderVarStack& to iShaderVarStack* in interfaces.
	- dfryer fixed a free() in glosx2d that made ptmalloc sad.  Also
	  fixed some OS X components with bad headers.
	- mdmkolbe fixed a few warnings and some SWIG errors.
10-Jun-2006
	- res added SCF interfaces for arrays.
	- Adam fixed a node-deletion bug in csPartialOrder, and added more
	  unit tests to boot.
9-Jun-2006
	- mdmkolbe fixed the following:
	  - several unused parameter warnings
	  - the CS_DEPRECATED_METHOD tag on iString::Clear()
	  - CS_PRId64 vs PRId64 in include/csutil/timemeasure.h
	    (Use the first for csPrintf and the second for printf.)
	- mdmkolbe fixed a suspected variable name typo.
	- Jorrit added support for strings to iSharedVariable.
	- Jorrit added std_rloop_standard.xml which corresponds to the
	  standard default renderloop as created internally by the engine.
	- Jorrit added support for conditional renderloops in a map file.
	  You can now say something like this:
		<renderloop variable="quality">
		    <condition value="low">std_rloop_standard</condition>
		    <condition value="high">std_rloop_shadowmap</condition>
		    <default>std_rloop_diffuse</default>
		</renderloop>
	  It will use the shared variable 'quality' to determine which
	  renderloop to select.
	- Jorrit fixed the engine renderloop commandline option so
	  that it actually works. Previously it would set a default
	  renderloop and later on it would be overwritten again by
	  the usual default renderloop.
	- mdmkolbe fixed overload ambiguity error in picView.
	- mdmkolbe removed unneeded includes from:
	  - include/csgeom/math3d.h
	  - include/iutil/event.h
	  - include/csutil/comparator.h
	  - include/csutil/sysfunc.h
	  Files that assumed these headers included things such as csstring.h
	  and util.h were corrected.
	- Jorrit fixed a compile error in tinypars.cpp after the removal
	  of several includes.
8-Jun-2006
	- Andres added a stupid filter to the annotation facility to filter
	  obvious spam.
	- Jorrit added new versions of iSector->HitBeamPortals() and
	  iSector->HitBeam() which return their results in a
	  csSectorHitBeamResult class instead of through their parameters.
	  That is more friendly for python, java, perl, ...
	- Jorrit extended iSector->HitBeamPortals() so that it also returns
	  the last sector we entered.
	- Jorrit fixed a bug in the new iSector->HitBeamPortals() with
	  regards to the final_sector.
	- Jorrit added updated ambient shader from Erroroman/caedes which
	  adds support for glow.
	- Jorrit added new parallaxAtt shader from Erroroman.
	- res changed "CS_STRICT_ALIGNMENT" from being defined on all but x86
	  processors to be only defined on Sparc (where it was originally
	  needed).
	- res fixed the GL renderer to repack csRGBcolor to an RGB bytestream
	  on platforms that need it.
	- Rhad added more robust error handling to the ALSA sound driver.
	  This should correct some cases where the sound device was entering
	  a bad state and never coming out when an underbuffer condition
	  occurred.
	- AndyDude fixed the url to demodata.zip to be the recent one.
7-Jun-2006
	- mdmkolbe made "separate debug info" default to disabled by default
	  on Cygwin.  All released binutils to date have a bug in them which
	  corrupts the output files when using separate debug info on Cygwin.
	  See <http://www.mail-archive.com/bug-binutils@gnu.org/msg00687.html>.
6-Jun-2006
	- Vincent fixed leak-guard enabled build.
	- Eric Sunshine added missing #include <new> to csutil/radixsort.h.
5-Jun-2006
	- res fixed createproject.sh to not copy cs_check_host.m4 any more
	  (since it has moved).
	- res fixed the Jam project template to utilize include custom.cslib.
	- res changed the "separate debug info" and "optimize mode debug info"
	  configure options to more appropriately use --enable-... instead of
	  --with-...
	- Marten fixed the interface and scfImplementation lines for sound
	  sources.
	- AndyDude fixed further spelling mistakes in (xmlfmt.txi).
4-Jun-2006
	- Marten made another fix to the quaternion class. Matrix->Quat->
	  Matrix seems to yield the original matrix (within tolerable
	  errors) for all tested matrices now.
	- DaveG fixed csKeyEventHelper to initialize passed csKeyModifiers&
	  to 0 when converting from a bit mask, to prevent undefined mods.
	- iceeey worked more on the 'ice' CEGUI skin. It should be fairly
	  complete now.
	- Rhad changed csLoader::LoadSoundSysData() so that it creates the
	  iSndSysData object with the filename as the description.
	- mdmkolbe fixed Java detection under Cygwin.
3-Jun-2006
	- iceeey made some more changes to 'ice' CEGUI skin.
	- Rhad updated the windows software sound driver (directsound)
	  so that it should better detect and respond to underbuffer
	  conditions.
2-Jun-2006
	- res fixed compilation of glshader_ps1 on gcc 3.3.
	- Jorrit fixed two errors in the documentation as reported
	  by schorsch_76 on the forums.
	- iceeey added example of handling a CEGUI event to ceguitest.
	- iceeey made various changes to the 'ice' CEGUI skin -- work
	  in progress.
	- AndyDude fixed the 'glosx2d' plugin to get proper bit-depth info.
1-Jun-2006
	- Jorrit fixed a bug in csMeshOnTexture where it would add the
	  begindraw flags from the engine and this would prevent the
	  persistent flag from working.
	- res fixed building with gcc 4.1.1 on AMD64 by adding utilizing
	  the -fPIC flag when testing for -shared.
	- AndyDude fixed spelling mistakes in my additions (xmlfmt.txi).
31-May-2006
	- res tweaked the Thing lightmap loader to use a block allocator
	  instead of a pool for the lightmap buffers.
	- Marten fixed the quaternion class. The woman in flarge now looks
	  normal, or at least as normal as before.
30-May-2006
	- res improved the debug facilities for the ATI_fragment_shader
	  support in glshader_ps1.
	- res changed glshader_ps1 to use a plugin namespace.
	- res fixed the software canvases to properly flip alpha component
	  of colors again before before doing alpha-blended 2D ops.
	- res changed the Thing lightmap loading to do somewhat less memory
	  allocations.
29-May-2006
	- Jorrit mentioned the new location of Cal3d (gna.org) in the
	  manual.
	- Jorrit fixed a big performance problem in the opcode plugin.
	  In some cases (i.e. flat surfaces) it would fall into a very
	  bad loop when initialization colliders. This badly affected
	  terrain since that is now initialization colliders constantly.
	  Performance when moving on one particular spot in a test
	  level I got went up from 0.2 to 23 fps.
	- res fixed the software canvases to not strip the alpha component
	  off colors before before doing alpha-blended 2D ops.
	- res changed the Win32 custom cursor code to only create cursors with
	  an alpha channel when the color depth is at least 24bpp.
	- res tweaked dsplex to not recursively use itself in all cases.
	- res tweaked the TGA loader to reject unusually large images. (TGAs
	  don't have a "magic" file identifier, so it can happen that some
	  random file is interpreted as a TGA image. So some heuristics to
	  reject bogus "images" are needed.)
	- res fixed a crash in the ddraw2d plugin when switching the double
	  buffer mode while in a BeginDraw()/EndDraw().
	- res changed fontplex to also use any available font server
	  automatically and not just those explicitly specified by the user.
	  This behaviour is more like the other multiplexers.
	- res changed picview so it really starts on the first file on startup
	  and also skips over directories properly when seeking the next/prev
	  image.
	- res added a picview.cfg.
	- res removed support for per-pass SVs from xmlshader.
28-May-2006
	- Jorrit copied some documentation out of the wiki into CS.
	  Documentation contributed by 'adu'. He added the 'sounds'
	  and 'variables' section to the XML map format documentation.
	- Jorrit made stdrep more robust so it no longer crashes
	  with empty lines. Apparently a SplitString() can return 0
	  strings.
	- Jorrit fixed bugplug so that it no longer outputs a useless
	  empty string.
	- Jorrit updated the features section in the manual a bit.
	- res added material emission support to glshader_fixed. Closes bug
	  (should've really been an RFE) #1396182.
	- res reworded, reordered and somewhat compacted the feature list.
	- Jorrit completed the portal container documentation.
	- res changed iSyntaxService to let the various Write*() methods take
	  const refs instead of pointers of the values to write.
	- res moved cssynldr to new SCF.
27-May-2006
	- res fixed the delimIgnoreDifferent mode for
	  csStringArray::SplitString() to work as it should.
	- res changed dsplex to new SCF.
	- res changed dsplex to try each document system only once when
	  parsing a document. This fixes the redundancy in error messages.
	- res changed stdrep to show alert windows before splitting a message
	  into multiple lines (so only one alert is visible per message and
	  not one per line of the message).
	- res changed csVariant to store strings in iString*s rather than
	  char*s, as outlined in bug #1388079.
26-May-2006
        - dfryer rearranged bitarray.h to avoid an ICE in Apple's gcc 3.3
          build
25-May-2006
	- res removed the now-useless WinCVS tutorial from the manual.
	- res changed some references to CVS in the manual to SVN and also
	  updated some CVS-specific parts.
	- res changed the jobber config to pass the 'quiet' flags to svn
	  invocations.
	- res changed the Win32 -[no]console stuff to respect user-specified
	  redirects of the standard handles.
24-May-2006
	- res changed the memory tracking to record function names, not
	  file names.
	- res changed csHash<> so that it truly takes no memory when it's
	  empty.
	- res changed a couple of interfaces in shader.h to use virtual
	  inheritance.
	- res renamed csBitArrayHashComputer<> to csHashComputerBitArray<>.
	- res added csBlockAllocator<>::FreeUninit() as a counterpart to
	  csBlockAllocator<>::AllocUninit().
	- res added CS::Memory::Heap which implements a separate memory heap
	  (based on dlmalloc). If used properly, a separate heap can
	  significantly reduce fragmentation of the main application heap in
	  case a lot of temporary mixed with non-temporary data is allocated.
	- res made xmlshader more memory-friendly for shaders with lots of
	  different variants.
	- Jorrit fixed csHash so it compiles again.
	- Jorrit did an optimization in genmesh lighting in case
	  --fullbright is selected.
	- Marten made a whole bunch of changes:
	    - Added methods to csOBB to access the base matrix.
	    - Rewrote csQuaternion a bit to make it more efficient and easier
	      to use.
	    - Added a "UnitAxisClamped" which returns an unit-length
	      axis-clamped version of a vector.
	    - Added currentFrame number to iMeshObject::NextFrame and updated
	      all mesh objects for the change.
	    - Force csQsqrt/csQisqrt to be inlined.
	    - Added one more version of CS::ForEach to work on normal arrays
	      instead of iterators.
	    - Added a number of public typedefs to the standard containers to
	      allow easier access of template parameters.
	    - Added a csRandomVectorGen which generates a spherically uniform
	      unit-length random vector.
	    - Small bugfix in GL-renderer buffer handling.
	- Jorrit fixed particles so that it compiles again after the
	  changes of Marten.
	- res fixed xmlshader to compile on gcc again.
	- res fixed the xmlshader bug where programs in auxiliary files (ie
	  included via a file attribute) did not work properly in some cases.
	  The problem was that conditions in that file did not contribute to
	  the main condition tree, ie a appeared that condition in an
	  auxiliary file but not the main shader file would not lead to more
	  variants. Fixed by also parsing auxiliary files for conditions and
	  adding those to the main condition tree.
	- res fixed the double-typedefintion of csArray<>::ElementHandler et
	  al.
        - acraig re-added the changes to the sprcal3d plugin to fix the
          flipping of left and right on models.
23-May-2006
	- res fixed bugplug to properly accept commands via keys again.
        - acraig made iGenMeshAnimationControl virtually inherrit from iBase.
22-May-2006
	- res fixed SubDir rules in the aws & aws2 Jamfiles after their move
	  to plugins/gui/.
	- Jorrit added a new iMissingLoaderData interface. Applications can
	  implement this and give it to the loader. The loader will then
	  call functions in case it can't find some sector, light, texture,
	  shader, material, sector, mesh, or factory. This can be used for
	  loader managing purposes.
21-May-2006
        - res changed the unresolved symbol reporting to (just) warnings.
        - res fixed the xwin linking issues.
	- res updated bindoc to use new SCF.
	- res augmented bugplug to allow programmatic command execution (and
	  not just via user input). Added new "bugplugcmd" command to
	  walktest.
	- res renamed csMeasureTime to CS::MeasureTime and changed it to use
	  csGetMicroTicks().
	- res augmented csHash to allow specification of an allocator.
	- res changed Memory::LocalBufferAllocator to have a templated
	  fallback allocator. Also improved detection of errorneous usage.
	- res added a csArray constructor that allows custom initialization of
	  the allocator.
	- res fixed gcc 3.4 compile errors after the array.h change.
	- res fixed some gcc compile warnings.
	- res moved AWS and AWS2 to plugins/gui/.
19-May-2006
        - res made the separate debug info and optimize mode debug info
          features toggleable via configure switches.
	- res changed separate debug info only to be enabled by default
	  when binutils >= 2.16 are present.
	- res changed the optimize mode debug info to only be enabled by
	  default when separate debug info is enabled (since otherwise
	  optimize mode binaries would get undesireably large).
17-May-2006
	- res fixed a couple of bindoc endianness bloopers, with the help of
	  dfryer, who acted as the remote debugger.
	- res augmented the memory tracker to also count the number of
	  allocation/deallocation calls.
	- res made a couple of look-up tables and generally read-only values
	  'const'.
16-May-2006
	- caedes added gmeshskelanim2 plugin and related shaders from
	  Erroroman. Also goes with some updates for skeleton code.
	- caedes added Jam files for the shadowmap shader folder.
	- Christopher added a Vfs object to AWS2, added several widgets,
	  finalizers for all native objects, clipping for child objects,
	  fixed the two layout mechanisms currently extant, fixed all
	  widgets to compile properly when created directly or through XML,
	  added a ListBox, a FileChooser widget, and is working on a ComboBox
	  widget.
	  He also added several icons to the AWS data file to help make the
	  FileChooser pretty.
	- Fossi also added terrainp to the vfs template as pointed out by eric
15-May-2006
	- Jorrit got a new bush from Jason Bonham and added it to
	  terrainf. Also made the lib files more standalone.
14-May-2006
	- Piotr Obrzut aplies patch from Lak_Moore: added check for
          valid references to 3D and 2D graphics plugins to
          csReporterListener::HandleEvent before trying to use them.
          Useful for console applications using the Standard Reporter
          plugin.
	- Philip Wyett added entries for Cal3D and lib3ds to external
	  libraries section of manual.
	- res fixed building of aws and the CEGUI stuff with memtracker
	  enabled.
	- res changed csBlockAllocator to disallow assignments and copy-
	  constructing.
	- res added a proper copy ctor for csSubRectangles.
	- res removed some static variables from csEngine.
	- res fixed shared lib linking on unix.
	- res added stripping of debug info to separate files when building
	  with a GNU toolchain.
	- res enabled debug info for optimized builds when building with a
	  GNU toolchain.
13-May-2006
	- Fossi added new compile output to .cvsignore.
	- Fossi added new paging terrain version and 'terrainp' testlevel.
	- res fixed a cut'n'paste error in the GLU check.
	- res fixed some missing symbol issues with Win32 shared lib builds.
	- res unified the allocators for classes that support custom memory
	  allocation (csArray, csBitArray, csBlockAllocator, csCowWrapper).
	  As a collateral, moved some functionality from the array memory
	  handler to the array element handler which more correctly belong
	  to the latter.
	- Adam updated the signpost event handlers to force full order even
	  when they are only partially instantiated.  Also added by-name
          GetID interface to iEventHandlerRegistry.
	- Adam added a method to csPartialOrder to query an edge's presence.
	- Adam added code to enforce ":pre"-then-":post" metahandler ordering
	  and cleaned up some debug output blocks.
	- Adam implemented an (incomplete) unit test for csEventQueue.
	- Adam converted bugplug to (partially) use a signpost event handler.
12-May-2006
	- Adam implemented an (incomplete) unit test for csPartialOrder.
9-May-2006
	- Jorrit fixed a bug in walktest with the 'doSave' variable.
	  First the 'doSave' variable was not initialized. Secondly
	  in the function that reads the config and commandline a local
	  'doSave' variable was used so that the real 'doSave' was
	  never set.
	- Jorrit changed the genmesh loader so that it now tests if
	  the number of vertices and triangles given matches the actual
	  number of vertices and triangles. This test shows that
	  blender2crystal occasionally doubles the number of vertices
	  in <numvt> without actually giving that many vertices.
	- Jorrit fixed the genmeshes in terrainf so that the number
	  of vertices is correct.
	- Jorrit fixed the haze mesh so that the
	  iMeshObject->SetMaterialWrapper() now works correctly. This
	  fixes a problem in partsys level.
	- Jorrit fixed instmesh in a similar way as a recent genmesh
	  fix with relation to GetFactory() from the mesh object.
8-May-2006
	- Jorrit restored the genmesh version of terrainf since that one
	  works better.
	- Jorrit fixed alpha fading in meshgen.
	- Jorrit reverted an optimization which only recalculates
	  the foliage density when the camera moves on x/z plane.
	- caedes uploaded correct bump.cgvp for light_spec_bumpamp from
	  Erroroman.
	- Jorrit added a forest to terrainf.
	- Jorrit fixed the mesh generator so that it correctly fades
	  hierarchical meshes.
7-May-2006
        - Reed updated csvosa3dl for CS API changes, tweaked some log messages,
          added some useful accessors.
	- Jorrit added a missing %ignore for iGraphics3D::PerformExtensionV()
	  so that the python plugin builds properly on 64-bit machines.
	- Eric Sunshine applied more fixes to the new jobber-svn.pl and
	  jobber-svn.cfg.
	- res made updates for the new cs-win32libs.
	- res augmented the cube map loader to also allow side image
	  specification via "posx", "negx" etc. tags, which might be more
	  intuitive than "north", "south" etc. tags in some cases.
	- res fixed some VC warnings.
	- res simplified and prettified some code in the shadowmap render
	  step.
6-May-2006
	- Eric Sunshine fixed several problems and issues with jobber-svn.pl
	  and jobber-svn.cfg; and also re-generalized them a bit
	- Eric Sunshine fixed resource leak in AWS2.
	- Jorrit fixed several mesh loaders so that they better test for
	  error conditions: genmesh, haze, instmesh, nullmesh, particles,
	  protomesh, spr2d, and terrain.
	- Errroman fixed a small bug in render to cubemap face.
	- Erroroman added another rendering tehnique in shadowmap.xml.
	- Erroroman added abillity light shadervars to override shader manager
	  shadervars in generic render step.
	- Erroroman fixed light_spec_bumpamp shader and added attenuation
	  support in it.
	- Erroroman added r3dsmtest in vfs.cfg.template.
5-May-2006
	- Jorrit started work on more detailed mesh object documentation.
	- Jorrit updated the genmesh documentation a bit more.
	- Jorrit replaced several @@@ tags in the public headers with
	  proper \todo tags.
	- Jorrit removed the unused csPoly2DEdges class.
	- Jorrit changed csArray::DeleteRange() to return false in case
	  of invalid arguments.
	- Jorrit removed iSector->RegisterPortalMesh() and
	  UnregisterPortalMesh() from the public api.
	- Jorrit removed a few unneeded '@@@' in the sources.
	- Jorrit added iMeshObjectFactory->SetMaterialWrapper(),
	  GetMaterialWrapper(), GetMixMode(), and SetMixMode().
	- Jorrit removed SetMaterialWrapper(), SetMixMode() and related from:
	    - iGeneralFactoryState
	    - iHazeFactoryState
	    - iInstancingFactoryState
	    - iLightningFactoryState
	    - iSprite2DFactoryState
	    - iSprite3DFactoryState
	    - iThingFactoryState (only mixmode stuff)
	  Added a note about this to the apimod document.
	- Jorrit removed the above functions also from iRainState.
	- Jorrit fixed the very ad-hoc code in the loader to set the
	  material on a factory in a generic way. This code only worked
	  for 3D sprites. Now it works for all factories that support
	  SetMaterialWrapper().
	- Jorrit fixed cssaver for latest changes.
	- res fixed configure to check for GLU again (needed by some 3rd party
	  libs).
	- JTarbox fixed the copy constructor for csEvents
	- JTarbox fix for the fix to the copy ctor of csEvents
	- Jorrit fixed a few apps for the latest changes.
	- Christopher changed the API of iAwsScriptObject to be a little easier
	  to use (I hope), and added an Exec() call.  He also moved picview
	  over to AWS2.
	- Christopher enhanced picview by having it actually tell you what it's
	  doing.  While some may feel that this is a radical paradigm shift, he
	  felt that taking the plunge was really worthwhile, and that everyone
	  will be better off for it eventually.
4-May-2006
	- Erroroman made the following:
	    - Generic render step now handles light shader variables.
	    - Lightiter render step shader variable for light world
	      inverse transform.
	    - Added param "subtexture" to iGraphics3D->SetRenderTarget,
	      that is used if texture is cubemap.
	    - Added crystalspace.renderloop.step.shadowmap interface. It
	      renders each direction to cubemap face. This is very usefull
	      for point lights. In future it will provide rendering to 2D
	      (depth) texture for spot lights. There are problems when
	      rendering from light position - sometimes vis culler doesn't
	      render some objects and their shadows are not visible/correct.
	    - Added distance and shadowmap Cg shaders. At the moment there
	      is no depth texture support and depth coding/encoding is
	      made by fragment shaders, so fragment program support is
	      neccessary.
	    - Added r3dsmtest level.
	    - Added std_rloop_shadowmap.xml renderloop.
	- Jorrit fixed the new parameter in SetRenderTarget() so that it
	  comes at the end. This is more compatible with CEL and
	  other external projects and also fixes several cases in CS
	  where the new parameter was not accounted for.
3-May-2006
        - res removed the CS_*_CAST macros. It is unlikely that a compiler
          can grok CS' use of templates but does not get the cast operators
          right.
	- res fixed some more "no virtual dtor" warnings.
	- Peter Amstutz added a try/catch block in material setup
	  in the VOS plugin to handle some exceptional conditions that
	  would cause meshes to not be assigned any material at all.
	- Jorrit did some small improvements to the engine API ref
	  documentation.
	- Jorrit removed the old and unmaintained map2cs. You can still
	  retrieve it using the PRE_MAP2CS_REMOVAL tag. To convert map files
	  there is now a better alternative at:
	      http://www-poleia.lip6.fr/~degris/converter/
	- Jorrit updated the SCF documentation so that it at least talks
	  about new scf and concepts.
2-May-2006
	- Eric Sunshine fixed csPoolEvent::DecRef() to set up recycled data
	  members the same way as they are set up by csPoolEvent constructor.
	  Reported by Jonathan Tarbox.
	- Jorrit fixed genmesh loader for the removal of SetMeshWrapper,
	  SetColor, and SetMixMode from iGeneralMeshState.
	- Jorrit fixed bugplug for the removal of SetMeshWrapper,
	  SetColor, and SetMixMode from iGeneralMeshState.
	- Jorrit fixed instmesh and lightning mesh for the removal of
	  SetMeshWrapper, SetColor, and SetMixMode from iGeneralMeshState.
	- Jorrit fixed a stray SCF_DECLARE_IBASE in genmesh. Still not
	  working though.
	- res re-added a SCF_IMPLEMENT_FACTORY to genmesh that somehow got
	  lost.
	- res fixed a gcc 4.1 compile fix to also work on Win32 with shared
	  libs.
	- Jorrit fixed a cast error in genmesh which caused everything
	  to crash.
	- Christopher changed the script event system to use a functor instead
	  of the function-based notification mechanism.
	- res consolidated the various 1.0 API modifications somewhat to have
	  less "Table of Contents spam".
	- res fixed csbench, mazing and startme for the removal of some
	  methods from iGeneralMeshState.
1-May-2006
        - Arianna fixed some warning for MSVC 7.1 and some deprecated
          function.
	- Jorrit removed the simple output console in favor of the
	  standard output console. There is no need to keep two consoles
	  with nearly the same functionality.
	- Jorrit documented the removal of the stars mesh.
	- Jorrit documented the removal of the simple console.
	- Jorrit reordered the nodes in the apimod100 document in a
	  more logical fashion.
	- Jorrit fixed simpvs so that it no longer crashes at startup.
	- Jorrit fixed frustvis and dynavis so that they no longer
	  crash when iGraphics2D is not present. This fixes a crash
	  in unittest.
	- Jorrit fixed the renderloop loader so that it no longer
	  crashes if the loader context is not given to the function.
	  This fixes a crash in csbench.
	- res tweaked the devapi doxygen settings a bit.
	- res removed the "no virtual destructor" warning suppression on GCC4
	- res re-activated the iBase virtual dtor.
	- res changed a couple of meshes to not implement iPolygonMesh as an
	  embedded interface but allocate it from the heap, to fix "abstract
	  virtual method called" errors experienced after an iBase dtor was
	  added last time.
	- res also updated those meshes to new SCF.
	- res changed some plugin namespaces to use the CS_PLUGIN_NAMESPACE_*
	  macros.
	- res fixed some more strict-aliasing warnings.
30-Apr-2006
	- Jorrit fixed spr3d object bounding box calculation. It now
	  calculates the bounding box of all frames instead of only
	  frame 0.
	- Jorrit fixed the following in csdemo:
	    - Made sure the sequences are now kept in memory. Due to
	      a change to the sequence manager the sequence manager
	      itself only keeps weak references to sequences. This change
	      broke csdemo. Now it is fixed.
	    - Fixed the 'show mesh' and 'hide mesh' operation so that
	      they show or hide the entire mesh hierarchy. That way
	      the particle trail is no longer kept visible when the
	      spaceship is made invisible.
	    - Added engine->PrecacheDraw(). This greatly improves the
	      smoothness of the animation when new objects come into view.
	    - Fixed demodata.zip (new version can be found at: http://www.
	      crystalspace3d.org/support/release/cs099/maps/demodata.zip)
	      for the removal of the ball mesh and the removal of the
	      generic render priority system.
	    - Update the message about where to download demodata.zip
	      from.
	- Rhad made the following changes to the Windows csGetMicroTicks():
	    - Changed the calculation logic into whole and fractional second
	      parts to avoid overflow. This fixes a problem where time
	      would appear to move backwards after about an hour on a 2.4
	      ghz CPU. (shorter on faster CPUs, longer on slower CPUs)
	    - Added an assertion when the time reported by the OS moves
	      backwards. This can happen with some AMD X2 processors
	      and requires OS level workarounds.
	- Jorrit removed the broken and not very useful 'stars' mesh.
	  Fixed demodata.zip for this removal.
29-Apr-2006
	- Jorrit added an example staticlod usage so that it is easier
	  to debug problems with it.
	- Jorrit fixed all three versions of iEngine->GetNearbyMeshes() so
	  that they will work correctly with static lod and also return
	  one of the lodded meshes (the correct one depending on the
	  distance between the intersection object and the mesh).
	  This fixed collision detection for static lod meshes and it
	  partially fixes dynamic lighting. It only partially fixes
	  dynamic lighting since when the camera is far away from an object
	  but the light is close to it then the light will only affect the
	  high detail version of the object but the camera can see the
	  low detail version.
	- res attempted to tweak the configure "code generation flags" to
	  work on Intel Macs. The minimum "-march=i586" conflicts with a
	  default setting of the compiler there, so use "-march=i686" on
	  Apples.
28-Apr-2006
	- Eric Sunshine repaired a bunch of Texinfo problems in the new AWS2
	  documentation.
	- Jorrit fixed csMeshOnTexture::ScaleCamera.
	- Jorrit moved the new csQueryRegistryOrLoad() function to
	  iutil/plugin.h and then removed the old CS_QUERY_REGISTRY_PLUGIN.
	- Jorrit added a version of csLoadPlugin() that accepts an
	  object registry instead of the plugin manager.
	- Jorrit added a new csLoadPluginCheck() function that implements
	  the common idiom of first doing a csQueryPluginClass, optionally
	  followed by a csLoadPlugin. There are two versions: one which
	  accepts a plugin manager, and one which accepts an object
	  registry.
	- Jorrit fixed several cases in CS where the above functions
	  are used but where in case of error there was no check (i.e.
	  a crash would result).
	- Jorrit fixed csMeshOnTexture::ScaleTexture() so that it more
	  accurately matches the object box. It now fits the mesh nicely
	  on the texture.
	- Jorrit fixed a bug in iMaterial->GetTexture(). It would crash
	  in case the material had no texture instead of returning 0.
	- Jorrit fixed xmlread and tinyxml parser so that they no longer
	  accept attributes without quotes. Attributes without quotes are
	  not valid XML and both tinyxml and xmlread actually caused
	  memory corruption when those attributes where used (in the case
	  of xmlread it was pretty hard to avoid).
	- Jorrit increased speed of mouselook in walktest.
	- Jorrit documented the removal of CS_QUERY_REGISTRY_PLUGIN and
	  also changed the 0.98 -> 1.00 document to use a menu (it
	  was becoming to big).
	- Christopher made a lot of updates in AWS2, including expanding the
	  Native/Script interface.
27-Apr-2006
	- Jorrit did a few more fixes to csMeshOnTexture. It finally starts
	  to work now.
	- Jorrit added a new convenience method: csQueryRegistryOrLoad().
	  This method will first look for an interface in the object registry.
	  If it is not there it will try to load the plugin and register
	  that to the object registry.
	- Jorrit fixed the distance calculation in csMeshOnTexture.
	  Started work on the auto-fit version of ScaleCamera() too.
26-Apr-2006
	- Jorrit fixed a small bug in the csMeshOnTexture class.
	- Jorrit fixed another small bug in the csMeshOnTexture class.
	- Christopher began adding documentation for Aws2.  He also added
	  the XML to Widget conversion function so that you can make interfaces
	  in XML.  Also, he added the partedit2 data resources for Aws2.
25-Apr-2006
	- Jorrit committed a patch from Adam to implement the signpost
	  changes in simple1 tutorial. Note that this is not perfect yet
	  as it breaks bugplug fps printing.
	- Christopher made partedit2 use csApplicationFramework, and removed
	  the iaws2.h file.
	- Christopher add two layouts: Horizontal and Vertical to the AWS2
          kit.  He also fixed a bug in the widget drawing code where widgets
 	  with no pen would not draw children.
24-Apr-2006
	- Eric Sunshine added msvc_deprecated_warn_{on,off}.h to
	  CS_MASTER_HEADER_REJECTS.
	- Jorrit modified sprcal3d.cfg and made the default animation
	  LOD distances a bit larger to reduce the appearance of 'choppy'
	  animation (but at the cost of some performance).
	- Jorrit added a new csMeshOnTexture class. This class makes it
	  easier to render a mesh on a texture.
	- Jorrit extended the light_ambient shader variable from the
	  generic renderloop so that it also returns the static ambient
	  from the engine (in addition to dynamic ambient from the
	  sector).
	- Jorrit fixed a major bug in iRenderView->GetEngine(). The
	  engine pointer that was returned there was totally bogus.
	  This fixed (among other possible problems) bogus ambient values
	  from the engine in the generic renderstep plugin.
	- res fixed cspace.i to also ignore the _MSG deprecation macros.
	- Christopher renamed iAws to iAws2 for AWS2 interfaces.  This fixes
	  a problem where the <crystalspace.h> include would die when including
	  both sets of interfaces.
23-Apr-2006
	- res worked around the overzealous emission of deprecation warnings
	  by MSVC.
	- res added a new macro to deprecate methods with a message (as
	  supported by MSVC).
22-Apr-2006
	- Jorrit added an optional mesh parameter to iView->Draw and
	  iEngine->Draw. If this mesh is given then this is the only
	  mesh that will be rendered. Otherwise rendering occurs
	  as usual.
21-Apr-2006
	- Jorrit fixed a typo in the fat renderloop.
	- Jorrit added a lit of supported shader variables to the (otherwise
	  empty) shader documentation.
	- Jorrit added a new technique to light_bumpmap.xml with priority 220
	  (thanks to Marten to help with this). This technique is similar to
	  the priority 250 technique except that it only requires 2 texture
	  units instead of 3. It does this by calculating the binormal
	  in the vertex program as a product of the normal and the tangent.
	- Jorrit fixed the arb shader plugin to only produce errors about
	  vertex programs in verbose mode. Otherwise you would get a huge
	  (two page long) error on top of the display when starting terrain
	  on some systems.
	- Christopher fixed a bug in AWS2 compositing, with help from res. He
	  also committed a small change to the opengl screenshot mechanism
	  that inlcudes alpha values.  I'm sure this doesn't affect most
	  situations where screenshot is used, but it's VERY handy for
	  procedural textures.
	- Christopher added a new tool, partedit2.  Since he volunteered to
	  fix this app for AWS2, and since he wants to make sure that AWS2
	  works well with complicated applications needing sophisticated GUI
	  support, he has decided to start building this application now.
	  This will let him make sure that he's making something that will be
	  useful and reasonably simple to use.  This app compiles but
	  currently does nothing at all useful.
20-Apr-2006
	- Jorrit added a patch from Frank which fixes the issue with an
	  CG program failing but the technique using that CG program was
	  still succeeding. This caused rendering errors in some
	  situations.
	- Christopher added SetMixMode to csPen and csMemoryPen.  He also
	  added SetMixMode to Pen in AWS2, and added several mixmodes as
	  constants.  This basically makes up the compositing functions in
	  AWS2.
	- res fixed some doxygen comments.
	- res fixed missing DLL exporting for some SndSys classes.
        - dfryer added a patch from Simon Mihevc (G0thic) to enable mouse
          wheel events in the wxgl canvas
19-Apr-2006
	- Piotr Obrzut fixed moving instances in instmesh.
	- res fixed some more gcc 4.1 warnings.
	- Jorrit again reverted the change to std_lighting.cscg because
	  it breaks lightmapped polygons on mingw. Even after recompiling
	  xmlshader.
18-Apr-2006
	- Jorrit restored the ambient to a dark value after iceeey changed
	  it to a very bright value some time ago.
	- Piotr Obrzut reverts his changes to instmeshes since they are bad
	  when someone deletes instances.
	- res fixed res' inability to count bits as well as res' lack of cut-
	  and-paste skill. Also reinstantiated caedes' fix for the point size
	  in std_lighting.cscg since the rendering issues where due now-fixed
	  xmlshader bugs.
17-Apr-2006
	- res removed the now-obsolete sounddrivers and soundrenderers compile
	  groups.
	- res changed the doxygen configs to expand the
	  CS_EVENTHANDLER_NIL_CONSTRAINTS macro as defined.
	- res fixed missing GUID_NULL symbols with Win32 shared library
	  builds.
	- res fixed csjoywin issues with Win32 shared library builds.
	- res fixed csArray to allow the compiler to not reserve dummy memory
	  for empty allocator classes.
	- res changed csArray so that the threshold logic is templated as
	  well.
	- res made csBitArray more tweakable (csBitArray now inherits from a
	  templated class csBitArrayTweakable that essentially contains the
	  logic).
	- res added some methods to csBlockAllocator to allocate an object but
	  don't construct it, free an object without destructing it, and a
	  free method that does not assert on memory not from the allocator.
	- res added a simple template "copy-on-write" variables.
	- res changed the way the csHash<> internal arrays are declared a bit.
	- res simplified SndSysBasicData::SetDescription().
	- res tweaked the "VFS not found" message for OS/X.
	- res corrected some statements in glfontcache.cpp.
	- res changed the static class variable macros to not require the
	  member to be public.
	- res added a MsvcExtraFile jamfile statement. Useful for e.g. adding
	  .tok files to VC projects.
	- res fixed the static plugin lib generation to properly include
	  defines and cflags from dependencies.
	- res augmented the syntax services to parse/write the upgraded mix
	  modes (with blend ops and alpha test flags).
	- res removed superfluous definitions of CS_USE_ODE_EXTERN_C.
	- res changed the sound system wav loader to utilize the function from
	  csendian.h for endiannes handling. Also enclosed everything into a
	  plugin namespace.
	- res moved the "pooled SCF class" support over to a templated,
	  new SCF style implementation.
	- res made various optimizations in xmlshader.
        - Arianna fixed some warnings found compiling with MSVC 7.1 in 64-bits
          mode.
	- res attempted to fix some gcc4.1 warnings.
15-Apr-2006
	- Piotr Obrzut fixed small bug in adding positions from map in meshgen.
	- Piotr Obrzut did some optimizations to meshgen.
	- Adam added missing newlines (silences a gcc warning).
	- Peter Amstutz fixed a bug in the csvosa3dl plugin whereby an object
	  that was already loaded into the engine wouldn't be moved from
	  one sector to another
14-Apr-2006
	- caedes changed comment formatting on some shaders to be more parser
	  friendly (specially some <?! !> to <!-- --> in std_lighting.xml).
	- caedes changed <? include ?> to <? Include ?> at parallax.xml as
	  the first seems deprecated.
	- caedes fixed an error at std_lighting.cscg where state.point.size
	  was incorrectly assigned to a variable.
	- Piotr Obrzut added quad to cs primitives and instmesh.
	- Piotr Obrzut added feature to add positions from map in meshgenerator
	  (still there are some problems with resolution probably).
13-Apr-2006
	- Piotr Obrzut added method for direct adding position for meshgen
	  geometry.
12-Apr-2006
	- Piotr Obrzut changed instmesh mixmode to alpha test (should be done
          from xml somehow).
	- Peter Amstutz updated the VOS plugin to take out a useless scaling
	  check in voscube, and changed vospolygonmesh to load vertex normals
	  from a3dl
	- Rhad fixed the Ogg Vorbis sndsys element to correctly calculate the
	  number of frames in the source data.
	- Jorrit fixed the configure check for GLCg so that it uses C++
	  to run the test program. That way CG can again be compiled on
	  linux.
	- Christopher fixed csGradient as per res, and also fixed procedural
	  textures in AWS2 to work as intended.  He discovered the cause of the
	  rolling texture on the slider, and fixed that too.
	- Piotr Obrzut fixed bug with instmesh ligtning.
	- Marten did some general warning fixes and formating cleanup. Please
	  people, remember the CS code guidelines. Thhere's more to be done
	  later, be sure of that.
11-Apr-2006
        - Piotr Obrzut fixed meshgen to delete instmeshes instances
          when needed.
9-Apr-2006
	- Rhad renamed CS::Sound namespace to CS::SndSys for all SndSys
	  sound system components. This naming is consistant with the
	  rest of the newer sound system and distinguishes components of
	  the new system from the old system.
	- Rhad added the components in csplugincommon/sndsys/ to the
	  CS::SndSys namespace.
	- Rhad commented and cleaned up the CS::SndSys::Queue class.
	- Marten did some more work on the lighter.
	- Marten fixed a few do-not-compile-on-vc8 bugs.
	- Marten made some improvements to csBox3 and csString.
8-Apr-2006
	- Rhad removed erroneous CS_PURE_METHOD specifier on
	  csMouseEventHelper::GetEventData.
	- Rhad made more updates to the sound system:
	  - Cleaned up excess useless comments in iSndSysSoftwareDriver
	  - Promoted RegisterCallback() and UnregisterCallback() interface
	    functions from iSndSysRendererSoftware to iSndSysRenderer.
	  - iSndSysSoftwareRendererCallback renamed to
	    iSndSysRendererCallback.
	  - Bumped version on iSndSysRenderer due to interface change.
	  - Changed %llu format specifier to PRIu64 in event recorder.
	  - Moved threadsafe queue implimentation from plugins path to
	    libs/csplugincommon/sndsys/queue.h
	  - Added ClearFilterList() function to SndSysOutputFilterQueue.
	  - Added iSndSysStreamCallback.  This interface will allow for
	    callback notification of interesting sound stream events.
	  - Bumped the version of iSndSysStream.
	  - Added libs/csplugincommon/sndsys/ snddata.cpp and sndstream.cpp
	    Simple sound system stream and data classes can build off of
	    the base classes defined here.
	  - Converted Ogg and Wav elements to make use of the streamd and
	    data base classes.
	  - Fixed gcc4.1 reported warnings in the sound system.
	- Fossi reverted the remove of polymesh from brute because it is
	  still used by ODE. So this will need to wait until a new
	  collidertype for heightmaps is added.
	- Fossi added backup of paging former. Should work, but with
          severe artifacts. No test level yet.
	- Piotr Obrzut changed instmesh vertices transforms to look right.
	- Piotr Obrzut optimized moving instances for instmesh.
	- Piotr Obrzut replaced genmeshes with instmeshes in terrainf
7-Apr-2006
	- caedes fixed a bug in cs-config generation scripts that would
	  prevent it from finding optional libraries if cs is installed and
	  CRYSTAL variable is not set.
	- caedes fixed a bug in cspython Jamfile that would make it not install
	  the _cspace.so file.
	- Fossi fixed some minor bugs in bruteblock and added material
	  (alpha)map support and raw heightmap loader to paging former
	- Fossi removed the polymesh from bruteblock that was used for old CD
6-Apr-2006
	- Daniel Fryer fixed the sndsyscoreaudio to work with the new
	  sound renderer.  There are likely to still be issues.  Also modified
	  configure.ac to add "-framework AudioToolbox" when linking with Core
	  Audio.
	- Magodra fixed a crash where csReporterListener::WriteLine crashed
	  because int length = strrchr(str,' ')-str; could case invalid
	  positive length if str is located in uper 1/2 of memory.
	- Vincent removed GLX_VERSION_1_4 test from wxgl canvas so that
	  glXGetProcAddressARB() is always used, instead of
	  glXGetProcAddress(). This corrects his previous bad fix from
	  11-Dec-2005, as well as unknown symbol runtime error with nvidia
	  driver.
	- acraig updated sprcal3d for changes in Cal3d that fixes orientation
	  issues when loading a model.  Also updated the configure.ac file for
	  the more recent check on cal3d.
5-Apr-2006
	- Piotr Obrzut changed terrain collider to be more optimized for
	  smaller 'other' colliders. Terrain colliders are now on.
	- Luca added the csHashReversible::PutUnique method, so that the
	  reverse hash table is updated also on that method. In fact this
	  method overrides the one in the csHash class.
	- Christopher removed csGradient4, and added all the stuff into
	  csGradient.  That class now supports both csColor and csColor4,
	  csRGBcolor, and csRGBpixel.  csColor4 is now the native type,
	  so it will be somewhat more efficient (no translation layer.)
	  He also changed a lot of the visual functionality of the default
	  widgets so that they are more attractive and faster.
	- Christopher added GaugeLevel, an analog gauge that can serve
	  a variety of purposes.  He also added several functions into
	  widget and the window manager, fixed drawing and input so that
	  they occur in order.  Added a simple FPS counter to watch
	  performance.  Added functionality to the dock so that certain
	  events are forwarded to widgets in certain dock locations.
	- Christopher made pens able to render into a texture for AWS2.
	  He also added a Level widget, which currently has some
	  problems due to the procedural texture bug.
29-Mar-2006
	- Fossi fixed bruteblock's SetMaterial(Alpha)Map to work as
	  previously. But since handling of materials is done in the
	  Formers now, their methods should be preferred over bruteblocks.
	- Christopher Nelson fixed the bug where text was appearing in the
	  wrong place.  He also fixed the problem with one of the test
	  windows not having filled shapes.
	- Fossi made the samplers actually return the right resolution for
	  requested integermaps and made some documentation fixes.
  	- Christopher Nelson added a texture object to AWS2, and turned the
	  texturing option on in csPen.  He also fixed some texture-related
	  bugs.  Now any shape that csPen can draw can also be textured.
        - Piotr Obrzut updated terrain formers cd test (works but it is very
          slow) - not active by default
        - Christopher Nelson made linear gradients render into a texture.
        - Christopher Nelson added csGradient4, which handles alphas and
	  csColor4's and renders into csRGBpixel.  He also made AWS2 use this
	  for it's Gradient object, instead of csGradient.
28-Mar-2006
	- Christopher Nelson made *major* changes to the csPen object.  He
	  removed the fill and swap_colors parameters, and added the
	  ClearFlag and SetFlag functions, along with SetTexture.  The two
	  previous functions allow the user to turn swap colors and fill on
	  and off, along with other flags like texturing.  He also turned off
	  CS_FX_FLAT so now per-vertex colors are possible, which lets the
	  user make very simple linear gradients by setting the current and
	  alternate colors.  csPen now has the ability to texture map a
	  given shape.  Texture coordinates are automatically generated for
	  all shapes.  There is currently no way to specify custom texture
	  coordinates.  Textures mapped to a triangle shape will probably
	  not look right.  He also added csMemoryPen, which is the AWS2
	  caching layer for drawing.  AWS2 now subclasses from this pen.
	  The current skin was updated for the changes to the drawing layer.
	  A Gradient object was added to AWS2, but it's currently not much
	  use.  Eventually the gradient object will be used to create a
	  texture which can be mapped to a shape for more complex gradients.
27-Mar-2006
	- Eric Sunshine fixed outdated information in CS/INSTALL document.
26-Mar-2006
	- Piotr Obrzut makes his changes to cs cd system silent. He also
	  adds code for real fix of the problem (not yet finished).
	- caedes made the following changes to cspace.i:
	    - Added includes to be able to access shader variables.
	    - Added particles mesh related interfaces and includes.
	    - Removed old iSndSysSoftwareFilterOutput interface from binding.
25-Mar-2006
	- Fossi fixed hitbeam with distance culled bruteblock
24-Mar-2006
	- Rhad cleaned up and updated the OSS sound driver to use the new
	  template based SCF and better buffering logic.
23-Mar-2006
	- Rhad cleaned up the Windows (directsound) driver and changed it to
	  use the new template based SCF.
	- Rhad changed the ALSA driver to use the new template based SCF and
	  changed the logic to more aggressively seek to lower latency while
	  accounting for under buffer conditions.
	- Piotr Obrzut added terra former collider collision queries handling
22-Mar-2006
	- Rhad performed numerous sound system enhancements:
	    - Changed all sound system components over to the new SCF format.
	    - Added iSndSysSoftwareOutputFilter interface and sound system
	      calls to attach implementing objects.
	    - The windows (directsound) driver should now behave much better.
	    - Cleaned up member variable naming conventions on most components
	      and added more comments.
	    - The sound system now 'keeps time' internally in frame count
	      instead of milliseconds.  This should simplify the flow and
	      reduce/eliminate drift.
	    - Added a 'compressor' class (unused for now) to ultimately
	      contain the logic for sound buffer normalization.
21-Mar-2006
	- res added the MsvcIncDirs rule to specify include dirs for
	  generated VC projects.
	- res moved the CS-specific defines for VC projects out of the
	  project templates into the template customization code.
	- Fossi moved the material and alphamap handling from bruteblock
	  into the formers.
	- res added a "nomanifest" option for applications to inhibit
	  manifest generation on Win32/for VC projects.
	- res changed the msvcgen well-known compile group setup to only
	  add groups as needed, e.g. the "plugins" group is only added
	  if there is at least one plugin.
20-Mar-2006
	- iceeey committed small optimization to parallax shader from
	  sueastside: "move the 2 normalize() functions for eyevec and
	  lightdir from the frag to the vertex shader."
	- Adam updated apimod100.txi to include a quick primer on attaching
	  event handlers to the six csevFrame phases.
	- Jorrit fixed a crash bug in the particles mesh.
	- res fixed cspace.i to define an empty CS_COMPILE_ASSERT macro.
19-Mar-2006
	- Vincent added 'shared' option to cs.spec for RPM using shared lib.
	- Vincent added missing 'partsys' parameter to startme.cfg.
	- Anders added PerformExtension support for 3d renderers, and
	  backface culling control to shaders.
16-Mar-2006
	- Fossi added support for non-square regions to terrain formers.
	  This required changing of the iTerraFormer interface.
	- Fossi also uploaded a newer version of the paging terrain.
	- Adam checked in the new "signpost" event handlers and helper
	  macros, and migrated the four ProcessFrameEventDispatcher flavors
	  to schedule themselves around the signposts instead of each other.
15-Mar-2006
	- Piotr Obrzut added float4x4 array maping with arrays of csVector4
	  arrays to cg shader plugin.
	- Fossi added some more interface changes for the new terrain CD.
14-Mar-2006
	- Jorrit added a GetFlags() method to iMeshFactoryWrapper. In that
	  method you can add defaults for flags for all the meshes created
	  from that factory. This only works for meshes created from
	  factories either through iMeshFactoryWrapper->CreateMeshWrapper()
	  or the loader will also do it if you create meshobjects
	  from factories from XML.
	- Piotr Obrzut changed his previous float4x4 maping to be more
	  intuitive.
13-Mar-2006
	- Vincent fixed 'jam install' so that it also installs terrainf *.lib,
	  AWS2 *.js files and CS/data/aws/widgets/ directory.
	- caedes added iSceneNode to cspace.i.
	- res wrapped some often-used configure command sequences into their
	  own commands.
	- Adam fixed a bug in csjoylin that prevented multiple joysticks from
	  being detected correctly.
12-Mar-2006
	- Marten added support for some more ANSI control sequences in
	  csPrintf on windows (where they are emulated).
	- Marten fixed an ambiguous function call in pagingformer.
	- res changed the CS_ANSI_COLOR_ defines back to their old CS_ANSI_
	  names.
11-Mar-2006
	- Vincent changed sound drivers to use namespaces.
	- Piotr Obrzut added float4x4 maping with 4 csVector4's in cg
          shader plugin
	- Peter Amstutz changed the way the VOS plugin synchronized
	  network updates to object in the CS engine.  This should fix some
	  race conditions.
	- Rhad added csGetMicroTicks() function which returns elapsed time
	  in microseconds.
	- Rhad updated SndSysEventRecorder to use microsecond time values
	  for events.
10-Mar-2006
	- Dan changed M_PI to PI in pen.cpp since it msvc 7.0 didn't like
	  it. Also fixed a typo in pen.h in a function declaration, and
	  fixed a truncation warning from double to float.
	- Christopher added the parent property and Broadcast function
	  to Widgets, and the CheckBox, RadioButton, Window, ResizeKnob,
	  StatusBar, and ToolTip widgets.
9-Mar-2006
	- Jorrit made the alsa sound driver default on linux because it
	  is a LOT better.
	- res made updates for the new cs-win32libs release:
	    - Obligatory docs update.
	    - Augmented msvcgen to allow per-version project options.
	    - Adjusted the VC project options for the new naming scheme of
	      libs that need to be compiled for a specific VC version.
	    - Removed the SpiderMonkey code from AWS2, it's an external
	      dependency now.
	    - Fixed the bullet plugin to compile.
	- Piotr Obrzut did fixes after update to newer bullet version
	- Christopher added SetPenWidth to csPen, and also changed the
	  stepping metric to be a simple constant of two degrees.
	- res committed a change to the splatting_scattering_base shader by
	  Xotic that gives better control about the scattering parameters.
8-Mar-2006
	- Reed make the VOS/A3DL plugin actually set the ambient light color
	  from the a3dl:ambient-light property, rather than a constant color :)
	- Christopher renamed the "Autom" object to "Sys" because he felt that
	  it made more sense.  He also added a "Print" function to the Sys
	  object so that scripts can send output to the console.  The
	  ScrollBar is essentially complete, the only thing lacking is
	  proportional scrolling, and handling correct redraw when the range
	  is something other than (min>0,max<infinity).
7-Mar-2006
	- Christopher added the basic event system to AWS2, and completed the
	  required features for the Pen object.  Christopher also added a
	  clock widget and started to implement mouse events for widgets. He
	  also corrected a silly bug in the widget::Contains function that
	  would cause children to never be resolved as the mouse container.
	- Jorrit changed walktest over to the standard output console
	  as opposed to the simple console. The standard console has more
	  features and it doesn't really make sense to support three
	  different output consoles. So in the end the simple output
	  console will be removed (once all needed features from it are
	  transferred to standard console).
	- Rhad made some spelling fixes to isndsys/ss_stream.h and
	  put in a test fix for a common underbuffering problem in the
	  software sound renderer.
6-Mar-2006
	- Christopher made numerous updates to AWS2, notably the Margins and
	  Font object.  He also fixed csPen so that the text translation vector
	  is properly stored and cleared with the rest of the transforms.
	- Rhad fixed an infinite loop in the ALSA sound driver that could
	  occur if the call to retrieve the sound frames available for filling
	  returned a negative number.
	- Fossi updated the paging terrain former which now actually
	  works for vertices
	- Peter Amstutz improved the wxgl canvas so that it emits
	  focus gained / focus lost events when the mouse enters or exits
	  the window
	- Rhad fixed the ginormous memory leaks in 3d sound sources for
	  real this time.  Also added more debug messages to the software
	  sound renderer and fixed a couple asserts on exit.
5-Mar-2006
	- Rhad cleaned up memory leaks in the sound system:
	    - SndSysOggSoundData has been cleaned up to use local variables
	      where appropriate.  Member variables have been renamed to be more
	      consistant.  Memory leak in IsOgg() corrected.
	    - SndSysSourceSoftware3D should now clean up its filter chains on
	      destruction.  This was causing rather large memory leaks due to
	      the sizable sound buffers some filters use.
	    - SndSysRendererSoftware will now properly cleanup stopped sources
	      and streams within about 500ms of their release.  This fixes a
	      memory leak that occurred when using AutoUnregister streams. As a
	      side effect, RemoveSource() and RemoveStream() will no longer
	      block waiting for the background thread to acknowledge.
	- Rhad added a new interface: iSndSysEventRecorder.  This interface
	  will allow for enhanced debugging of sound events without cluttering
	  the console with reporter messages.
	    - A new plugin - sndsyseventrecorder has been created at
	      plugins/sndsys/utility/eventrecorder/ This plugin is not loaded
	      by default.  To specify enhanced sound system event recording,
	      add -soundeventlog=/this/sound.log (example) to the command line.
	    - queue.h, the sound system's threadsafe queue implementation has
	      been moved from renderer/software into utility/ .
	    - Not all sound system components use the event log (yet).
	- Rhad added an ALSA software sound driver.  This driver needs more
	  adjustments, but seems to work well. Tested only on x86 Linux
	  so far.
4-Mar-2006
	- Jorrit added a feature to csColliderActor so that you can get
	  the meshes that were hit with in the last call to Move().
3-Mar-2006
	- Christopher fixed bugs in csRect and csPen.  Christopher also
	  submitted a large change to AWS2.  He fixed awstest to be able
	  to load AWS2 again, and added some test files to the data portion
	  of the repository.  To see the new changes, uncomment the define in
	  awstest_config.h
	- res revamped the Win32 shared library Jam code to handle the
	  massive amount of object files libcrystalspace contains.
	- res fixed some classes for proper DLL exporting.
	- res made shared libs install properly.
	- Vincent applied res' fixes for undefined symbols with shared libs on
	  GNU/Linux, gcc 3.4.4.
	- res fixed a couple of shared lib issues.
2-Mar-2006
	- Fossi committed another backup of the paging terrain.
	- Fossi copied priority 50 to terrain_fixed_base, so that terrain
	  does at least show on old hardware.
	- Jorrit fixed iObjectRegistryIterator so that it doesn't skip the
	  first element.
	- Jorrit fixed keyboard autorepeat on linux.
	- iceeey made parallax shader use add mixmode by default and
	  destalphaadd only if using projection.
	- iceeey again changed parallax shader mixmode to be srcalphaadd
	  mixmode by default so it supports transparency.
	- iceeey added autoRegions flag to the loader. This makes the loader
	  create a new region for the contents of each library file it loads
	  with the name of the filename. Set it using
	  iLoader::SetAutoRegions(true).
	- iceeey added iSaverFile which stores the filename and filetype
	  (world, library, etc) of a file.
	- iceeey added iSaver::SaveAllRegions() function to save all loaded
	  regions to their respective files. It will look for the iSaverFile
	  attached to each iRegion's iObject. If the saveable flag is set,
	  these will be created automatically by the loader.
	- iceeey implemented saving regions in cssaver. SaveRegionFile() will
	  save the contents of a region to a file.
	- iceeey removed saving renderpriorities from cssaver since they are no
	  longer supported in world files.
	- iceeey made cssaver save the priority for mesh objects and also save
	  sector ambient.
	- iceeey implemented terrain mesh factory and object savers.
	- iceeey made terrain object store materialmap info for the saver.
	  Alphamaps are not supported.
	- iceeey added a special case in cssaver for saving bruteblock meshes
	  to use the crystalspace...terrain.saver rather than the
	  crystalspace...terrain.bruteblock.saver which does not exist.
	- iceeey added iLibraryReference and iAddonReference interfaces.
	  These store references to libraries (<library>somelibrary</library>)
	  and addons respectively.
	  Addons can now be saved if they implement the iSaverPlugin interface.
	  The plugin name of the saver corresponds to the plugin name of the
	  loader but instead of ending in .loader, ends in .saver
	  (crystalspace.renderloop.loop.loader is saved with
	  crystalspace.renderloop.loop.saver).
	- iceeey made terraformers implement iObject. This is so the object
	  name can be accessed easily and so they can be associated with
	  iRegions for use in the saver.
	- iceeey converted pagingformer to new SCF.
1-Mar-2006
	- res added a memory handler for csArray<> that keeps a local buffer.
	  So if the array is small enough and fits into that buffer, a heap
	  allocation is saved.
	- res fixed the csAnsiParse color code checks.
	- res added csPtrWrap, a wrapper to initialize pointers with 0.
	- res took the Python-related plugins out of the MSVC static plugins
	  library.
	- res made some optimizations to xmlshader.
28-Feb-2006
	- Jorrit fixed csStringArray::SplitString() with option delimIgnore
	  so that it actually does what it is advertized to do.
	- Jorrit committed the workarounds for CG related problems on some
	  3d cards. This should fix disco effects on terrainf, incorrect
	  point sprites and incorrect portals. Note that these are
	  workarounds! We need real fixes.
        - Daniel Fryer committed fixes for Mac mouse events (using wrong
          constants for buttons) and for OSXGetDirs.cpp (missing a slash in
          path names).  Mouse fixes required moving mouse button enum from
          event.h to evdefs.h
27-Feb-2006
	- Erroroman added new iSkeleton interface (still not usable).
	- Peter Amstutz fixed a bug in csInputDefinition::Compare where
	  it didn't convert between cooked/uncooked keyboard codes
	  correctly, which broke csInputBinder
	- Jorrit converted iConsoleExecCallback to new SCF.
26-Feb-2006
	- Reed fixed typo in libs/csutil/radixsort.cpp that affected OSX
	  (it was using #if instead of #ifdef to check a preprocessor symbol
	  definition)
	- Jorrit enhanced eventtest to also show mouse move events.
	- Jorrit fixed csInputDefinition::IsValid() so that it no longer
	  crashes with an assert in case you pass an invalid key
	  specification to ParseOther. That shouldn't crash but just
	  return false so you can test for it in calling code.
25-Feb-2006
	- Fossi added a first version of the pagingterrain. It's still
	  under heavy development and no testlevel is provided yet.
24-Feb-2006
	- Jorrit fixed bugplug so it no longer crashes if there is no
	  engine.
	- Jorrit disabled point sprites globally for now since it appears
	  to work incorrectly on all cards found so far.
	- Jorrit fixed csInputDefinition::GetOtherString() so that it works
	  for mouse events too.
	- Jorrit added a new eventtest app. It prints out all mouse and
	  keyboard events (except for mousemove).
	- res made a crash fix to SR.
	- res made the fixed terrain shaders work with SR again.
	- res changed the Win32 keyboard code to only set the autoRepeat flag
	  on key down events.
	- res renamed CSKEY_MODIFIER_COMPARE to CSKEY_MODIFIER_COMPARE and
	  added a CSKEY_MODIFIER_COMPARE macro to aid in comparison of
	  modifier key codes.
	- res submitted a patch from rhohr with some small improvements of
	  the python tutorial apps.
	- Marten removed the old lighter.
	- Marten worked some more on lighter2. Begins to approach usable state.
	- Marten added a const iteartor to csArray.
	- Marten added another version of ForEach function.
	- Marten added some getters to csBox.
	- res enabled generation of Python-related VC projects. (Not in any
	  workspace by default.)
	- res fixed an issue in the Python bindings where _csWrapPtr_to_Python
	  would store the iBase pointer and and not the queried interface
	  pointer. Later, the store pointer would be statically cast to the
	  desired interface pointer, which does not work with the iBase*.
	- res added csApplicationFramework::OnCommandLineHelp().
	- res modernized pysimp.
23-Feb-2006
	- caedes committed a patch he prepared with rhohr that fixes the python
	  SetupEventHandler, the python event handler itself and the python
	  tutorials. All this was broken since last event system changes. Now
	  python only cs apps can again be made.
22-Feb-2006
	- Jorrit added a version of iEngine->GetNearbyMeshes() that works
	  with a beam (i.e. finds all meshes that intersect with the beam).
	- Jorrit fixed sprcal3d so it compiles again after the changes
	  with iObjectModel.
	- Jorrit removed 'Some' and 'may' from the iDocument->Parse()
	  documentation which gives it a completely different meaning.
21-Feb-2006
	- Jorrit added GF 7800 to the driver database so that it doesn't
	  use point sprites.
	- Fossi fixed a c&p error in priority 50 in std_lighting_fixed
	- Fossi added GetTerraFormerColldet() to iObjectModel and
	  implementations for terrain CD
20-Feb-2006
	- res fixed xmlshader to not throw an assertion on external programs.
	- Jorrit added GF 6600 to the driver database so that it doesn't
	  use point sprites.
	- Fossi moved iObjectModel from igeom to imesh and changed
	  includes accordingly to prepare for the terrain CD.
	- Fossi missed some includes in the first try...
	- Peter Amstutz fixed a longstanding (but elusive) bug in
	  csKDTree where the static allocators could sometimes
	  themselves be destructed in the wrong order, causing a
	  crash when the program exits.
19-Feb-2006
	- Piotr Obrzut removed unecesery and wrong conditions checks while
	  seting autodisable params in ode dynamics system.
	- res changed the image loaders to employ the CS_PLUGIN_NAMESPACE_*
	  macros for namespaces.
	- res converted imgplex to new SCF.
	- res changed the VC templates to use /O2 instead of /Ox. Also fixed
	  the whole program optimization setting to work in VC8.
18-Feb-2006
	- res fixed xmlshader so nested conditions and logic expressions
	  actually work.
	- res un-enabled the global Cg position invariance option.
17-Feb-2006
	- res beautified some shader snippet code.
	- res made the following changes to csDirtyAccessArray<>:
	    - Add element handler template parameter.
	    - Split contents reference counting into separate class,
	      csDirtyAccessArrayRefCounted<>.
	- res added support to the Cg shader plugin to specify Cg compiler
	  arguments from the configuration.
	- res enabled position invariance for Cg vertex programs.
16-Feb-2006
	- iceeey made several changes related to ambient light:
	    - Added "light ambient" shadervar to generic renderstep that tracks
	      the sector dynamic ambient light.
	    - Changed the default ambient value in engine.cfg to a dark value
	      of 0.2, 0.2, 0.2.
	    - Added support for setting sector ambient light in world files.
	      Just add <ambient red="1.0" green="1.0" blue="1.0"/> inside the
	      <sector> tag.
	    - Modified most of the ambient shaders to use the shadervar.
	- Jorrit fixed a bug in the parser for meshgen. It was doing a global
	  mesh finding instead of one local to the sector alone with the
	  result that if you had objects with same name in different sectors
	  it would sometimes fail to place the objects on the right position.
	- Jorrit changed the parser so that it no longer sets the world
	  ambient as the default for sector dynamic ambient (as iceeey changed
	  in his earlier commit). World ambient is ADDED to sector dynamic
	  ambient already. So setting dynamic ambient to world ambient
	  basically doubles ambient.
	- res fixed consoletest on Win32 to properly output non-ASCII again -
	  apparently the recently added setlocale() call to do proper output
	  on other platforms causes harm on Win32...
	- res worked a bit on the snippet-based std_lighting. Also sprinkled
	  some comments/explanation throughout the snippets.
	- res added functions to csString to append wchar_t strings.
	- res added overloads for iGraphics2D::Write(), iNativeWindowManager
	  and iNativeWindow methods that take wchar_t strings.
	- res fixed VC8 warnings in simpleformer and converted it to new SCF.
	- res fixed some VC8 warnings in csRadixSorter.
	- res added a method to csStringArray to add multiple strings by
	  splitting a given string at given delimiters.
	- res fixed stdrep to properly handle newlines in messages to report.
	- res converted stdrep to new SCF.
	- res simplified the condition culling code in xmlshader.
	- res changed the "template", "endtemplate" and "include" shader
	  processing instructions to "Template", "Endtemplate" and "Include".
	  The idea is to distinguish them visually from "if" etc (which have
	  somewhat different instructions).
	- res fixed radixsort for 64bit.
	- res fixed cspace.i for CS_GNUC_WPRINTF macro(s).
	- res fixed a bug in xmlshader where the overlap of two value sets
	  was computed wrong.
15-Feb-2006
	- Erroroman added support for 'checkelementcount' option in genmesh
	  factory loader (omits a warning when the element count of a
	  custom buffer does not match the vertex count).
	- res fixed csFinite() compilation on MinGW with -ansi -pedantic.
	- Jorrit fixed a bug in csSector and meshgen. It was casting
	  csMeshGenerator to iMeshGenerator without even knowing the
	  right inheritance structure. This caused meshgen's to not
	  destruct properly (i.e. crash).
14-Feb-2006
	- Piotr Obrzut fixes bugs he left after adding support for different
	  sized maps in simple terraformer.
	- Jorrit fixed compile errors in simpleformer.
	- res added a csFinite() function to wrap the platform-dependent
	  way to check for the finiteness of a floating point value.
	- res worked around an issue in xmlshader where the condition
	  result check failed to work (ultimatively leading to consumption of
	  huge amounts of memory). The issue was caused by gcc apparently
	  performing an unexpected cast.
	- Jorrit fixed compilation of radixsort on 64-bit.
	- res made a condition check in xmlshader sharper.
	- iceeey moved the projection pass into snippets/projection-pass.inc.
	- iceeey added projection support to parallax.
13-Feb-2006
	- Marten started cleaning up the namespace mess. Not finished yet.
	- Eric Sunshine fixed 'jam install' so that it also installs the
	  CS/data/flarge/factories directory.
	- res tweaked the softrenderer & softshader to more appropriately use
	  "bool"s instead of "int"s for some template parameters.
	- res fixed some VC8 warnings occuring with enabled memtracker.
	- res added macros to reduce typing for plugin namespaces.
	- res changed the way XMLshader detects redundant conditions.
	  Basically, for each possible outcome of some condition, the ranges
	  of values a shader variable can take is stored, and a condition is
	  checked whether it is definitely true or definitely false, based on
	  the known possible range of values. If a definite result can be
	  obtained, the condition will not be checked later when a variation
	  is determined; less conditions to be checked mean less variations of
	  a shader.
	- res renamed CS_PLUGIN_PRIVATE_NAMESPACE_* to CS_PLUGIN_NAMESPACE_*,
	  suggested by Marten.
	- res did a small bit of reorganization in xmlshader.
11-Feb-2006
	- Jorrit fixed a bug in setting a parent on a mesh that was already
	  in a sector. The bug is fixed by automatically clearing the
	  list of sectors of the child mesh as soon as it gets another
	  parent.
9-Feb-2006
	- Piotr Obrzut added density map to mesh generator
	- Piotr Obrzut changed simple terraformer to work with different
	  sized intmaps and floatmaps than heightmap.
	- Jorrit added parameters to iMeshWrapper->HitBeam() so that it
	  can now also fetch the material that was hit.
	- Jorrit fixed the mesh generator so that it now works correctly
	  even if it sits on a mesh (terrain) that is not positioned
	  at 0,0,0.
8-Feb-2006
	- iceeey moved the renderloop from the terrain level to
	  std_rloop_terrain.xml. Also added support to it for regular
	  diffuse shaders (before it only had steps for terrain).
	- caedes changed the name of terrain_splat shader type in new
	  std_rloop_terrain to "terrain splat" so it is more consistent
	  with std_rloop_terrainfixed renderloop.
        - Daniel Fryer fixed compile error in cursor plugin
7-Feb-2006
	- Piotr Obrzut fixed a bug in dynamics system colliders reported
	  by CAOZANE. Setting offset for sphere collider wasn't working right
	  when collider was attached to body.
	- Erroroman added shader variables to light.
	- Erroroman added support for light shader variables in loader.
        - Daniel Fryer fixed compile error in CoreAudio driver
6-Feb-2006
	- Piotr Obrzut reverts back his changes in protomesh related to index
	  buffer creation as previous resolution was right.
	- Erroroman fixed creating quaterion from matrix
	- res committed a patch from Andres to annotate.php, to make it work
	  on crystalspace3d.org (it was actually broken since the move from
	  SF).
	- res changed the GL state manager to allow a more fine-grained
	  control about the texture state. The idea is to ease supporting
	  differing maximum numbers of texture coordinate sets and texture
	  image units.
5-Feb-2006
	- Marten fixed the lighter2 after last refactoring. Running lighter2
	  on cornell level should now work out-of-the-box. Still work to do to
	  make it work on other levels and more features.
	- res added routines to get descriptions for DirectX error codes to
	  crystalspace_directx.
	- res converted csjoywin to new SCF.
	- res changed lighter2 to not write out a <filter> texture attribute
	  (since it is enabled by default).
	- Jorrit did a small fix to the documentation with regards
	  to the removed iThingState->GetFactory().
4-Feb-2006
	- Piotr fixed small bug in protmesh when index_buffer is created
	  (csTriangle attributes are stored as int not unsigned int)
	- Jorrit changed the driver database to disable point sprites
	  for ATI on Linux. The particles are miniscule.
	- Jorrit restructured mazing so that the game logic is now seperated
	  in a new Game class. Continued working on the tutorial itself.
3-Feb-2006
	- iceeey made CEGUI wrapper inject time pulses into CEGUI. These are
	  used in CEGUI for things like tooltip timers.
	- Jorrit fixed the jam project template so that the generated program
	  actually compiles.
	- Jorrit did some documentation updates:
	    - Fixed the user object documentation to use new SCF.
	    - Added some more info to the tutorial section.
	- Jorrit added a mazing tutorial. This is a more or less full but
	  small game. Soon I will write a section in the manual dedicated
	  to explaining this tutorial step by step.
	- Jorrit added the first version of the mazing tutorial to the
	  documentation. Not yet finished.
	- Jorrit continued on the mazing tutorial. Still not finished.
2-Feb-2006
	- Jorrit did the following documentation updates:
	    - Reorganized the 'The Basics' and 'Quick Overview' sections
	      in the 'Using Crystal Space' chapter of the manual so that
	      it becomes clearer.
	    - Updated the landscape mesh documentation.
	    - Updated the sound documentation.
	    - Extended the documentation about engine concepts.
	    - Removed the section about the ball mesh.
	    - Added a stub for shader documentation.
	    - Added a stub for renderloop documentation.
	    - Many other small updates.
1-Feb-2006
	- res converted protomesh to new SCF.
	- res fixed std_lighting_detail to work with per-vertex lighting.
	- res fixed a closing of an invalid handle in the Win32 memory mapping
	  code.
31-Jan-2006
	- Jorrit fixed csMeshObject::GetRadius() so that it calculates the
	  radius instead of double the radius.
	- Jorrit fixed a big bug in portal container introduced yesterday.
	  The problem was an uninitialized radius variable causing havoc
	  in portal culling.
	- rvl_ removed logical bug in his code (that was trying to clear
	  stencil in ClosePortal() on hardware where stencil is not available)
	  Portal flags coversion was added to make renderer portal code
	  independent of engine stuff.
	- res fixed a VC7 compile error in Marten's static typechecking.
	- res made the VC _byteswap_* functions intrinsic.
30-Jan-2006
	- Jorrit changed iObjectModel->GetRadius() to return the radius as
	  a single float instead of a vector. It was always used as a single
	  sphere and not an ellipsoid.
	- Jorrit changed all mesh objects for the above change.
	- Jorrit changed many mesh objects to correctly set the center as
	  returned by GetRadius() to the actual center of the model and not
	  to (0,0,0). The radius is calculated accordingly.
	- Jorrit fixed the generic renderstep so that it uses the model center
	  to check if an object is affected by the light (instead of object
	  origin).
	- res updated some code to use new-style endian conversions.
	- res deprecated old-style endian conversions.
	- res added support for optimized byte swapping, when supported by
	  the compiler.
	- res removed support for MD2 conversions from md22spr (since MD2s
	  can now be loaded via the spr3md2 plugin). Also renamed md22spr to
	  mdl2spr.
	- res changed wxtest to use RequestPlugins() to load the WX canvas.
29-Jan-2006
	- rvl_ corrected portal logic of opengl renderer to handle
	  rendering to target correctly. Some code logic/style was
	  changed as advised by res.
	  Removed dependence on engine headers (portal.h) from opengl &
	  software renderers. Version of iGraphics3D was bumped up
	  according to past OpenPortal/ClosePortal changes.
	- Marten added some static type-checking to SCF.
	- Marten fixed VC8 compatibility for rvl_s latest commit.
	- Marten added render buffer saving to genmesh factory saver.
	- Marten fixed some random warnings and errors in comments.
28-Jan-2006
	- Jorrit changed walktest to use the new sound renderer.
	- Jorrit completely removed the old sound system from CS.
27-Jan-2006
	- rvl_ changed portal code (mainly for floating portals) inside
	  opengl renderer to fix the bugs #1411948, #1398043
	- res updated the memory mapping support in VFS for the not so recent
	  memory mapping changes.
	- res fixed the memory mapping code to properly support mapping ranges
	  including the end of the file.
	- res added support for specular lighting to vproc_std.
	- res added support for color sum to softshader.
	- res changed the fatloop to use new SCF.
	- res changed lights to have their specular color the same as the
	  diffuse color by default.
	- res revived csVertexListWalker<>, albeit with a slightly different
	  purpose: it now converts the data inside a render buffer to some
	  user-specified type.
26-Jan-2006
	- Peter Amstutz updated the VOS plugin to remove the crossbuilder code
	  and use the new, much cleaner iLoader interface instead.
	- Peter Amstutz fixed the csvosa3dl plugin to use GenerateSphere()
	  and genmesh in place of the old "ball" plugin
	- Jorrit fixed a few more cases in opcode plugin where it was using
	  dangerous floating point comparisons.
	- Jorrit added a better description of terrainf (mentioning
	  foliage generator) to startme.cfg.
	- Jorrit fixed terrainf so that the skybox no longer casts a shadow.
	- Jorrit decreased density of foliage in terrainf slightly to get
	  somewhat better performance.
	- Jorrit updated the screenshot of terrainf for the startme app.
	- Jorrit removed a few asserts in waterdemo which caused it to crash.
	- res fixed the Win32 and (blindly) OS/X port to set the correct
	  event info on FocusGained/FocusLost events.
	- res restored the waterdemo asserts (since the real cause is fixed
	  now).
	- res worked around a crash on exit that occured when the csVFS
	  object gets released before all VFS files get.
	- res added a missing SCF_INTERFACE to iDebugGraph. Absence of
	  SCF_INTERFACE in an interface causes weirdness at runtime.
	- res made csColliderActor::InitializeColliders() tolerate a 0 mesh.
25-Jan-2006
	- Jorrit added support for cylindrical mapping, half-sphere
	  generation, and reversed triangle generation to
	  csPrimitives::GenerateSphere().
	- Jorrit added support to genmesh for these flags. You can specify
	  them in a map file by using the attributes 'cylindrical',
	  'toponly', and 'reversed' in the <sphere> statement.
	- Jorrit fixed a bug in normal generation of GenerateSphere() in
	  case the center of the sphere was not the origin.
	- Jorrit changed the csSphere in GenerateSphere() to be a
	  csEllipsoid instead. That way one can create ellipsoids.
	- Jorrit added support to the genmesh loader for using an ellipsoid.
	  It works by having radius as a child node instead of an attribute:
	      <sphere>
	          <radius x="1" y=".5" z=".5" />
	      </sphere>
	- Jorrit fixed the XML test in the loader so that it also recognizes
	  XML comments.
	- Jorrit fixed csLoadPlugin and csQueryPluginClass so that they no
	  longer leave a dangling reference in case the plugin actually
	  loaded but didn't implement the requested interface.
	- Jorrit added support for '1' and '0' in the ParseBool implementation
	  of syntax services.
	- Jorrit added a new iSyntaxService->ParseBoolAttribute() to make it
	  easier to parse boolean attributes.
	- Jorrit fixed the new attributes for genmesh/sphere in the loader so
	  that they properly parse as booleans now (so you can say:
	  reversed="false").
	- Jorrit removed some dependencies from csparser to the removed
	  crossbuilder.
	- Jorrit fixed odedynam plugin for the api change in
	  iGeneralFactoryState->GenerateSphere().
	- Jorrit changed all levels to use genmesh instead of ball mesh.
	- Jorrit changed phystut to use genmesh instead of ball mesh.
	- Jorrit removed the ball mesh. It is now obsolete.
	- Jorrit added a new 'zsort' option to the particles mesh. Previously
	  the particles mesh always sorted particles from back to front. But
	  this is slow and only needed if you use alpha. For add and multiply
	  you don't need this. So by default zsorting is now disabled which
	  gives a great boost on performance. This no-sorting option is
	  implemented in the simple and the ode particle physics plugins.
	- Jorrit did some optimizations to the simple physics plugin for the
	  particles mesh.
	- Jorrit fixed instmesh and instmeshldr so they work again. In addition
	  they now support ellipsoids too (like GenerateSphere for genmesh).
	- Jorrit added support for 'direction variation' to the particles mesh.
	  That way it becomes easier to make things like fountains.
	- Jorrit also implemented this for the ODE physics particles plugin.
	- Jorrit fixed animation speed in md2 loader.
	- res fixed a bug in the font plexer where a font was not properly
	  removed from the "loaded font cache" upon deletion.
	- res fixed consoletest to utilize the proper output charset on
	  non-Win32 platforms.
	- Jorrit fixed a serious bug in opcode plugin. It turned out that
	  it was using dangerous tricks to do floating point comparisons.
	  These tricks don't work very well in optimize mode. This caused
	  TraceBeam to fail sometimes and this also caused startme to not
	  work properly.
	- res fixed the software renderer to handle shader-desired but unbound
	  buffers correctly.
	- res fixed some SR-related shader techniques for the recent buffer
	  changes.
24-Jan-2006
	- mdmkolbe removed a VC6 workaround from SCF.
	- mdmkolbe fixed a few more dirent.h issues with the Perl 5 bindings.
	- Jorrit fixed a bad bug in the gmesh 3ds loader plugin which basically
	  prevented it from loading more then one model without crashing.
	- Jorrit fixed a big memory leak in the loader. Every time the loader
	  parsed a plugins section with a plugin it previously encountered
	  the plugin would be loaded again which caused big leaks.
	- Jorrit fixed a leak with portals in the engine when portals were
	  loaded the old way (embedded in the thing plugin). The problem was
	  that the thing loader forgot to register the created portal
	  container mesh to the current region.
	- Jorrit added a patch from Lak_Moore to add support for returning
	  sector information to csColliderHelper::TraceBeam.
	- Jorrit added iModelLoader->Load() version that accepts an iDataBuffer
	  instead of a filename. Fixed gmesh3ds and spr3md2 to support this.
	- Jorrit added iModelLoader->IsRecognized() so that the model loader
	  plugin can check if some model is recognized.
	- Jorrit added a version of iLoader->Load() that accepts an
	  iDataBuffer.
	- Jorrit extended iLoader->Load() so that it will now also try the
	  3ds or md2 model loader if the file is not an XML file. That
	  way iLoader->Load() has become a very flexible method to load
	  any kind of model (CS library files, factories, 3ds, md2, ...).
	- mdmkolbe did a blind commit of a patch from Razor that fixes
	  receiving keyboard events from numpad5 when numlock is off.
	- Jorrit removed the old model importing system (crossbuilder
	  and similar). If you need it for some reason then you can get
	  it back by checking out with the tag PRE_CROSSBUILD_REMOVAL.
	- Jorrit fixed the walktest loadmesh command to use the new
	  iLoader->Load(). That way it can load a lot more models and it
	  is no longer tied to 3D sprites.
	- Jorrit added a new feature to 'meshfact' in world files so that
	  you can now do:
	    <meshfact name="bla" file="/lib/data/model.md2" />
	  That way you can now create mesh factories easily from meshfact
	  files. This works for md2, 3ds, and normal CS XML files like
	  mesh factories and libraries.
	- Jorrit fixed the walktest_static target by removing 'crossbld'
	  target.
	- res changed csparser to not have a hardcoded model loader list.
	- res made some warning fixes.
	- res fixed a gl3d crash when no canvas is present.
	- res fixed gl3d to properly activate buffers from a holder bound to
	  the secondary color.
	- res changed the xmlshader plugin to not have buffer mappings for
	  the color, normal and texcoord buffers by default. While convenient,
	  it could also result in subtle performance issues, e.g. when a
	  buffer is autobound that has to be calculated relatively expensively
	  by a buffer getter, yet is not used in the actual shader (e.g. Thing
	  vertex colors, which are often not used). In this context, requiring
	  an explicit mapping of all buffers seems the better approach - you
	  can see if you forgot a mapping, but may never notice if you waste
	  cycles because of an autobound buffer you don't need.
	- mdmkolbe documented in apimod the recent function removals
	  from iParticleState.
23-Jan-2006
	- Jorrit changed the sequence manager to have support for removing
	  sequences. This is done by optionally allowing to assing
	  a unique id to sequence operations.
	- Jorrit changed the engine sequence manager to use the above new
	  sequence manager feature so that every sequence wrapper gets
	  a unique id. That way, at destruction time, the sequence wrapper
	  can discard its own operations from the sequence manager.
	- Jorrit added some (default disabled) test code to print out all
	  objects that didn't manage to get deleted by a region deletion.
	- Jorrit cleaned up some reference use and introduced a few weak
	  references in the engine sequence manager in order to attempt
	  to fix a leak with triggers that are referenced in other sequences.
	  So far the leak is not gone though.
	- Jorrit fixed a memory leak in the engine sequence manager.
	  Triggers were sometimes put in two ref counting arrays causing
	  them to be leaking.
	- Jorrit fixed memory leaks with the material and texture in case
	  a checkerboard was made on request from some mesh object. The
	  problem was that the texture was added to the region but not the
	  material. Extended iLoader->LoadTexture() with an optional region
	  parameter to fix this.
	- Jorrit changed the csloader plugin to use csString for strings
	  instead of char*. That cleans up the code a bit (eliminated a lot of
	  goto's) and it also eliminates a few memory leaks.
	- Jorrit fixed a walktest crash. The texture loading plugins
	  returned csPtr but didn't increase the ref count first.
	- Jorrit fixed another leak in the engine sequence manager by
	  adding iEngineSequenceManager->AddOperationRunSequence(). This
	  should be used instead of the normal
	  iSequenceManager->AddRunSequence() so that the clean up works
	  properly.
	- Jorrit fixed the sequence manager conditional functions
	  (AddRunSequence(), AddCondition(), and AddLoop()) so that they
	  actually perform as documented. Which means that they don't
	  increase the ref count on the sequence. This fixes a number
	  of memory leaks and makes the above change to the engine
	  sequence manager obsolete (hence it has been removed).
	- Jorrit added memory tracker protection to the clipper in the
	  software renderer so that it compiles again with the memory
	  tracker enabled.
	- res added support for secondary color and color sum to the GL
	  renderer and fixed function plugin.
	- res moved the "lazy unload" from the Win32 library loading code
	  to SCF (seems it is also needed for other platforms).
22-Jan-2006
	- Jorrit fixed an accidental commit in the standard renderloop.
	- Jorrit rewrote csMaterialWrapper to use new SCF. For some reason
	  this fixed engine->RemoveObject() for material wrappers. Not
	  sure why.
	- Jorrit removed iMaterialWrapper->Clone().
	- mdmkolbe removed the following functions from iParticleState as they
	  conflict with functions in iMeshObject:
	    - SetColor(),
	    - GetColor(),
	    - SetMaterialWrapper() and
	    - GetMaterialWrapper().
        - mdmkolbe converted some classes in CS/libs to the new SCF.
	- mdmkolbe fixed some copy constructor issues in scfImplementation.
	- Rhad added basic thread priority adjustment to the csThread interface
	  and implementations.
21-Jan-2006
	- rvl_ changed iGraphics3D::OpenPortal(...) to give a render
	  plugin more information about portal's properties (flags).
	  Portal flags are stored in 'clipportal_stack' member of
	  render plugins (opengl, soft3d). iGraphics3D::ClosePortal()
	  is called without parameters now.
	  Corresponding changes were made in engine code (portalcontainer,
	  fat renderloop) and render plugins code (null, opengl, soft3d).
	- Jorrit fixed a very big memory leak in the engine. All objects
	  that would use software dynamic lighting (like genmesh by
	  default) would leak as soon as they were rendered once.
	- Jorrit fixed a big memory leak in thing. Once a thing was
	  rendered it would never release the render meshes at destruction.
	- res added an option to the GM loader to omit a warning when the
	  element count of a custom buffer does not match the vertex count
	  (there is the odd legitimate use for that).
	- res added support for index buffers to
	  csTextSyntaxService->ParseBuffer().
	- res took the "no texture mappings" warning out of xmlshader.
20-Jan-2006
	- Jorrit did the following documentation updates:
	    - Removed everything about the soon-to-be-removed model
	      importing system.
	    - Added mention of this to the apimod doc.
	    - Added mention of the changed render priorities to the
	      apimod doc.
	- Jorrit temporarily removed the deprecation warnings for
	  the csevProcess and similar events. We don't want these warnings
	  present in the new pseudo-stable. After release of that we can
	  put the warnings back in.
	- Jorrit added support for scfImplementationExt6.
	- Jorrit added a new iSelfDestruct interface. This will be used
	  by engine->RemoveObject() so that it will become:
	    - Faster (only one scfQueryInterface).
	    - Cleaner (no dependencies on non-engine stuff).
	    - Extensible (everyone can implement iSelfDestruct).
	- Jorrit implemented iSelfDestruct in csMeshWrapper.
	- Jorrit clarified the render priority documentation with regards
	  to alpha and keycolor.
	- Jorrit converted csSequenceWrapper and csSequenceTrigger to new SCF.
	- Jorrit implemented iSelfDestruct in various engine objects.
	- Jorrit implemented iSelfDestruct in iSndSysWrapper. By doing that
	  this removes a dependency from engine to the new sound system
	  and it also enables engine->RemoveObject() to work on sounds.
	- Jorrit implemented iSelfDestruct in iSequenceWrapper and
	  iSequenceTrigger. By doing that this removes one dependency from
	  engine to the engine sequence manager and it also enables
	  engine->RemoveObject() to work on sequence wrappers and triggers.
	- Jorrit implemented iSelfDestruct in csNullShader and csXMLShader.
	  This removes the dependency from the engine to the shader manager
	  and enables engine->RemoveObject() to work on shaders.
	- Jorrit added a new iEngineFrameCallback interface. This can be
	  implemented if you want to know whenever the engine starts drawing
	  a new frame.
	- Jorrit announces:
	  For long and dark years a fierce creature roamed in the gloomy
	  corners of BugPlug. Taking the shape of a big Spider it wove its
	  web of deceit and catched many careless wanderers. But no more! The
	  age of the darkness is over and light shines over the land again.
	  The Spider has been defeated. But not by a great warrior, oh no!
	  A small and innocent creature has given Spider a bitter defeat and
	  from now on BugPlug shall be a safer place for everyone.
	- Jorrit completely removed the dependency from engine to engine
	  sequence manager. The engine sequence manager will now use the new
	  iEngineFrameCallback interface to find out the current camera.
	- Jorrit changed csRenderLoop to inherit from csObject. By doing
	  that renderloops can now be added to regions too.
	- Jorrit implemented iSelfDestruct in csRenderLoop.
	- Jorrit changed the renderloop loader addon so that it also
	  respects regions and it will now add the new renderloop to the
	  current region from the loader context.
	- res removed the VC6-related docs and updated the VC7-related docs
	  for the fact that they basically apply to VC7.1 and 8 as well.
	- res made a small optimization in SR clipping.
	- res fixed a crash-on-exit with SR.
	- Jorrit fixed csBlockAllocator so it actually compiles with
	  the memory tracker enabled.
	- res fixed memtracker linking issues for namespaced plugins.
	- Jorrit fixed the memory tracker version of the block allocator
	  so that it is 64-bit clean.
	- Jorrit added a work around for the placement new as used in
	  the GL renderer so that it compiles with the memory tracker
	  enabled.
	- Jorrit fixed an infinite loop in csarray which is triggered with
	  the memory tracker because it was using cs_snprintf. Rewrote to
	  use strcpy/strcat instead.
	- Jorrit fixed another 64-bit issue in the memory tracker.
19-Jan-2006
	- Jorrit fixed gmesh3ds for Frank's latest refactor.
	- Jorrit fixed a bug in spr3d. If the factory had no material but
	  the mesh had one then it would still complain that the material was
	  missing. Now the factory material is really optional.
	- Jorrit added a new md2 loader for spr3d. This will help replace
	  the model importing system.
	- Jorrit added a new iModelLoader interface. This is a convenience
	  interface that some loading plugins can implement. This makes it
	  easier to create a mesh factory from a model file. Currently
	  this is implemented by the new gmesh3ds and spr3md2 plugins.
	  Loading a model is now as simple as:
	    csRef<iPluginManager> plugin_mgr = csQueryRegistry<
		    iPluginManager> (object_reg);
	    csRef<iModelLoader> l = csLoadPlugin<iModelLoader> (plugin_mgr,
		    "crystalspace.mesh.loader.factory.genmesh.3ds");
	    iMeshFactoryWrapper* ff = l->Load ("model", "/lib/model.3ds");
	- Jorrit updated the documentation to document the new way to load
	  models.
	- res changed some code to use csLittleEndian::Convert() for endian
	  conversions.
	- res fixed the broken SWIG post-processing sed expression.
	- Jorrit changed the render priority system in CS:
	    - Giving an unknown priority to a mesh or factory will now
	      result in an error.
	    - It is no longer possible to define render priorities in a
	      world file. It is now only possible to define them from code.
	    - The standard render priorities are now:
		- init
		- sky
		- sky2
		- portal
		- wall
		- wall2
		- object
		- object2
		- transp
		- alpha (only one with back2front sorting)
		- final
	- res toned down file-not-found warnings when using the font plexer.
18-Jan-2006
	- Jorrit fixed a bug as reported by rvl_ involving a memory leak
	  when looking at space warping portals.
	- Jorrit added a size parameter to iBinaryLoaderPlugin->Parse.
	- Jorrit added a new 3DS loader for genmesh. Supports multiple
	  submeshes (different materials).
	- Jorrit fixed genmesh so that it ignores the request for Compress()
	  if submeshes are used. Compress() should be called before adding
	  submeshes or else Compress() should not be called at all.
	- res made the following changes:
	    - Fixed a VC warning in collider.cpp.
	    - Added scfImplementation::operator=() which does nothing. The
	      compiler-generated operator would be unsuitable.
	    - Copy constructor for scfImplementation which triggers an
	      assertion. The compiler-generated constructor would be
	      unsuitable.
	    - Changed iBinaryLoaderPlugin::Parse() to take an iDataBuffer*
	      instead of a pointer and a size.
	    - The scfImplementation::operator=() addition allows the removal
	      of the less than beautiful "scfRefCount = 1" in
	      csCamera::Clone().
	- Peter Amstutz added support for setting gravity and collision
	  detection policies for sectors in the csvosa3dl plugin.
17-Jan-2006
	- Jorrit fixed bruteblock->HitBeamObject() so that it correctly
	  returns the resulting material.
	- Jorrit changed csIntersect3::SegmentTriangle() to also detect a
	  hit on triangle boundaries.
	- Jorrit fixed bruteblock->HitBeamObject() so that it works on
	  triangle boundaries too.
	- Jorrit implemented material specific density modifications
	  in the mesh generator. So you can now disable generation of
	  a specific type of mesh depending on a material.
	- Jorrit added a elapsed time cap to csColliderActor to prevent
	  falling through terrain in case of very slow fps.
	- res added csStringBase& csStringBase::operator= (const
	  csStringBase&) to allow assignment of a csStringBase& to another
	  csStringBase&.
	- mdmkolbe fixed multiple declarations of 'struct dirent' in the
	  Swig Perl interfaces under Cygwin.
16-Jan-2006
	- Jorrit did some documentation enhancements.
	- Jorrit updated the xml format document with a bit more information
	  about textures and materials.
	- res dropped the unused CS_TEXTURE_DITHER flag.
	- res added an assertion to csBaseEventHandler to ensure it's properly
	  initialized.
	- mdmkolbe fixed some compile errors in the Swig bindings
	  that happen when compiling with a separate build directory.
15-Jan-2006
	- rhad added two missing interface declarations for software sound
	  source types. The lack of these could cause SCF_QUERY_INTERFACE
	  to return a non-null pointer cast as an incorrect interface.
	- rhad made some updates to the oss software sound driver so
	  that it respects byte order requests from the renderer.
	- rhad made some updates to the mac coreaudio software sound driver
	  so that it respects byte order requests from the renderer.
	  (and shouldn't crash now).  Mac changes are untested even for
	  compilation as I don't own a Mac, sorry! :(
14-Jan-2006
	- res improved the wxgl keyboard handling somewhat.
13-Jan-2006
	- res changed gl3d to also utilize an iGraphics2D from the object
	  registry, if present (to allow canvas specification from
	  RequestPlugins()).
	- res fixed the wxgl canvas to only call wxGLCanvas->SetContext() on
	  initialization when it's actually visible.
	- res ditched the csavi (and related), cssgiimg and cswalimg plugins.
12-Jan-2006
	- Jorrit added iLoader->LoadShader() to load a shader from a file.
	- res made more tweaks to static plugin linking.
11-Jan-2006
        - res changed the VC project generation to put files that can be shared
          between different VC project versions into the mk/msvc directory.
	- res changed the VC project generation to regenerate the "common"
	  files only when needed (the idea is to speed up the process by
	  avoiding redundant generation of those files by every msvcXgen).
	- res tweaked the VC8 projects to include the manifest file among the
	  "normal" project files (so it gets picked up by the manifest tool).
	- res fixed msvcgen to also work when no msvc "common" directory was
	  specified.
	- res made the static plugins jam file "common", too.
	- res made some fixes to MSVC static plugins support.
10-Jan-2006
	- res tweaked the VC7 project templates a bit to avoid VC8 modifying
	  them when doing "Save all".
9-Jan-2006
        - res dropped the VC project generation for VC6 and added generation
          for VC7.1 and VC8.
	- res dropped the "ExtensiveMemDebug" VC project build configuration,
	  but added they (probably more useful) MemoryTracker and RefTracker
	  configurations.
	- res changed the MemoryTracker and RefTracker VC project build
	  configuration to use the out/debug directory again (since this is
	  probably easier to utilize for external projects).
	- res moved the generated manifest for apps into a separate file.
	- res applied a fix from Xordan to fix (old sound) .wav loading on
	  64bit systems.
	- res converted the image loaders to new SCF.
8-Jan-2006
	- res fixed some spurious text drawing issues.
	- res removed the 'extern "C"' functions from the ODE plugin (since
	  they aren't used any more).
	- res made Win32 thread error reporting more verbose.
	- res fixed an uninitialized var in viewmesh (which caused display
	  issues).
	- res added dependencies for .tok files where used.
	- res fixed VC warnings in tritri.cpp.
7-Jan-2006
	- Jorrit did some more work on integrating instmesh with meshgen.
	  Still not 100% functional.
6-Jan-2006
	- mdmkolbe made some more warning fixes.
	- Marten removed some warning-disable #pragmas for VC, and
	  cleaned up the warnins instead.
5-Jan-2006
        - Arianna fixed some warnings in MSVC 7.1 (64bits) related to
          size_t int conversions.
4-Jan-2006
	- res updated the driver DB tweak against terrainf corruption on ATIs
	  to also include older drivers (Cat 4.8, as reported by Vasily
	  Rudnikov).
	- mdmkolbe fixed some more unused parameter warnings.
3-Jan-2006
	- mdmkolbe fixed build errors in the new event system and a typo
	  that used button instead of buttonState.
	- mdmkolbe fixed several warnings including:
	    - Copy constructors not calling constructors of virtual parrents,
	    - String formats not matching argument types,
	    - Missing size_t cast before a -1, and
	    - Missing #if's around uncalled functions on some configurations.
	- mdmkolbe fixed some unused parameter warnings.
	- Jorrit fixed a bug in the engine: when a mesh or light is
	  deleted it will now automatically unlink whatever children it
	  might have. This fixes crashes when regions are unloaded that
	  contain hierarchical objects.
	- Adam marked csevPreProcess, csevProcess, csevPostProcess, and
	  csevFinalProcess as deprecated.
	- mdmkolbe removed an unused parameter from
	  csEventTree::UnsubscribeInternal
	- mdmkolbe fixed warnings about enum vs non-enum in conditionals.
2-Jan-2006
	- Jorrit fixed a bug in the with lights as children of meshes
	  (reported with bug #1394869).
	- Jorrit started work on support for instmesh in the mesh generator.
	  Doesn't work yet.
	- Jorrit fixed a bug in mesh generator with high radius.
	- res fixed some warnings and issues reported by mdmkolbe.
        - Magodra fixed some warnings
	- Peter Amstutz fixed csInputBinder to work correctly with mouse events
30-Dec-2005
	- Jorrit enabled the new AFP workaround for walktest terrainf so
	  that it also kicks on in Linux.
	- Jorrit sanitized genmesh so that you can now also set the geometry
	  by calling AddVertex/AddTriangle (like instmesh) instead of the
	  clumsy SetVertexCount() followed by GetVertices() and others.
	- Jorrit also changed the genmesh loader so that it accepts the same
	  syntax as instmesh loader. This means that numvt and numtri are
	  now obsolete and you can specify the normals and colors directly
	  in the same <v .../> statement (but only if you don't specify
	  'numvt'!).
	- Jorrit added a new csNormalCalculator class which is used by
	  instmesh and genmesh to calculate normals.
	- Jorrit added a feature to genmesh and instmesh so that the
	  auto calculation of normals doesn't compress vertices anymore. Use
	  <normalnocompress/> to enable this.
	- Jorrit added a new csPrimitives class which can be used to easily
	  generate primitive meshes (boxes and spheres right now). Changed
	  genmesh and instmesh to use csPrimitives.
	- Jorrit fixed bounding volume calculation for instmesh in case
	  of box and sphere generation.
	- res fixed some valgrind errors reported by Jorrit.
29-Dec-2005
	- Jorrit fixed a bug with lighting of instmesh.
	- Jorrit implemented the automatic box generation of instmesh.
	- res worked around a bug in the latest ATI driver causing text and
	  CS logo get corrupted in walktest terrainf.
28-Dec-2005
	- Jorrit finished the basic implementation of instmesh. Still some
	  optimizations to do and then the mesh generator has to be modified
	  to work with it.
	- Oktal fixed compilation on Cygwin.
	- res fixed the "darkness" of the std_lighting_detail_alpha and
	  std_lighting_detail_alpha_scroll shaders, inspired by a different
	  fix from Vasily Rudnikov.
27-Dec-2005
	- Jorrit made the mesh_tri_normals in genmesh a local array for
	  CalculateNormals(). For some reason it was stored in the factory
	  class which means a waste of memory since the array was
	  used nowhere.
	- Jorrit fixed a leak in genmesh. For every genmesh object an
	  instance of a shader variable accessor was leaking.
	- Jorrit added the first version of the new 'instmesh'. This is
	  a mesh that is specifically designed to allow for multiple
	  instances of the same geometry. Currently it doesn't work yet.
26-Dec-2005
        - res added support for separate specular and some specular-related
          parameters to glshader_fixed.
        - res added (partial) support for specular lighting to the vproc_fixed
          shader.
	- res added loading of the light specular color to csparser.
	- res fixed XMLshader to always expect the shader-global <shadervar>s
	  in a <shadervars> block. (One code path expected them outside such a
	  block.)
	- res fixed the fat RL to propagate the light specular color.
	- res added some specularity to simplelights.zip. Shiiiney!
25-Dec-2005
        - res fixed a crash in xmlshader when retrieving metadata from a
          fallback shader that itself did not have validated techniques.
	- res updated the DDS plugin to use new SCF.
	- res added a SR technique for the "lighting_vproc" shader.
24-Dec-2005
	- Jorrit optimized meshgen lod handling considerably.
	- Jorrit optimized meshgen alpha handling considerably.
	- res added support to gl3d for uploading DXT-compressed textures even
	  if the S3TC ext is not present (since some DRI drivers support that,
	  but don't expose the ext since their implmentation is not conformant
	  in other aspects).
23-Dec-2005
	- Jorrit fixed a bug reported by Andrew Craig. csSector was
	  doing a delete on the light sector influence structures but
	  this is a ref counted thing.
	- Jorrit fixed a bug in csThing::SetMixMode(). It would not update
	  the mixmode in the already created render meshes so in many cases
	  this method had no effect.
	- Jorrit fixed the engine so that children of a mesh are now also
	  added to the main mesh list. This already happened in a few cases
	  but not all.
	- Jorrit fixed the main loader so that it uses the loader context
	  correctly to find the mesh factory in case of 'meshref' (as
	  opposed to directly trying to find the factory from the engine).
	- Jorrit fixed the main loader so that in case of 'meshref' the
	  child mesh objects (or lights and cameras) of the just created
	  mesh are also added to the current region.
	- Jorrit added a nice skybox to terrainf with moving clouds.
	- Jorrit did the following meshgen changes:
	    - Added a check and error in case the number of needed
	      blocks (in one frame) is more then the total number.
	    - Fixed a bug where blocks were not properly taken from
	      other blocks already in use. This bug manifested easily
	      if a big radius was used.
	    - Jorrit added method calls so that you can change the
	      number of cells and blocks.
	- Jorrit refixed the bug with adding children to regions too so
	  that it will now also add children of children.
	- Jorrit fixed the handling of CAMERA objects so that they don't
	  call UpdateMove() in case the position didn't change. That
	  optimizes rendering a bit in case the camera stands still.
	- Jorrit did a rather significant fix to csKDTree. In the past,
	  whenever an object moves, is deleted, or added CS will try
	  to do a new distribute of the kdtree. However, this is an
	  expensive operation so instead we now do it only after
	  20 such tree operations.
	- Jorrit optimized csKDTree::MoveObject() so that it will now
	  test if the bounding box of the object actually changes before
	  doing more expensive operations.
	- res changed the Unix csLoadLibrary() to pass RTLD_GLOBAL to dlopen().
	  That seems to fix issues were only indirect GL rendering was
	  available to CS ("export LIBGL_DEBUG=1" revealed a symbol not being
	  found by the DRI driver).
	- res rearranged some code in glx2d to make things work for him.
	- res fixed the X canvases to properly set the default window title.
	- res ported the xwin plugin to new SCF.
	- res fixed softshader to use the same alpha test enabling logic as
	  gl3d.
22-Dec-2005
	- Jorrit added SetMixMode() and GetMixMode() to iMeshObject. This is
	  supported by most meshes.
	- Jorrit fixed a bug in the CS_FX_SETALPHA and CS_FX_SETALPHA_INT
	  macros. They were not putting parenthesis around the macro argument
	  which means that things like CS_FX_SETALPHA (1-factor) simply
	  didn't work correctly.
	- Jorrit did the following meshgen changes:
	    - Optimized it so that meshes are better reused by setting
	      them aside first so that they can be reused in the same frame.
	      That way we avoid removing the meshes from the sector only to
	      put them back later again. Removing a mesh from a sector is an
	      expensive operation.
	    - Implemented density scaling. That way you can have a high density
	      for objects close to the camera and less density for objects that
	      are further away.
	    - Implemented alpha scaling for objects in the distance.
	    - Implemented random rotation for the generated objects (rotation
	      around y axis).
	- Jorrit fixed the lightning mesh object for the mixmode change.
	- res unborked software DXT3 decompression in the DDS plugin.
21-Dec-2005
	- Jorrit improved mesh cache usage by first removing the meshes
	  that are no longer needed for out of range cells before trying
	  to allocate new ones.
	- Jorrit did the following mesh generator changes:
	    - Density now works correctly. Still have to implement density map
	      and material based density.
	    - LOD is working correctly.
	- Jorrit added support for getting the hit material with iMeshWrapper
	  and iMeshObject->HitBeamObject() function. This is implemented for
	  ball, proto, spr2d, spr3d, thing, bruteblock, and genmesh. All others
	  will return 0 for the material. For genmesh submeshes are not yet
	  supported.
	- sueastside contributed some grass for the terrain.
	- Jorrit started an optimization in bruteblock which detects that the
	  beam passed to HitBeamObject() is vertical in which case it will
	  resort to simpler calculations. Not totally finished though. There
	  are still plenty of ways to optimize this further. Also the current
	  optimization is not working correctly. So it is disabled for now.
	- Jorrit finished the optimization of HitBeamObject() in bruteblock
	  for vertical beams. The speed difference is very big and it speeds
	  up mesh generation on terrain considerably.
20-Dec-2005
	- res fixed support for SR "smaller" rendering.
	- res made the SR properly support the canvas clipping rect (which is
	  supposed to effect 3D drawing as well).
	- res clarified some docs for iGraphics3D methods which claimed to
	  take coords in screen space but in fact take coordinates with Y
	  inverted in relation to screen space.
	- res fixed some uninitialized csEvent members.
	- res fixed a coordinate inversion in gl3d.
	- Jorrit implemented the mesh generator loader and fixed a
	  bug in meshgen. Added a test meshgen to terrainf but the engine
	  doesn't yet show the generated meshes (still todo).
	- Adam implemented a unit test for csInputDefinition and fixed a
	  couple of bugs in the parser/constructor.
	- Adam removed an unnecessary resolution layer from static
	  csEventNameRegistry methods.
	- Jorrit changed region removal so that it uses engine->RemoveObject()
	  first. This means that adding support for removal of some object
	  to RemoveObject() is sufficient to support regions.
	- Jorrit added early exit to region removal so that it stops scanning
	  the list as soon as it is totally empty.
	- Jorrit changed the test for a successfully cleaned up region so
	  that it also operates in optimize mode.
	- Jorrit changed RemoveObject() to first check on meshes, factories,
	  textures, and materials since there will be more of those.
	- Jorrit added support for iSharedVariable and iMeshGenerator to
	  RemoveObject().
	- Jorrit fixed the loader so that mesh generators are added to the
	  region if needed.
	- Jorrit fixed a few bugs in the mesh generator.
	- Jorrit changed the engine so that it is actually generating the
	  meshes now. Still not correct though. Density is ignored. The
	  height of the meshes is ignored and meshes are not properly cleaned
	  up when you go away from them.
	- res added SR support to the terrain_fixed_* shaders.
	- res augmented the SR to support index buffers with data types other
	  than 'uint'.
	- Jorrit fixed cleaning up of blocks when they are out of range.
	  Meshes don't yet appear correctly though.
	- Jorrit did the following mesh generator changes:
	    - Fixed a crash at cleanup in the mesh generator.
	    - Meshes are now properly cleaned up when out of reach in a cell.
	    - Distance based generation is now working properly.
	    - The generated meshes now correctly follow whatever meshes
	      they are supposed to follow.
	- BigG Removed unused variable axdata[] from Cajoywin.cpp.
	  Touched code to meet coding standards.
19-Dec-2005
	- Jorrit did more work on the mesh generator.
	- Jorrit fixed a memory leak in md32spr as reported by Anuj Goyal
	  (agoyal@coverty.com).
	- Jorrit fixed a potential overwrite bug in the fixed shader
	  plugin as reported by Anuj Goyal.
	- Jorrit fixed the engine from handling the resize event again.
	- Jorrit fixed csInputDefinition::ParseOther() so that it again
	  parses keyboard events.
	- Jorrit did some code reformatting in csutil.
	- res attempted to merge Adam's and Jorrit's respective tries to fix
	  csInputDefinition.
	- res updated the GL driver DB to extend the GF5 VBO tweaks to all
	  NVIDIA hardware - means that VBO disabling for NV is now only
	  dependent on the driver version.
	- Jorrit did a lot of work on the mesh generator. In principle it
	  is nearly testable now (although the object placement is not correct
	  yet). I can't test it yet because the loader for it is lacking.
18-Dec-2005
	- Jorrit added new functions to csBox2/csBox3 to calculate the
	  squared distance between a point and a box. These new functions
	  complement the already existing SquaredOriginDist() functions.
	  The new functions are called SquaredPosDist() and
	  SquaredPosMaxDist().
	- Jorrit did more mesh generator work.
        - Magodra fixed a typo in inputdef.cpp where Caps and Scroll lock where
          mixed up.
	- Eric Sunshine fixed an unlikely, though potential crasher in
	  csVariant::SetString() which could occur with an expression such as
	  variant.SetString(variant.GetString()).
	- Peter Amstutz updates the csvosa3dl plugin to compile with the
	  latest VOS CVS.
	- Peter Amstutz committed an initial fix for csInputBinder to
	  work with the new event system.  Needs more work though.
17-Dec-2005
        - res reactivated (and slightly improved) "-ilace" support for the
          software renderer.
	- Adam really, really fixed csInputDefinition this time.  Really.
	- Adam csString-ified more csEventNameRegistry and
	  csEventHandlerRegistry internals.
        - BigG Removed unnecessary call to Texture Manager in sndtest.cpp
        - BigG modified g2d.cpp - csGraphics2DDDraw3::PerformExtensionV to
          meet code standards. Removed unused variables.
	- caedes committed changes to pysimp script, as he forgot after fixing
	  it on 15-Dec-2005.
	- Jorrit continued work on the mesh generator. Still not functional.
	  Removed the iMeshGeneratorMapping interface.
	- Eric Sunshine removed a bogus test in CMapEntity::Read() which was
	  added on 2004-06-09. Reported by:
	  http://community.crystalspace3d.org/forum/index.php?topic=624.0
	  The test would fail on valid input because CMapParser had already
	  advanced the line count before it was snagged by CMapEntity::Read()
	  if the closing string quote was the last character on the line.
16-Dec-2005
	- Oktal fixed null pointer dereference in csEngine when iGraphics2D/3D
	  are not available.
	- dfryer fixed OS X specific stuff for event changes.  Some
	  canvas-hidden events aren't generated, but the rest of it seems to
	  work.
	- Adam changed csEventNameRegistry::GetID to use csString internally
	  (fixes a MSVC7.1 crash)
	- Adam fixed csInputDefinition to parse "0" correctly
	- Adam fixed a corner case of event subscription inside of a related
	  event handler.  This should fix runtime-loaded bugplug.
	- Adam fixed a bug in in successor-bound handling when a successor ID
	  had not yet been instantiated in the partialorder graph.
	- Adam exchanged some NULLs for 0's.
	- BigG fixed bug in lighter.cpp that used wrong variable to query mesh.
	- Eric Sunshine renamed the OPCODE plugin from 'opcode' to 'csopcode'
	  in order to avoid clash with Python's 'opcode' module where, if the
	  CS opcode.dll was found in PYTHONPATH or PATH, then Python would
	  complain that the Python-specific initopcode() function was missing
	  from the DLL. This should resolve problem where py2app and py2exe
	  failed when wrapping a pure-Python CS application.
	- res made the SR DrawMesh() work again when no shader was activated
	  previously.
	- res fixed the Win32 callstack generation to not chop off the top
	  entry.
15-Dec-2005
	- res fixed the printf formatter to properly handle very very large
	  floats as well.
	- res made some VC8 warning fixes to wxgl and wxtest.
	- res made csPtr<>'s CS_VOIDED_PTR more 64-bit friendly.
	- Adam added debug-mode sanity checks to partialorder.h
	- caedes did the following fixes and additions to python bindings
	  (fixes most problems, but SetupEventHandler does not work yet):
	    - Fixed cspython to build again after event system changes.
	    - Fixed pysimp example (it used GetFactory from iThingState).
	    - Added iEventNameRegistry and iThingFactoryState to cspace.i.
	    - Added some of the new event macros (csev*(reg)) to cspace.i.
	    - Removed all CSMASK* values from pythpost.i.
	- Adam fixed a crasher in csPartialOrder::Delete().
	- res improved the software rendering of certain polys in a sharp
	  angle to the camera.
	- res fixed some umlauts in the contributors list.
	- Jorrit fixed crash (or potential crash) at exit in isotest,
	  joystest, vostest, simpcd, partedit, pathtut, waterdemo,
	  lightningtest (crashes were indirectly caused by the new event
	  system).
	- caedes removed previous additions to cspace.i that where giving swig
	  errors (bad fix for SetupEventHandler brokeness).
	- caedes added ss_driver.h and changed quaterni.h to quaternion.h in
	  cspace.i to remove some swig warnings.
	- caedes fixed the pysimp2 example.
	- acraig fixed an issue in csMeshWrapper::SetParent when parent is set
	  to 0.  Need to unprepare the mesh.
14-Dec-2005
	- Jorrit did various documentation updates:
	    - Fixed the link to the related projects on the CS page.
	    - Removed mention of the 'new renderer' in the feedback page.
	    - Added mention of using -verbose for more output.
	    - Fixed the link to the bug tracker.
	    - Added Adam Bradley, Michael D. Adams, Piotr Obrzut,
	      Mike Handverger, Mike Gist, iceeey, caedes, Christian Van
	      Brussel, Hristo Hristov, and swedishcoder to the contributor
	      documentation.
	    - Added some extra information to the entries for
	      Marten Svanfeldt, Vincent Knecht, and Andrew Mann.
	    - Updated the directory hierarchy slightly.
	    - Updated the outdated entry about OpenGL needing 2*SRC*DST.
	      Replaced it with an explanation about how to fix slow
	      OpenGL rendering.
	    - Mentioned the need for -relight in rundemo.txi.
	    - Removed several obsolete options from the walktest
	      documentation. Added documentation for -fullbright.
	    - Removed a few obsolete programs from the application
	      overview.
	    - Fixed a csQueryInterface -> scfQueryInterface.
	    - Replaced all deprecated CS_QUERY_REGISTRY with csQueryRegistry.
	    - Replaced all deprecated SCF_QUERY_INTERFACE with
	      scfQueryInterface.
	    - Replaced all deprecated CS_LOAD_PLUGIN with csLoadPlugin.
	    - Updated the simple tutorials for the latest event changes.
13-Dec-2005
	- res fixed render-to-texture support in the software renderer.
	- res fixed pixmap drawing in the software renderer.
	- res fixed some miscellaneous new event stuff fallout.
	- Jorrit added a note about Cg 1.4 requirement to the
	  documentation.
12-Dec-2005
        - res fixed some issues with mouse events.
	- Adam fixed a bug in csInputDefinition::ParseOther().
	  Also fixed a type warning.
	- Jorrit added a few clarifications to the apimod doc about the
	  recent event changes and GetFactory() removal.
	- Jorrit worked further on the mesh generator. No real functionality
	  yet but all classes are there with stub implementations.
11-Dec-2005
	- Vincent Knecht fixed wxgl plugin for platforms using GLX by
	  reversing GLX_VERSION_1_4 test.
	- Vincent Knecht updated sdl2d canvas for the recent event change.
	  Only works in software mode for me though, crashes with OpenGL.
	- Vincent Knecht fixed keyboard handling in phystut. It still crashes
	  on exit though.
10-Dec-2005
	- res updated the apps for the iThingState::GetFactory() removal.
	- res updated and reworded the simple1 tutorial for the
	  iThingState::GetFactory() removal.
	- Vincent Knecht made the following changes:
	  - Updated wxtest and vostest for the recent event changes.
	  - Updated wxtest for the iThingState::GetFactory() removal.
	- Adam fixed the csMouseButton enumeration to be basis-0
	- Adam removed deletedList from csEventTree.  This makes event
	  dispatch slightly less efficient when unsubscribing from an
	  event name currently in-delivery, but makes the code much more
	  understandable.
	- Adam removed some debugging code and cleaned up some
	  coding style violations.
9-Dec-2005
	- Jorrit changed csInputDefinition class to use normal pointers
	  as parameters for iEventNameRegistry instead of csRef.
	- Jorrit fixed a few coding style issues: don't go over 78 chars
	  per line and put curly braces on their own lines.
	- res fixed the Win32 "lazy dll unloading" when ref tracking is
	  enabled.
	- res made the Win32 callstack creation via exception VC-debuggable.
	- res changed csBaseEventHandler to put the iEventHandler
	  implementation into an embedded class. This was done to allow
	  csBaseEventHandler to be co-inherited with classes that are not
	  refcounted (like csApplicationFramework).
	- res fixed some leaks in the new event stuff.
	- res added support for dynamic ambient/PD lights to the Thing vertex
	  color support (ie those work in SR now).
	- res removed the non-vital iThingState::GetFactory() (since the same
	  functionality can be achieved by querying interfaces).
	- res converted the thing and thingldr plugins to new SCF.
8-Dec-2005
	- res made some VC7 and Win32-related new event stuff fixes.
	- res did some slight reformatting.
	- res changed the Win32 platform support code to not assume a single
	  global Win32Assistant any more.
	- Adam made some changes to apimod100.txi to reflect last night's
	  csBaseEventHandler re-factor.
7-Dec-2005
	- Adam Bradley checked in a massive event system overhaul.
	    - The pre-overhaul code is tagged as PRE_EVENT_OVERHAUL_2005
	    - Replace constant event types/masks with string event names.
	    - Add constraint-driven event subscription and scheduling
	    - Change event handler interface to define its own event
	      delivery constraints
	    - Change all input, axis, and button enumerations from
	      basis-1 to basis-0
	- Adam fixed a memory leak in csGraphics2D shutdown
	- Adam refactored csBaseEventHandler to allow co-inheritance
	  along with csApplicationFramework.  A lot of the tutorial
	  apps and tools are now much closer to their pre-overhaul form.
5-Dec-2005
        - res fixed the generic csInstallationPathsHelper::GetAppPath() to
          treat an empty entry in PATH like ".".
	- res made compile fixes for spr3d and sprcal3d.
2-Dec-2005
	- res fixed a bug in flushing of text with the OpenGL renderer.
1-Dec-2005
	- Jorrit added a new iMeshGenerator interface. This will be used
	  for a new feature in the engine which can be used to do things
	  like foliage or other situations where you have to populate a
	  level with lots of objects.
	- res changed csVirtualClock to support suspend and return a current
	  time of 0 (instead ~0) in case it was not advanced yet (the latter
	  valued confused at least spr3d. 0 seems much saner in the context as
	  well.)
	- res converted spr3d, its loaders and the sprcal3d loader to new SCF.
	- res removed some methods from iSprite3DState that can be found in
	  iMeshObject as well.
30-Nov-2005
	- res added mipmapping to the software renderer.
	- res converted some more classes in the renderers implementations to
	  new SCF.
	- res made some small documentation tweaks.
29-Nov-2005
	- Jorrit fixed a bug caused by a recent optimization which freed
	  images directly when they are being loaded. The bug was that
	  the 'keepimage' flag was not respected.
	- res made the following changes:
	    - Removed the now-unneeded scfstrset.cpp and path.cpp files.
	    - Tweaked the driver DB to have the GeForce rules not match the
	      beginning of the GL renderer string (on Macs, this string starts
	      with "NVIDIA GeForce...").
	    - Converted sprcal3d to new SCF and made some smaller tweaks.
	    - Fixed some VC8 warnings.
	    - Fixed a subtle bug in csRenderBuffer that caused the last lock
	      type to be stored incorrectly.
	    - Tweaked csFrameDataHolder<> so it now releases memory after a
	      while as well.
28-Nov-2005
        - Andrew Craig fixed sprcal3d so that the following items are
          supported again:
            - Using attach="n" in the .cal3d file to have meshes that are not
	      attached by default.
            - DetachCoreMesh()
          This patch is a mix of my own work and res2k's patch.
25-Nov-2005
	- Jorrit removed an unneeded call to wview->Draw() in awstest.
	  Improves performance slightly.
	- Jorrit added a new iLight->GetFullCenter() method that gets the
	  real center of the light (taking care to look at parent objects
	  too). Fixed a few places in the engine where GetCenter() was called
	  and GetFullCenter() should be called. This fixes dynamic lighting
	  moving correctly when the light is parented on some object.
	  Note that at this time it is still needed to manually call
	  light->Setup() for dynamic software based lighting.
	- Jorrit fixed halos to use light->GetFullCenter() too.
	- Jorrit reverted the unix timing function because it appears to
	  break things for some reason.
24-Nov-2005
	- Jorrit made the unix implementation of csGetTicks() consistent
	  while still avoiding wrap arround by normalizing the time with a big
	  constant. That means csGetTicks() will (on unix) return consistent
	  values accross all plugins.
23-Nov-2005
	- Jorrit added bruteblock, terrainldr, and glshader_cg to
	  'walkall' target.
	- Jorrit changed the trigger system in AWS to have an additional
	  function. That means that every callback that is registered with
	  RegisterTrigger() now needs to conform to the following
	  prototype:
	      static void Func (unsigned long, intptr_t, iAwsSource*)
	  This extra parameter was added so that you can discover the
	  name of the trigger from the callback function (you can do that
	  by comparing the id from the name as returned by the standard
	  stringset: crystalspace.shared.stringset).
22-Nov-2005
	- Jorrit added LoadLibrary() to sanity.inc to avoid the define
	  of LoadLibrary() to LoadLibraryA() on windows. This seems to be
	  needed for external projects using CS. I don't know why apps
	  within CS itself work fine though (even without this line
	  in sanity.inc).
	- Jorrit reverted the sanity.inc change since it breaks CS. However
	  this means that iLoader->LoadLibrary() remains unusable for
	  external projects for now.
	- res made the haze plugin a bit SR-friendlier.
	- res tweaked the Cg plugin to report slightly more information on the
	  used profile.
	- res fixed an SR clipping issue.
	- res changed walktest to store the camera position with higher
	  precision.
	- Jorrit disabled VBO globally for the ATI/Linux combination.
	  Jorrit disabled VBO for GeForce4 440 Go.
	  Jorrit otherwise enabled VBO again by default.
	- res limited "GF5 Slow VBO" tweak to only certain driver versions.
	- res also annotated some of the tweaks, the idea being to be later
	  able to determine whether a tweak may still be needed.
	- Jorrit fixed a bug in sprcal3d. It was using csGetTicks() instead
	  of the virtual clock to get the current time. As such this wouldn't
	  be that bad except that it seems that on linux the csGetTicks()
	  of every plugin can possibly return slightly different values
	  depending on when csGetTicks() is first called in that plugin
	  (because of a static variable used to normalize the time so it
	  always starts at 0 or 1 and that static variable is repeated
	  for every plugin).
	- res fixed vertex attributes when used in conjunction with Cg shaders.
	- res disabled VBO on GF5/Linux ForceWare below 76.67.
	- res made the following changes to the driver db code:
	    - More sensible syntax. You can now nest <conditions> nodes
	      instead of counter-intuitively having to use <match> to nest
	      conditions.
	    - Version number comparator is more tolerant; notably, an
	      arbitrary number of non-digits can appear between version parts
	      (GL versions are often in the format "1.2.3 Vendor 4.5", those
	      can be correctly compared now as well.)
20-Nov-2005
        - Piotr Obrzut added missing method for creating/deleting hinge2
	- Jorrit fixed awstest to compile again after changing the Broadcast
	  prototype.
	- Jorrit fixed a bug in the Engine View of AWS. Apparently the clip
	  rect must be set inverted in y direction (relative to height
	  of display) if used for 3D rendering as opposed to 2D rendering.
	  This may actually be a bug in the renderer/canvas. Worked around
	  it in AWS for now.
19-Nov-2005
        - Piotr Obrzut added cs interface to ode hinge 2 joint
18-Nov-2005
	- Jorrit changed the default for register in iLoader->LoadTexture()
	  from false to true. That means that all loaded textures are now
	  automatically registered unless you specifically set that option
	  to false.
	- Jorrit added a new 'free_image' flag to iLoader->LoadTexture().
	  If that flag is true (default) then the loaded image will be
	  removed after registration of the texture. This save up a lot of
	  memory during loading of big maps.
	- Jorrit changed the map loader to also immediatelly register and
	  free images when loading textures.
	- Jorrit changed awstut to use OpenGL by default.
	- Jorrit fixed a bug in AWS Popup Menu. It was using 'sink' before
	  it was setup.
	- Jorrit fixed a 64-bit issue in AWS: Broadcast was using an
	  unsigned long. Should be an uint32. unsigned long caused
	  signalComponentCreated messages to fail.
17-Nov-2005
	- Jorrit removed the OR specific csRenderQueueSet class from the
	  engine.
	- Jorrit increased the default capacity and thresshold for the
	  following arrays (should improve performance slightly):
	    - Temporary array in csRegion implementation.
	    - Temporary array in fat renderloop implementation.
	    - csStencilPolygonMesh->AddPolys().
	    - csPolygonMeshTools->CloseMesh().
	    - shadowMeshes in csStencilShadowStep (bigger thresshold).
	- Jorrit added csArray::SetMinimalCapacity(). This version of
	  SetCapacity() will never shrink the capacity. Only enlarge it.
	- Jorrit changed csPolygonMeshTools->CloseMesh() and
	  csStencilPolygonMesh->AddPolys() so that they are slightly
	  more optimal with setting the capacity. Also fixed a bug
	  in the latter function.
	- Jorrit further increased the default capacity and thresshold for
	  the following arrays:
	    - face_normals in csStencil2PolygonMesh.
	    - csStencil2PolygonMesh->CalculateEdges().
	    - csStencil2PolygonMesh->AddPolys().
	    - A great number of arrays in
	      csStencil2ShadowCachEntry::GetShadow().
	    - projected_points in csStencil2ShadowStep::Perform().
	    - Temporary 'lightList' in the light iterator step.
	    - csMeshList capacity for engine goes to 256 and thresshold to 256.
	    - csMeshList capacity for sector goes to 64 and thresshold to 128.
	    - csMeshFactoryList capacity goes to 64 and thresshold to 64.
	    - csDynavis visible object arrays now have initial capacity of
	      256 and thresshold of 256. occluder_info array is now 128,128.
	    - csFrustumVis visible object arrays now have initial capacity of
	      256 and thresshold of 256.
	- Jorrit cleaned up the stencil2 code a bit. Removed a bit of
	  duplicated code.
	- Jorrit fixed the engine to no longer make a copy of the shader
	  array when trying to find a shader.
	- Jorrit removed support for software shadows for dynamic lights.
	  This was only used by bezier mesh and it was not even enabled.
	  This cleans up the engine a bit more.
	- Jorrit fixed the engine to no longer make a copy of the shader
	  variable array when trying to render a portal (portalcontainer).
	- Jorrit fixed the fat renderloop to no longer make a copy of the
	  shader variable array when trying to render a portal.
	- Jorrit removed the obsolete CS_LIGHT_THINGSHADOWS flag. Also
	  removed the obsolete iFrustumView->ThingShadowsEnabled().
	- Jorrit replaced several occurances of csArray->DeleteAll() with
	  Empty() where this is more optimal (DeleteAll() cleans the array
	  completely while Empty() leaves the allocated items so it can
	  be reused later).
	    - csEngine::ControlMeshes().
	    - csSector::CleanupLSI().
	    - csLight::CleanupLSI().
	    - csLight::CalculateLighting().
	    - csMovable::ClearSectors().
	    - csShaderVariableList::RemoveAll().
	    - csStencil2PolygonMesh::CalculateEdges().
	    - csDynaVis::VisTest().
	    - csFrustumVis::VisTest().
	    - csGenmeshSkelAnimationControl::StopAll().
	- Jorrit increased the default capacity and thresshold of the
	  update_queue set used in Dynavis and Frustvis.
16-Nov-2005
	- res made the following changes:
	    - Shuffled some code around in the software renderer, made some
	      speedups here and there.
	    - Removed a bit of unneeded code from xmlshader.
	    - Tweaked VC7 projects Release mode optimization to use "Full"
	      instead of "Custom" and all settings set explicitly.
	    - Simplified csGLScreenShot::SetData().
	    - Fixed CS_ASSERT to not cause "empty statement" warnings under
	      some circumstances.
	- Jorrit fixed a small warning.
	- res made some tiny optimizations to SR.
	- res added flags to control the direction into which a renderer
	  resizes the dimensions of a texture (if that should be necessary).
	- res worked around buggy GL drivers that crash when copying the whole
	  framebuffer to a texture larger than that.
	- res fixed the SR to properly support alpha modes. Includes addition
	  of binary alpha support.
15-Nov-2005
	- Jorrit fixed a bug in HardTransform() of genmesh. It didn't
	  transform the normals which would give bad results on lighting.
	- Jorrit added new csVertexCompressor class to compress vertex
	  table with texels, normals, and colors too.
	- Jorrit added iGeneralFactoryState->Compress() to compress the
	  vertex table (including texels, normals, and colors) of a genmesh.
	  Also added <compress> keyword to do it from a map file.
	- Jorrit optimized software lighting in genmesh slightly.
14-Nov-2005
	- Jorrit fixed a bug in the new LSI algos so that they
	  don't crash in case there is a portal that can't resolve
	  (i.e. destination sector is missing).
	- Jorrit added 'addmbot' and 'delmbot' commands to walktest.
	  These are the same as 'addbot' and 'delbot' except that
	  the bots don't move.
	- Jorrit fixed a bug in portal container. If the portal world
	  plane was used before the portal was first used for rendering
	  it would return wrong results. This caused functions like
	  GetNearbyMeshes() and the new LSI to fail.
	- Jorrit added a new version of csIntersect3::BoxFrustum() that
	  works directly on a csFrustum.
	- Jorrit fixed iMeshWrapper->GetRelevantLights() so that it now
	  checks the frustum of the LSI.
	- Jorrit fixed the new generic/appfilename.cpp so that it compiles
	  on linux. Every file must include cssysdef.h and also the
	  syspath.h include was forgotten.
	- Jorrit added a new function csLight::GetLuminanceAtSquaredDistance()
	  which calculates the real contribution to the brightness of
	  an object at a given distance.
	- Jorrit fixed a bug in GetRelevantLights() in mesh object in case
	  always update was set.
	- Jorrit changed the GetRelevantLights() in mesh object so that
	  they now sort based on real contribution of the light intensity.
	- Jorrit added an optimization to GetRelevantLights() so that
	  calculation of intensity is now only done when there is a chance
	  that sorting is required.
	- Jorrit fixed some very bad code in the genmesh GenerateSphere()
	  code. First it uses hardcoded array sizes which is bad as such.
	  Secondly it even called delete[] on statically allocated
	  arrays!
13-Nov-2005
	- Jorrit started work on structures to keep track of which
	  lights influence which sectors. The basic algorithm is there
	  but it is not used yet and there is also no auto-updating.
	- Jorrit fixed the LSI algorithms in the engine so that they
	  no longer crash. Also whenever the light moves the LSI is
	  now updated.
	- Jorrit added iLightSectorInfluence interface so that this
	  can now be accessed from outside the engine.
	- Jorrit changed iLightManager->GetRelevantLights() so that it
	  now returns an array of iLightSectorInfluence references instead
	  of iLights. That allows meshes and other systems requiring
	  lighting (fat renderloop) to use lights from neighbouring
	  sectors and also with additional frustum information.
	  Currently this frustum information is not yet used though.
	- evought split getAppFilename() out into its own module to avoid
	  multiple defines on OS X. UNIX build now includes the generic
	  appfilename.cpp.
11-Nov-2005
	- Vincent Knecht made the following changes:
	    - Fixed 'unused parameters' gcc warnings.
	    - Replaced mentions of aalib by libcaca in the manual.
	    - Hopefully fixed height obtained from
	      csRainMeshObject::GetDropSize().
	- Jorrit fixed an initialization error in xmlshader which could
	  case xmlshader to take a VERY long time in some situations.
	- Jorrit fixed genmesh so that it once again updates software
	  vertex colors automatically if the object moved.
10-Nov-2005
	- Jorrit fixed SimpleRoom.java for a recent change in
	  LoadMeshObjectFactory.
	- res made the following changes:
	    - Added a clarifying comment to gl_txtmgr.cpp.
	    - Made some msvcgen adjustments to have VC7 projects work with
	      VC8 nicely.
	    - Fixed some not quite correct size counting in unix/loadlib.cpp.
	    - Removed need for CS_24BIT_PIXEL_LAYOUT.
9-Nov-2005
	- Jorrit changed the way cache filenames (lightmaps and such) are
	  generated for thing, genmesh, bezier, and bruteblock terrain.
	  All floating point values are now avoided because there was no
	  way to generate a unique MD5 from those that is guaranteed to
	  give the same result on all platforms. This would cause failure
	  to load lightmaps. This changes means that ALL lightmap and
	  other CS caches are now invalid so you'll have to use -relight
	  on all maps! This change also means that objects REALLY need
	  unique names now. The MD5 is now calculated from the name,
	  the name of the parent sector, the number of vertices, and
	  the number of polygons only.
	- Jorrit silenced a few valgrind warnings in odedynam.
	- Eric Sunshine renamed texinfo/usingcs/plugin_overview.txi to
	  pluginoverview.txi to work-around TeX shortcoming where it barfs on
	  underscores in filenames.
8-Nov-2005
	- Piotr Obrzut fixed orientation  getters in bullet plugin (reported
	  by Erwin Coumans)
	- Piotr Obrzut changed updating position for rigid bodies to be valid
	  for static bodies too (it is possible to change static body position
 	  and in some situations it makes sense to do so)
	- iceeey added the ability to specify a glow texture to the parallax
	  shader.
	- iceeey merged the specular parallax shader into the single main
	  parallax shader using conditionals.
7-Nov-2005
	- res changed simple1 from using CS_QUERY_REGISTRY to
	  csQueryRegistry<>.
	- res fixed an issue were text was not correctly drawn when output
	  just before iGraphics3D->FinishDraw().
	- res fixed a crash in TinyXML when querying attributes from certain
	  elements,
	- Adam Bradley <artdodge@cs.bu.edu> added the buttonMask attribute
	  to mouse and joystick events, with corresponding helper functions.
6-Nov-2005
	- Vincent Knecht made the following changes:
	    - Added a csInstallationPathsHelper::GetAppFilename() method which
	      returns a native executable filename given a basename.
	    - Modified 'startme' to read demos and star settings from its
	      configuration file.
5-Nov-2005
	- res reinstantiated the forcing of the minimum Cg vertex program
	  profile to be ARB_v_p since NV vertex programs require some extra
	  support from code we don't provide atm.
4-Nov-2005
	- Jorrit improved error reporting in the physics loader in case a
	  body for a joint could not be found.
	- Jorrit added a new shader from Raymond Geerts. This shader is
	  std_lighting_nofog and it can be used to disable fog for a specific
	  material. This is useful in case you want to disable fog for a
	  skybox.
	- Piotr Obrzut fixed BoxShape setting in bullet plugin (it was using
	  box size when it needed half extents)
	- Piotr Obrzut changed phystut to work with bullet and ode
 	  engines. To use bullet just run it with '-phys_engine=bullet'
	  parameter.
	- res fixed some buffer activation/deactivation issues.
	- res enabled the Cg version of std_lighting.
3-Nov-2005
	- Jorrit added a <sphere> keyword to the genmesh loader so that you
	  can now generate genmesh spheres from map files too.
2-Nov-2005
	- res augmented the shader conditionals to also allow access to shader
	  variable vector value components.
	- res augmented the shader expression to allow quoted strings (since
	  spaces in shadervar names are somewhat common).
	- res fixed "accumulator register" allocation being borked in the
	  shader expression make-vector op support.
	- res added fog support to the Cg std_lighting.
	- Jorrit fixed the xwin plugin so that the alert function works
	  properly on 64-bit machines.
	- Jorrit improved error reporting and code style in the physics
	  loader.
	- Jorrit improved the plane parser in syntax services so that
	  a, b, c, and d are now also recognized if you use them as
	  attributes instead of child nodes.
	- Jorrit improved the physics loader so that you don't have to
	  specify the attributes 'friction', 'elasticity', and 'softness'
	  for all the colliders. Friction now has a default of 1.0 and
	  the others 0.0.
	- Jorrit changed the physics loader so that the system node now
	  supports an additional 'name' attribute. If that attribute is
	  not given then it behaves as it used to behave: i.e. a new
	  system is created. If the 'name' attribute is given then it
	  will first try to find a system with that name. If none exists
	  then a new system is created and the new system will get the
	  given name.
	- Piotr Obrzut fixed orientation getters, and added debuging feature
	  for displaying box colliders in bullet plugin.
	- Anders (hopefully) fixed bugs related to render to texture
	  functionality. Render backend needs to flush text drawing to avoid
	  conflicts with text drawing states. Also viewport adjustments
	  weren't applied correctly in all cases.
	- res removed some static class vars from csShaderExpression.
	- res updated the Cg recency check.
1-Nov-2005
	- Jorrit fixed the wav loader of the new sound system so that it
	  works properly on 64-bit.
31-Oct-2005
	- res changed the cs-win32libs configure check so it is only performed
	  on Windows hosts.
	- res added a configure check to determine whether "no virtual
	  destructor" warnings should be silenced.
	- Piotr Obrzut added bullet plugin. Still there are many missing
	  features like joints, some colliders shapes etc.
30-Oct-2005
	- res made the following changes:
	    - Added support for buffer destination resolution by a shader
	      program.
	    - Added support for Cg program parameter names as buffer
	      destinations.
	    - Improved mapping of buffers to generic vertex attributes.
	    - Improved nesting of shader conditional templates a bit.
	    - Files included via a shader conditional <?include?> must now
	      have an <include> node to better comply with the XML spec.
	    - Fixed some VC7 warnings.
	    - Took SR-related projects out of the VC6 workspaces.
	    - Added a workaround for timing problems on Win32 on multiprocessor
	      machines.
	    - Made some reftracker-related tweaks.
	    - Added a (incomplete and still disabled) Cg-based implementation
	      of the std_lighting shader.
	- res fixed shader fallbacks in the (common) case that the variants
	  of the shader and its fallback differ.
	- Eric Sunshine eliminated a number of compilation warnings throughout
	  the project.
        - res made the ref tracker activateable via configure.
28-Oct-2005
	- Jorrit fixed lighter, simpcd, and viewmesh so that they work after
	  yesterday's changes.
	- Jorrit optimized thing, genmesh, and bruteblock mesh objects slightly
	  by avoiding the unneeded SCF_QUERY_INTERFACE for getting an
	  iMeshWrapper from an iMeshWrapper.
	- Jorrit fixed the movable so that InSector() considers parent
	  movables too. So the movable will be in a sector if the root movable
	  is in a sector.
	- Jorrit did some attempts to fix lighting issues with the new
	  hierarchical meshes. Not yet successful.
	- Jorrit fixed lighting and culling for hierarchical meshes again.
27-Oct-2005
	- Jorrit did a big change to the way hierarchical objects are managed
	  in the engine. Meshes and lights can now properly be used as
	  hierarchical objects with the same API. For cameras some preparation
	  work has been done but it is not ready yet. Here is how it works:
	  meshes, lights, and camera implement the new iSceneNode interface.
	  You can do QuerySceneNode() to get the scene object from the mesh,
	  light, or camera without having to do SCF_QUERY_INTERFACE. To
	  make some object a child of another you simply do:
	      object_child->QuerySceneNode ()->SetParent (
	    	  object_parent->QuerySceneNode ());
	  To remove some object from a parent you do:
	      object_child->QuerySceneNode ()->SetParent (0);
	  You can also get the children by calling iSceneNode->GetChildren().
	  The following methods have been removed:
	      - iMeshWrapper->GetChildren()
	      - iMeshWrapper->GetParentContainer()
	      - iMeshWrapper->SetParentContainer()
	      - iMovable->GetParent()
	      - iMovable->SetParent()
	- Jorrit fixed the saver so it compiles again.
26-Oct-2005
	- Jorrit made autoresolve for portals default now. It is still possible
	  to disable autoresolve by using <autoresolve>no</autoresolve>.
	  The autoresolve flag is important in case of dynamic loading so it
	  is best to have it default on.
25-Oct-2005
	- caedes added a jack driver for the new sound system in cs. it is
	  called jackasyn as it uses a wrapper library called libjackasyn that
	  has the same interface as oss.
	- caedes added configure test for libjackasyn to configure.ac.
	- caedes added commented example to sound.cfg about how to change
	  sound driver.
	- res split the blending out of the SR scanline rendering.
23-Oct-2005
	- Eric Sunshine fixed some serious brokeness in the libode checks in
	  configure.ac which resulted from the 22-Oct-2005 re-ordering of those
	  checks.
	- Eric Sunshine eliminated several compilation warnings.
	- Eric Sunshine clarified the GPL-OKAY documentation in embed.m4.
	- Eric Sunshine updated jamtemplate/createproject.sh so that it now
	  informs the user about CS's relatively new ELF-based plugin
	  meta-information reader which is preferred over the older
	  GPL-licensed libbfd-based reader.
	- Marten did some more work on lighter, which soon begins to enter the
	  realms of usable software.
	- Eric Sunshine worked around problem with -fvisibility-inlines-hidden
	  causing link errors for external projects on MacOS/X. This should
	  resolve problems where clients of CS experienced errors such as:
	    /usr/bin/ld: libcrystalspace.a(scf.o) malformed object, illegal
	        reference for -dynamic code (reference to a coalesced section
	        (__TEXT,__textcoal_nt) from section (__TEXT,__text) relocation
	        entry (1))
	- Eric Sunshine updated the simple map tutorial (simpmap.txi), which
	  had become pretty well bonked and failed to reflect present-day
	  reality.
	- Eric Sunshine fixed crasher in csMeshWrapper::RemoveFromSectors(0) if
	  the mesh wrapper did not reside in any sectors. (bug #1325410)
22-Oct-2005
        - Philip Wyett changed the order configure deals with libode and if it
	  has/has not been built with OPCODE support. In this order it is more
	  apparent why the lib you have is usable or not.
21-Oct-2005
	- Jorrit fixed some huge reference leaks in the odedynam plugin.
	  It was storing all information (meshes, callbacks, bodies,
	  colliders, ...) in csRef's or csRefArray's but it was also doing
	  IncRef() on the objects manually AND in many cases forgetting
	  to do the DecRef()'s. Fixed by removing all manual IncRef/DecRef
	  calls.
	- Jorrit added support to odedynam to also attach lights and
	  cameras to bodies. The iDynamicsMoveCallback interface has
	  been extended for this too.
	- caedes added scripting bindings for the new sound system to cspace.i.
20-Oct-2005
	- Jorrit changed a lot of code in CS to use
	  light->GetMovable()->GetFullPosition() instead of light->GetCenter().
	  That means that parenting lights to meshes will work better now.
	  Still not perfect as with software lighting a manual Setup() is
	  needed on the light after moving it.
19-Oct-2005
	- Jorrit did a big optimization to the generic renderloop plugin
	  in combination with the lightiter step. Now the list of visible
	  meshes will be intersected with the influence radius of the
	  light (only for point light at this moment). This gives a big
	  speedup on levels that use the diffuse or shadowed renderloops
	  and also makes it possible to use a lot more smaller lights in the
	  same level without big performance degradation.
	- Jorrit changed the optimization in the generic renderloop plugin
	  so that it tests for cutoff radius also for spot and directional
	  lights. A better test for spot light still has to be written
	  though (one that also takes direction and cone of spot light
	  into account).
	- Jorrit removed direction support from lights. A spot or directional
	  light will now point to 0,0,1 by default. Use a transform (<move>
	  in xml) to rotate the light. This means iLight->SetDirection() and
	  iLight->GetDirection() are gone and also it means that it is now
	  possible to use the <move> keyword in light (just like for meshes).
	- Jorrit added support for using <lookat> in parsing of matrices. It
	  works like this:
	    <move>
	      <matrix>
	        <lookat>
		  <to x="0" y="2" z="1" />
		  <up x="0" y="1" z="0" />
		</lookat>
	      </matrix>
	    </move>
	  The default 'up' is 0,1,0.
	- Jorrit fixed the fat renderloop so that it compiles following
	  the above changes but wasn't able to test if the change is
	  actually correct.
18-Oct-2005
	- res updated the new SCF to support the ref tracker.
	- res fixed the console on Win32 disappearing to soon under some
	  circumstances.
	- Christian Van Brussel fixed csSpriteCal3DMeshObject::GetActiveAnims
	  in the cal3d plugin. It left uninitialized the last allocated
	  csSpriteCal3DActiveAnim buffer.
17-Oct-2005
	- res removed some now-outdated code from softrender3d.
	- res made a small importkit documentation tweak.
	- res fixed some SR Z buffer issues.
16-Oct-2005
	- Eric Sunshine increased robustness of the ceguitest + VFS interaction
	  by adding an actual mount point for ceguitest rather than having it
	  rely upon an underlying physical directory structure (which might
	  differ between source and installation locations).
	- Piotr Obrzut did another fix to cs ode colliders, allownig to do
	  mass correction only having all needed paramters.
15-Oct-2005
	- DeSigna made the following changes:
	    - Fixed several minor style issues in shaderexpressions.
	    - Wrote prelim s-expression parser for shader expressions. Only
	      minimally tested.
	- Jorrit added a <radius> to the light in the parallaxtest map.  That
	  works around (hides) the bug where the parallax effect disappears if
	  the light is too far away.
14-Oct-2005
	- Jorrit fixed a bug in the odedynam plugin. Auto-disable for
	  inactive objects is enabled. However the odedynam plugin didn't
	  enable physics again when you called AddForce() or similar.
	- Jorrit did the same physics fix for linear and angular velocity.
	- Eric Sunshine added a Jamfile to CS/data/shader/specular to ensure
	  that the new specular shader gets installed by 'jam install'.
	- Jorrit added a replica of the cornell box to CS to make testing
	  radiosity easier.
	- Jorrit fixed the xml in light_spec_bumpmap.xml.
	- Jorrit added proper error reporting to the loader in case a shader
	  file is malformed.
	- Jorrit added std_rloop_shadowed2 which is a variant of
	  std_rloop_shadowed that uses the stencil2 plugin.
	- res reduced the number of template instantiations in softshader
	  somewhat.
	- res added support for the alpha part of the mixmode to SR.
13-Oct-2005
	- Jorrit added a new specular shader which he got from
	  Erroroman.
	- res converted the shader-related plugins to use new SCF.
	- res replaced cgSetErrorCallback() in the Cg plugin with
	  cgSetErrorHandler().
	- res made some small doxygen fixes to graph3d.h.
	- res updated the doxygen.css from the one from 1.4.5 and updated the
	  doxygen header fragment to support 1.4.5.
	- res added cpu specific flags for x86_64 from Mike Gist to configure.
	- res made the software text writer cleanly return on 0 strings (like
	  the GL one).
	- res removed a superfluous x86_64 codegen check.
	- res made some more doxygen css tweaks.
	- Jorrit fixed a few bugs in the new specular shader.
12-Oct-2005
	- res enhanced the mixmode abilities a bit.
	- res added blending support to SR.
        - res fixed some walkall issues (notably, not all needed canvas
          plugins were always compiled).
        - res added the softrenderer and openglrenderer compile groups.
        - res worked around a gcc SR optimize mode crash. Needs more
          investigation though.
11-Oct-2005
	- Piotr Obrzut fixed ode colliders that they work now when we are
	  changing geometry after body is attached and added mehtod getting
	  local transform
	- Eric Sunshine fixed a bunch of compilation errors reported by gcc 3.x
	  in the recently templatized csBoxClipper and csPolygonClipper
	  innards.
10-Oct-2005
	- Vincent Knecht made a few changes:
	    - Silenced gcc warnings about initialization order in xmltiny.cpp.
	    - Added a doxygen comment about valid arguments for iVFS::Mount().
	    - Removed $@data mount in ceguitest and use /data/ceguitest/ for
	      ChDir(). This is more correct since $@ matches
	      $prefix/etc/crystalspace when CS is installed, at least on Unix.
	- Vincent Knecht fixed a few AWS apps to not crash when invoked with
	  -help.
9-Oct-2005
	- swedishcoder changed the cegui entry in the manual again,
	  the required version of cegui is 0.4.0 nor less or higher.
	- Marten almost completed conversion of libcrystalspace to new SCF at
	  least on win32.  There are a few hard cases left, most notable SCF
	  itself and particle systems basecode. Pooled SCF-classes also needs
	  to be solved.
	- Marten fixed a few warnings about "x previously seen using class,
	  now using struct".
	- Marten fixed a bug introduced in Erics latest fix to his previous
	  commit.
	- res changed csBoxClipper and csPolygonClipper to reuse code via
	  templates instead of macros and #includes.
	- res fixed some SR clipping issues.
	- res removed the now-pointless databuf.cpp and scfstringarray.cpp
	  files.
	- res made a couple of VC7 warning fixes.
	- res fixed some more SR clipping issues.
8-Oct-2005
	- res renamed csgeom/quaterni.h to the more verbose
	  csgeom/quaternion.h.
	- res fixed walktests load camera feature to correctly restore the
	  rotation of the collider actor.
	- swedishcoder renamed cegui.h to icegui.h to distinguish it from
	  CEGUI.h that comes with CEGUI. Also changed ceguitest for this fix.
	- swedishcoder added a note to the manual, that version 0.4.0 of CEGUI
	  is needed.
	- Reed Hedges added a check in plugins/net/vos/vosobject3d.cpp for the
	  case a mesh does not support collision detection (such as
	  billboard)... crash otherwise.  Also added some more diagnostic
	  output and comments to the vostest application.
7-Oct-2005
	- Eric Sunshine pacified autoheader by using three-argument form of
	  AC_DEFINE() for __CARBONSOUND__ work-around in cs_check_host.m4.
	- Piotr Obrzut did another fix against ODE error messages
5-Oct-2005
	- res removed the superfluous CS_ZBUF_FILLONLY Z buffer mode.
	- res moved csFog out to iengine/sector.h since ivideo/graph3d.h does
	  not seem appropriate any more.
	- res fixed wrong coordinate transformations in the SR.
	- res removed csutil/bintree.h.
	- Eric Sunshine made some Texinfo mark-up corrections in the AWS/FVG
	  documentation.
	- Eric Sunshine added `typename_qualifier' support to cspace.i.  This
	  fixes problem with Swig bombing on scf_interface.h in which this
	  CS-specific portability "keyword" now appears.
	- Piotr Obrzut added comments after his last commit, and change
	  odedynam colliders to be dynamic when they will be attached to body.
	- res fixed the std_detail shader mistakenly utilizing the vertex
	  colors as well as lightmap (resulting in a perceived darkness of the
	  walls in flarge).
	- res made the detail shaders fall back to std_lighting (instead of
	  having explicit fallback techniques).
	- res fixed an issue in the SR where not all textures were properly
	  prepared.
	- res fixed the bezier plugin to specify a more correct vertex index
	  range on index buffer creation.
	- Piotr Obrzut added check for sphere colliders in odedynam if given
	  radius is greater than 0 (if it is lower ODE will send his nasty 'bad
	  argument' error notification, stopping all app)
	- res changed the renderers to use new SCF.
	- res moved the SR scanline rendering code into the softshader plugin.
	- res fixed the software techniques of the reflect* shaders.
	- res added flat shading support for the software shader.
	- res added support for variable color scaling to the software shader.
4-Oct-2005
	- Jorrit renamed -nolightmapping to -fullbright and also implemented
	  it in the bruteblock terrain engine and in genmesh (in addition
	  to thing where it already worked before).
	- res removed a specialization for scfFakeInterface<> which VC7 could
	  not handle; also, to have scfFakeInterface<> work, the Interface
	  type to cast to is provided by scfInterfaceTraits<>.
	- Piotr Obrzut change odedynam collision detection to not check
	  collisions between 2 static colliders by default (but allowing user
	  to decide if he want that collision to be checked) .
3-Oct-2005
	- Jorrit fixed odedynam so the default true is REALLY set.
	- res slightly tweaked the wxWidgets check to also support a case
	  where both WX' own GL libs and the standard OpenGL libs are needed
	  on certain platforms.
	- res fixed some SR clipping issues.
	- res fixed a wrong computation in the Thing vertex color logic.
	- res scraped a few bytes off csRenderBuffer by using bitfields.
2-Oct-2005
	- Eric Sunshine fixed protection-related compilation errors in csThing.
	- Eric Sunshine fixed bug in awsImageView::Setup() where its invocation
	  of iAwsPrefManager::GetString("Image") would fail every time,
	  unconditionally. Reported by manolopm@cip.es.
	- Eric Sunshine removed some code from awsImageView::Setup() which was
	  obsoleted by ancient 25-Apr-2002 changes to AWS.
	- res fixed the VC projects to really create PDBs named like
	  "simple1.pdb" instead of "simple1.exe.pdb".
	- Jorrit changed the default for auto-disable in the ODE dynamics
	  plugin to true.
	- Eric Sunshine upgraded devapi.dox to bring it in line with recent
	  changes to pubapi.dox.
	- Eric Sunshine added 'dot' check to jamtemplate/configure.template
	  since 'dot' is now used by doxygen.jam, if present.
	- Eric Sunshine fixed csDefaultsConfig for MacOS/X to be more robust
	  when dealing with inputs the user may have entered via the
	  command-line 'defaults' utility.  In particular, boolean, integers,
	  and floats should now be interpreted correctly. Also, parsing of
	  booleans is now more broad: it accepts any first-letter 'y', 't', '1'
	  (case-insensitive) as meaning true.
1-Oct-2005
	- res changed the engine to only try to load the engseq plugin once.
	- res improved the csFixed* docs somewhat.
	- res optimized SR interpolation to do less interpolations.
	- res changed the VC projects to create .pdb files with the target and
	  not project name (e.g. now simple1.pdb instead of appsimple1.pdb),
	  since some tools seem to like that more.
	- res did some more voodoo in the SR which seems to bump up FPS a
	  notch.
	- res (re)added initial support for vertex colors to the SR.
	- res added support for Thing vertex colors (simply by taking the
	  lumel at the vertex' position).
30-Sep-2005
	- caedes added <rotatelight> sequence to loader, and added support for
	  lights in sequence manager rotate operations. This works exactly as
	  the rotate sequence for meshes, but specifying a light instead.
	- Eric Sunshine fixed a bunch of Texinfo mark-up problems in AWS FVG
	  documentation and corrected a number of navigation problems. Also
	  improved some of the actual content.
	- Eric Sunshine worked around a problem where the CS configure script
	  could mistake a MacOS/X installation for a Darwin-only installation.
	  In particular, the QuickTime 7.0 installer removes
	  <CarbonSound/CarbonSound.h>, which causes #include <Carbon/Carbon.h>
	  in the configure script to fail unconditionally. Re-installing the
	  QuickTime SDK should restore the header, however not all developers
	  know to do this.
	- caedes changed the projectortest map so the spot light now uses the
	  rotatelight sequence for real disco effect.
	- res made the SR scanline interpolation use fixed point maths.
	- Vincent Knecht removed '.exe' occurences in 'startme' app.
	- Eric Sunshine updated the Mingw/Msys instructions to mention the
	  actual Mingw download location since the download list on the Mingw
	  site is incomplete, and this incompleteness can confuse new users.
	- Eric Sunshine fixed bugs in csendian.h following 25-Sep-2005 changes
	  where csGetLittleEndianShort() and csGetLittleEndianLong() failed to
	  perform any endian conversion at all. This manifested often as
	  crashes and other related problems on big-endian hardware.
	- res reordered some data structures in the SR for some performance
	  improvements.
29-Sep-2005
	- Eric Sunshine fixed the CoreAudio plugin so that it once again builds
	  cleanly. Also reduced namespace pollution a bit.
	- Eric Sunshine worked around complaints from gcc 3.3 in objects which
	  have been converted to the new SCF design. In particular, the
	  compiler dislike seeing a private destructor when the class had no
	  friends.  To fix, made the destructor public. The public destructor
	  should not be a problem since these implementations are themselves
	  entirely private to their respective modules.
	- Eric Sunshine eliminated compilation warnings in the bruteblock
	  plugin.
	- Eric Sunshine added %ignore to cspace.i for deprecated csRect method.
	- Eric Sunshine worked around (possibly gcc 3.3) issue where the
	  singleton `cspluginSoft3d::Scan' symbol was unresolved at link time.
	- Eric Sunshine added some aliases to bugplug.key for MacOS/X since
	  bare F9, F10, F11, and F12 are used by OSX itself by default.
	- Eric Sunshine eliminated some additional compilation warnings.
	- Jorrit did some more cleanups.
	- Jorrit removed the pvs culler as it is not really useful and would
	  need further development to make useful. It can be retrieved from
	  the attic with the PRE_PVSVIS_REMOVAL tag.
	- Jorrit removed the foliage mesh as it is not really useful and would
	  need further development to make useful. It can be retrieved from
	  the attic with the PRE_FOLIAGE_REMOVAL tag.
	- mdmkolbe fixed a build error due to integer-size ambiguity.
	- res added some protections against IncRef()ing objects from the
	  destructor or excess DecRef()ing objects to scfImplementation<>.
	- res cleaned up the generic csplugincommon/render3d texture-related
	  classes.
	- res added initial support (again) for perspective-correct rendering
	  to SR.
	- Piotr Obrzut fixed bug while attaching existing placable collider
	  to body.
	- res templatized csVector4.
	- mdmkolbe fixed some unused parameter warnings in CS/libs/csutil/.
28-Sep-2005
	- Jorrit caused much wailing and gnashing of teeth as everyone will
	  have to rebuild CS and everyone will get a new set of auto-generated
	  documentation.
	- Eric Sunshine resolved a bunch of Doxygen warnings.
	- Erroroman made the following:
	   - added light type SV in generic render loop.
	   - added projection and texture3d mapping in gl fixed shader.
	   - added projectortest (r3dtest + small changes).
	   - added light_projection_bumpmap.xml shader.
	   These things are working with lots of ugly fixes. We need
	   light transform definition in world xml and trigger for light
	   rotation. Also every light must hold projection/attenuation texture
	   (now i can't add another spot light with different projection
	   texture).
	- Jorrit did more cleanups. People try to keep to the 78 char per line
	  limit and follow the indent=2 space rule.
	- Eric Sunshine fixed numerous compilations warnings and errors in
	  AWS2.
27-Sep-2005
	- Jorrit added csTransform::GetUp(), GetFront(), and GetRight().
	  These three convenience functions get the up, front, and right
	  vectors in 'other' space. They are very efficient.
	- Jorrit fixed the loader so it is no longer an error if the
	  sound loader is not present. Sounds will simply be ignored then.
	- Marten fixed the handling of casting for scfFakeInterface.
	- Erroroman made a lot of bug fixes in genmesh skeleton animation:
	    - All euler angles operations are replace with quaternions.
	    - Added offset transform when rigid body is attached to the
	      bone and that fixed lots of problems in ragdoll.
	    - Added 3 methods for faces/verts normals recalculating:
	        - Disabled method - nothing recalculates.
	        - Fast method - fast, but not accurate.
	        - Accurate method - accurate, but slower than fast method.
	          (<calcnorms>fast</calcnorms> can be defined in animation
	          xml).
	    - Added methods to get normals and their count.
	    - Fixed problems arround animation looping and frames that have
	      limited loops.
	    - Added "duration" attrib in frame tag, that can force animation
	      duration.
	    - Added SetSpeed, GetSpeed functions in animation script, that
	      can control animation duration (similar to SetTime/GetTime).
	    - Fixed lots of problems in time related operations, that makes
	      animation to run differently on different frame rates.
	    - Passed iMeshObject to the animation plugins for future
	      sharing of skeleton between parent and child object.
	- Jorrit added an error to the sprite mesh loader in case the action
	  couldn't be set.
	- Eric Sunshine made run_command() in jobber.pl even more robust for
	  some of the complex expressions passed to it, such as the $configure
	  commands in CS's jobber.cfg.
	- Erroroman added light transform in lightsvcache
	- caedes added iMapNode and iMovieRecorder interfaces to cspace.i.
	- Erroroman added light transform shader var in ligtiter step plugin.
	- Christopher added csTriangulate2, a 2-dimensional arbitrary polygon
	  triangulation algorithm.  This triangulator does NOT handle holes,
	  but it should handle concavities.  I haven't tested the code yet, but
	  it does compile fine.
	- Eric Sunshine eliminated some Swig warnings.
	- Eric Sunshine worked around problem where <perl.h> #defines Pause,
	  thus borking the output of Swig for iMovieRecorder::Pause().
26-Sep-2005
	- Eric Sunshine resolved some additional Doxygen warnings.
	- Eric Sunshine improved the robustness of jobber.pl's run_command()
	  function in the face of shell expressions involving && and ||.  This
	  fixes problem where it failed to catch error messages generated by
	  Doxygen following recent changes to CS's jobber.cfg where the Doxygen
	  task became `jam apihtml && rm foo'.
	- res changed iSndSysLoader::LoadSound() to load from an iDataBuffer*
	  and not a pointer and size.
	- iceeey reverted the CEGUI updates requiring CEGUI CVS. The 0.4.0
	  CEGUI release is now required instead.
	- res tweaked the CEGUI plugin to be less greedy about character
	  events.
	- res made a computation in simpleformerldr a bit clearer.
25-Sep-2005
	- res did a couple of Doxygen fixes. Mostly adding \file to files.
	- res did some more SR code shuffling.
	- res merged ivideo/polyrender.h into Thing.
	- iceeey removed the width and height parameters from
	  iCEGUI::Initialize() as Doxygen complains and they are not needed.
	- Jorrit extended the iObjectWatcher with the possibility to watch
	  arrival/removal of new meshes in sectors in addition to light
	  and movable changes in general.
	- Jorrit changed a few more engine interfaces to new SCF.
	- res fixed the simple former loader to properly read heightmap32
	  again after the recent raw format additions. Also compiles on gcc
	  again.
	- mdmkolbe fixed some initializer order warnings.
	- res reorganized the endian conversion stuff a bit; the routines are
	  now wrapped into classes. Also, they are now named to reflect that
	  specifically sized types are converted. Last but not least,
	  encourage use of IEEE floats instead of a custom floating-point
	  representation.
	- res fixed csRGBcolor comparison. Previously, it could happen that
	  when comparing a, b and b, a in both cases "first greater than
	  second" was reported.
	- res removed iImageVector and csImageVector.
	- res merged csVertexListWalker<> into csRenderBufferLock<>.
	- res worked around breakage due bogus pointers when casting to
	  scfFakeInterface<If> by having scfFakeInterface<> inherit from If,
	  to make things work again until Marten can take a look.
	- res removed csDataStream since it overlapped with csMemFile; the
	  convenience functions have been moved to csFileReadHelper.
	- res moved csVideoPreferences into the simpvs app.
	- mdmkolbe fixed some inheritance ambiguity warnings due to virtual
	  inheritance from iBase.
24-Sep-2005
	- Jorrit fixed dependencies in the loader. It now also depends on
	  new sound loader and renderer.
	- Jorrit fixed the sound manager so that it actually compiles.
	- iceeey updated the CEGUI recent check to require CEGUI CVS.
        - res changed the API documentation generation to use dot, if present.
	- Marten finished converting csengine to new SCF syntax. Only a single
	  issue is left (iMaterialEngine) but it needs some more investigation
	  and discussion.
	- res augmented the simple former loader to also support heightmaps in
	  a selection of raw formats.
	- res removed the unused csRGBVector.
23-Sep-2005
	- Jorrit fixed the sound renderer csplugin file so that it works
	  again.
	- Jorrit fixed the general sound loader plugin so it no longer tries
	  to load the wav and ogg loaders with the 'planeshift' prefix.
	- Jorrit changed the iSndSysRenderer prototypes to accept normal
	  pointer arguments instead of csRef's.
	- Jorrit finished the sndtest app. It now plays a sound and constantly
	  rotates it around the camera. The position of the sound is
	  represented by a simple mesh as well.
	- Jorrit fixed a leak to the reporter in the OSS driver for the new
	  sound system.
	- Jorrit fixed a leak to the reporter in the CoreAudio driver for
	  the new sound system.
	- Jorrit fixed a circular reference in the windows directsound driver.
	  It was holding a ref to a csThread that in turn held a ref to the
	  csRunnable (which was implemented by the driver itself). Solved this
	  by making the csRunnable a separate class.
	- Jorrit did a similar circular-leak fix to the OSS driver (untested).
	- swedishcoder added some CEGUI documentation.
	- Jorrit added a new system to the engine so that you can optionally
	  include lights in the culling system as well. This can be useful
	  for shadow plugins (like the stencil plugins) so that they can
	  be notified when a light is visible. To enable this you need to call
	  iSector->SetLightCulling(true). Note that this is completely and
	  utterly untested!
	- Eric Sunshine fixed numerous Texinfo mark-up problems in the new
	  cegui.txi.
	- res fixed some CEGUI blurriness; in screen space mode,
	  DrawSimpleMesh() does not like vertices with Z != 0.
	- res extended the CEGUI event handling to support more CS keys. Also
	  made it use the iKeyComposer for character input.
	- res tweaked the CEGUI texture parameters a bit.
	- res improved PAD key handling in the Win32 composer.
	- Jorrit added a few functions to iLoader to support the new sound
	  system.
	- res made the SCF implementation class generation macro magic header
	  being filtered by the C++ preprocessor. This way, scfImplementationN
	  and scfImplementationExtN are now documented, and implementation
	  classes utilizing those helpers show unherited documentation again.
	- Jorrit added support for loading sounds for the new sound system
	  through world and library files. To use this you just have to add
	  the 'mode3d' attribute for the <sound> keyword with one of the values
	  'disable', 'relative', 'or 'absolute'.
	- Jorrit allowed sound filename to be specified with 'file' attribute
	  in addition to the old syntax of using a <file> child node.
	- Jorrit allowed texture filename to be specified with 'file' attribute
	  in addition to the old syntax of using a <file> child node.
	- res renamed iGLDriverDatabase to iOpenGLDriverDatabase for
	  consistency.
	- res did some more misc tweaks of the recently changed Doxygen stuff.
	- iceeey fixed constructor, and removed deletion of resource provider
	  in CEGUI to match CVS changes. Also added renderer identification.
	- iceeey updated CEGUI skin and layout files for CEGUI CVS changes.
22-Sep-2005
	- Jorrit started working on better integration of the new sound
	  stuff into CS. First the loader now also optionally loads the new
	  sound loaders. Secondly there is a new sound manager which will
	  be responsible for keeping track of the sounds. In the old system
	  this was done by making the sounds children of the engine object
	  but this is a bit clumsy and there was also no proper region support.
	  This is all work in progress.
	- Jorrit added support for the new sound wrappers in regions.
	- Jorrit changed the loader so that it tries to find the sound manager.
	  If not present the loader will load the sound manager plugin.
	- Jorrit fixed the new sound renderer to use the correct sound driver
	  for the OS by default.
	- Jorrit added a test app for the sound system. Still not functional
	  (work in progress).
	- res fixed some 64bit warnings in sndsys.
	- res added a paragraph about documentation for inherited members to
	  the coding guidelines.
	- res augmented csInitializer to generate a default app ID from the
	  executable name (if possible). Also made csApplicationFramework use
	  this default ID when the user did not set one.
21-Sep-2005
	- res fixed a few warnings in the new sndsys stuff, did some
	  reformatting to better follow the CS coding guidelines (reading
	  recommended) and reduced namespace pollution.
	- Eric Sunshine fixed bug in PCMSampleConverter::ReadFullSample16()
	  caused by unintended multiple evaluation of macro argument during
	  macro expansion.
	- Jorrit replaced a number of 'NULL' usages with '0'.
	- Jorrit cleaned up formatting in the new sound system api docs.
	- Eric Sunshine fixed some additional Jamfile issues in the sndsys
	  hierarchy.
	- Eric Sunshine fixed build errors in the new CoreAudio sndsys driver.
	- res templatized csQint() and csQround().
	- res generasimplifilized SR a wee bit more.
	- res did more namespace pollution reduction of the sndsys stuff.
20-Sep-2005
	- Eric Sunshine resolved a few build-system glitches related to the
	  new sound system (sndsys).
	- Eric Sunshine added a DirectX v8 check to configure.ac.
	- res made some tweaks to configure to detect DirectX 9 properly.
	- res made sndsyswin depend on crystalspace_directx.
	- res fixed odedynam to also support ODE compiled in "double" mode.
	- res fixed some VC double truncation warnings in startme.
	- res further tweaked the configure DirectX check.
	- res did a bit of soft3d simplification.
	- res updated the manual for the new cs-win32libs version.
19-Sep-2005
	- Rhad added initial files for new sound system (SndSys).
	  Jamfiles will be committed this evening.
	- res made a few tweaks to lighter2 to have it work nicely when invoked
	  with .zip files from the command line.
19-Sep-2005
	- Jorrit added iStreamSource interface. This will be used as
	  a generic way to provide faster methods for getting buffers for
	  meshes.
	- Jorrit extended iLoaderPlugin, iBinaryLoaderPlugin, iSaverPlugin,
	  and iBinarySaverPlugin with a parameter for the iStreamSource.
	  None of the mesh loaders currently implement this.
	- Jorrit extended various functions in iLoader with the possibility
	  to give an iStreamSource as a parameter.
	- Jorrit changed iStreamSource to use a callback system for getting
	  the data. This allows for asynchronious reading.
19-Sep-2005
	- Eric Sunshine fixed compilation error in startme.cpp. (bug# 1294906)
	- Adam Bradley added partialorder.h, a generic partial-order graph
	  implementation.  This will be used by the new event scheduler.
	- Adam Bradley re-introduced tree.h.
18-Sep-2005
	- res tweaked "lightmap" & "lookup" texture classes to not do mip
	  sharpening.
	- res fixed the cswinCallStackHelper docs to document 'fast'.
	- res shuffled some more code around in the software renderer.
	- Marten made some more enhancements in the new lighter.
16-Sep-2005
	- Jorrit added a new feature to the terrain engine. Instead of
	  specifying one materialmap to tell the engine what material
	  from the palette to use on a specific spot in the terrain you
	  can now also specify n-1 alpha maps with n equal to the size
	  of the palette. The last alpha map will be automatically
	  calculated so that the alpha's add up to 100%. This technique
	  is a bit more flexible because you can now mix textures
	  on the same spot. Added a new 'terraina' level in CS which
	  demonstrates this feature.
	- Jorrit made the check if a material is used in the bruteblock
	  terrain engine a bit more robust and optimal.
	- Jorrit made thing a bit more robust in pathological polygon
	  cases.
	- res added a "Search" field to the online manual.
15-Sep-2005
	- Jorrit made the infinite maze rooms a bit bigger. That makes
	  collision detection works again so you can walk to the next
	  room. The only thing that remains broken for now is the
	  actual infinite maze generation. The maze is not infinite
	  as it should be.
	- Piotr Obrzut added getters for dynamics system colliders geometry
	- Piotr Obrzut fixed attaching dynamics system colliders to bodies to
	  work better with planes.
	- res added a "Search" field to the online API docs.
14-Sep-2005
	- res made the software renderer support interleaved arrays.
	- mdmkolbe fixed missing CS_REQUEST_PLUGIN in Python Swig bindings
	  reported by Vincent Knecht.
	- mdmkolbe converted CS/plugins/filesys to new SCF.
	- Jorrit removed the obsolete SetDynamicAmbientLight() method in
	  iLightingInfo.
	- Jorrit sanitized the confusing lighting options in genmesh.
	  It is now better documented how exactly the lighting calculation
	  is supposed to take place and it now actually works as documented.
	  The behaviour has changed slightly as compared to before.
	  Here is how it now works:
	    - In all cases the color array from the factory will be added
	      to the colors calculated below.
	    - If manualcolors is enabled then only the optional animation
	      control still matters. No other lighting values are processed.
	    - Otherwise if lighting is disabled then the base color of the
	      mesh will be added to the factory colors.
	    - If lighting is enabled and localshadows is disabled then
	      lighting is calculated as follows:
	        factory colors + base color + static ambient + dynamic
		ambient + lighting as calculated from nearby/relevant lights.
	    - If both lighting and localshadows are enabled then
	      lighting is calculated as follows:
	        factory colors + base color + static ambient + dynamic
		ambient + lighting as precalculated during static lighting +
		dynamic lights
	  This also fixes a bug with genmesh->SetColor() which was not
	  correctly forcing an update of the lighting.
	- Jorrit fixed genmesh so that the color array in the factory is now
	  also initialized to zero (black).
	- Jorrit added a new startme app that is a tool to guide the new
	  CS user through all the demos we have.
	- Jorrit added a binding for 'esc' to walktest so that esc now
	  quits walktest too.
	- Jorrit fixed zbuf issue in walktest -infinite.
	- mdmkolbe converted libs/csgfx to the new SCF.
	- mdmkolbe added in SCF_INTERFACE a check that the interface name is
	  really a type to help catch typos
	- mdmkolbe fixed some arguments to SCF_INTERFACE that weren't types.
13-Sep-2005
        - res reverted the embed.m4 comma removal since it was likely not
          correct.
12-Sep-2005
	- Jorrit fixed the thing plugin so that modification of a thing
	  factory will now immediatelly affect the instances.
	- Jorrit changed cal3d so that iSpriteCal3DSocket inherits from
	  iSpriteSocket now.
	- mdmkolbe fixed a build failure in the Perl Swig bindings.
	- Philip Wyett allowed access to /cache/tmp for lightmap precalc data
	  to be stored and eliminating warning dialog.
	- Philip Wyett updated his email address.
	- Vincent Knecht fixed vfs.cfg.template so that /lev/isomap mount is
	  valid when CS is installed.
	- iceeey fixed a problem with the configure check for embedding of
	  meta information. If elf.h was detected, then the libbfd check would
	  be skipped due to an extra comma in embed.m4.
11-Sep-2005
	- Eric Sunshine fixed problem introduced with recent configure script
	  changes where ELF plugin meta-data reader was not being linked into
	  targets on Unix.
	- Eric Sunshine changed configure.ac so that it only runs the
	  traceback-related libbfd check on Windows since it is only need on
	  that platform for tracebacks. (On Linux, the backtrace() function is
	  used instead.)
	- Eric Sunshine fixed problem where results of multiple invocations of
	  CS_CHECK_LIBBFD() with different contexts could have undefined
	  results.  This fixes problem where libbfd was not considered usable
	  on Windows for backtraces.
	- Vincent Knecht fixed csbench so that shader snippets inclusions
	  work.
	- Vincent Knecht corrected filename extension for python module in
	  python.txi.
	- Piotr Obrzut added method for removing all systems in iDynamics
	- res changed the call stack to at least print the hex address if no
	  symbol name could be resolved for an instruction.
	- Marten converted a few more bits of plgengine to use new SCF syntax.
	- Marten fixed a few typos in applighter2.
10-Sep-2005
	- Philip Wyett fixed some returns in non-void functions.
	- res added file+line numbers for MinGW call stacks.
	- res moved the custom assert into its own source file.
	- Philip Wyett added some experimental gcc 3 and 4 mmx compilation
	  problems fixes for the movierecorder plugin.
9-Sep-2005
	- Jorrit fixed a missing 'break' in the particles loader. This caused
	  using 'mixmode' to give an error even though it worked fine.
	  Also added lots of missing 'return 0' and 'return false' lines
	  after reporting an error.
	- Jorrit fixed a bug in many particle systems. They would 'explode'
	  or behave badly in case the elapsed time was very large. That
	  could happen if you dragged around the CS window for example.
	  The fix is to artifically cap the elapsed time to 200ms.
	- Jorrit fixed addbot command in walktest so that the dynamic light
	  moves with the bot again.
	- Jorrit added csColliderActor->SetCamera() to change the camera.
	- Jorrit fixed split_view in walktest so that it is again possible
	  to toggle keyboard/movement between the two views.
	- Jorrit fixed the explosion particles in walktest so that they
	  are visible again.
	- Jorrit fixed a crash in the engine with some object right on top
	  of a light. This would cause GetBrightnessAtDistance() to be
	  called with distance equal to 0 -> divide by zero!
	- res fixed consoletest to use CS_IMPLEMENT_APPLICATION instead of
	  CS_IMPLEMENT_PLATFORM_APPLICATION (which is really just a subset of
	  what CS_IMPLEMENT_APPLICATION does).
	- res updated include/csutil/win32/.cvsignore.
	- res removed th BFD external lib addition from
	  libs/csutil/win32/Jamfile (since the Win32 part does not really
	  use bfd directly itself).
        - res worked around GCC4 breakage in movierecorder plugin.
	- Eric Sunshine fixed some icky-poo brokeness in embed.m4 which was
	  introduced along with the elf.h handling. It was accessing
	  non-existent shell variables and generally behaving badly.
	- Eric Sunshine removed CS-specific goop from embed.m4 which was
	  introduced with the elf.h handling. In particular,
	  CS_META_INFO_EMBED() had been changed to emit header properties
	  despite the fact that it was not documented as doing so, and had no
	  way of doing so generically. This broke the generality of
	  CS_META_INFO_EMBED() for external projects which do not necessarily
	  need to generate a project header at configuration time.
	- Eric Sunshine refactored embed.m4 a bit so that the exhaustive libbfd
	  check can be re-used by other modules rather than being specific to
	  embedding. It is now named CS_CHECK_LIBBFD().
	- Eric Sunshine removed the recently added libbfd check from
	  configure.ac and replaced it with an invocation of the much more
	  exhaustive and capable CS_CHECK_LIBBFD().
	- Eric Sunshine relocated the user-presented libbfd GPL warning so that
	  it appears after all other output from the configure script in order
	  to ensure that it does not get lost amidst all the other verbosity.
8-Sep-2005
	- res added a libbfd test to configure. bfd is used for some
	  development and debugging aids. Since bfd is GPLed, which can be
	  problematic for external projects, libbfd is only used for debug
	  builds. Also, a message is emitted at the end of configure to inform
	  the user about the fact that bfd is used.
	- res added a (mostly working) libbfd symbol name resolver for Win32.
	  This means that callstacks on MinGW are now actually useful.
	- Jorrit fixed dynavis and frustvis so that they update their internal
	  data structures when the screen is resized. This doesn't fix the
	  culling problems however so there most likely is another place
	  somewhere in the engine where the original size is remembered.
	- Jorrit made the event handler in the engine an internal class
	  of csEngine. This prevents the engine leaking when the engine
	  plugin is going to be removed before the entire system is removed.
	  The reason for the leak is that the engine registered itself in
	  the event queue. This caused an additional ref to it. The leak
	  was not present in normal system shutdown since then the event
	  queue will also be emptied. General rule: ALWAYS make event handlers
	  a separate object.
	- Jorrit fixed a bug in the engine handling of cscmdContextResize.
	  It was only setting 'resize' to true in case the event data was
	  equal to G2D but that didn't appear to be the case. I don't know
	  why that test is there so I simply removed it and now things are
	  working properly.
	- Jorrit added a new method to csKDTree so that the kdtree can ask
	  the user of the kdtree a description of the object. This is used
	  to improve diagnostics when weird things occur in the KDTree.
	  Both in debug and in optimize mode the KDTree will now dump
	  information about what object it is trying to process when something
	  goes wrong. Nearly all CS_ASSERT's have been replaced with custom
	  code that uses the new descriptor. This change should help people
	  who have problems with mysterious asserts in the KDTree code and
	  don't know what object is causing it.
	- res fixed the bfd/win32 symbol resolver to properly support relocated
	  modules.
	- Jorrit changed CS_ASSERT so that it will now show a callstack
	  if available.
7-Sep-2005
	- res added a "callstack" command to walktest. Mainly useful to check
	  whether the callstack facility is working.
	- res fixed a ressource waste in the Thing poly renderer were the
	  normal buffer was recomputed every time needed. This change also
	  works around recent crashes in that module.
	- res fixed a possible crash in engseq.
	- res improved Win32 call stack generation.
	- res added a small helper to measure the time the execution of a
	  block takes.
        - res modularized the implementation of callstack creation.
	- Andrew Dai changed the sliding algorithm to be bounceback based in
	  actor collisions.
	- res changed the docs to point to cs-win32libs 016.
	- res made some small tweaks to the callstack stuff.
	- res made an object registry warning more colorful.
        - res added demangling to the backtrace symbol name resolver.
	- swedishcoder fixed a bug, where an unitilialized variable could
	  cause cegui render to crash at destruction.
6-Sep-2005
	- res fixed a bug in glshader_fixed were the constant color was not set
	  to black when the SV was not found.
	- res fixed compile errors in particles.
	- res made a small iDocument documentation enhancement.
	- res applied some Opcode VC6 compile fixes from Raymond.
	- Jorrit fixed the documentation about efficient textures so that
	  you can actually read the subsections easily.
	- Jorrit added a note to the api docs about the rename of
	  SetLogicalParent().
	- mdmkolbe eliminated some inheritance ambiguity warnings due to
	  inconsistent virtual inheritance from iBase.
	- Eric Sunshine patched cstypes.h so that it looks for int64_t and
	  cousins in <inttypes.h> on platforms which do not have <stdint.h>
5-Sep-2005
	- iceeey fixed memory leak in CEGUI plugin as reported by Eric.
	- iceeey cleaned iCEGUI interface by removing all Get functions
	  returning a reference, as recommended by Eric.
	- iceeey completed CEGUI memory leak fix by making sure all quads were
	  freed in the render list. Also removed duplicate deletion of
	  CEGUI::System singleton in csCEGUIEventHandler::OnUnhandledEvent().
	- Jorrit renamed iMeshObject->SetLogicalParent to SetMeshWrapper
	  (similar for GetLogicalParent). The meshes now store an iMeshWrapper
	  instead of iBase. That avoids a few ugly casts and the need
	  for query interface.
	- Jorrit renamed iMeshObjectFactory->SetLogicalParent to
	  SetMeshFactoryWrapper (similar for GetLogicalParent).
	- iceeey added script support to CEGUI for any language through iScript
	  interface. Some parts are missing.
        - res moved the "polygon renderer" into Thing.
	- iceeey changed license information for CEGUI plugin from GPL to LGPL.
	  Licensing it as GPL was unintentional.
4-Sep-2005
	- Marten fixed master header problem after cegui addition.
	- Piotr Obrzut fixed bug in ODE dynamic system collider when user
	  wanted to add not specyfied collider to space
	- Piotr Obrzut added dynamics system collision callback
	- Piotr Obrzut fixed bug in colliders surface paramters setting
	  (reported by Pablo)
	- Piotr Obrzut fixed bug in trimesh colliders  (reported by Pablo)
	- iceeey activated the CEGUI plugin and ceguitest targets.
	- caedes corrected some issues in the odedynam plugin:
	    - corrected segfault on cleanup: odecolliders ibase was not
	      initialized in constructor and destructor.
	    - added global templates for cs to ode and backrotation matrix
	      assignment, please use them instead of ad-hoc assignments.
	    - moved dGeomTransformSetGeom function to
	      csODECollider::AddTransformToSpace as geoms should not both be
	      added to a transform and to a space.
	    - changed triangle indices order in CreateMeshGeometry (c,b,a to
	      a,b,c).
	    - added transposition to world box colliders as somehow this
	      special case seems to fail. this must be looked into.
	- caedes added some tokens to physldr plugin:
	    - <simulationmode> in <system>, options: worldstep,quickstep,
	    	stepfast
	    - <autodisable> in <system>, bool.
	    - 'cfm' and 'erp' attributes in <system>, float, only for
	      csODEDynamicSystems
	    - 'enabled' attribute in <body>, bool.
	- iceeey added a recent check for CEGUI to the configure script: You
	  must have the latest CEGUI CVS to use the plugin.
	- caedes added ode.h reference and csODE* interfaces to cspace.i.
	- res enabled VC7 project generation for CEGUI (since it will be in
	  next cs-win32libs).
	- res enabled VC project generation for the VOS projects as a
	  convenience - they are not added to any workspace, though.
	- res fixed a csHash<> compile problem on 64bit systems.
3-Sep-2005
	- res removed an #include from tokenlist.h which caused compile errors
	  for some people (since tokenlist.h is intended to be included in
	  places e.g. inside classes).
	- Marten added some more documentation to DocumentHelper namespace.
	- Marten made a few cleanups in csPoly3D.
	- Marten worked a bit more on the new lighter. It can now produce its
	  first output.
	- res fixed xmlread to not crash when an attribute is queried from a
	  non-element node.
	- res fixed a crash when removing meshes from the engine due calling a
	  method of an possibly already deleted object.
	- res fixed a circular reference in fatloop.
	- res changed the shader expressions to take a stack of shader
	  variables at evaluation time, as opposed to a shader var context at
	  parsing time.
	- res made the shader expression SV accessor use the shader manager's
	  "rendering shader variable stack". This means that expressions in
	  SVs can now utilize the variables as at render time.
	- res enhanced vproc_std with the ability to disable select lights.
	- res fixed non-float shader conditional constants to actually work.
	- res changed the shader conditional parser to use isspace() for
	  whitespace checks instead of just a comparison with ' '.
	- res changed xmlshader to also add normals to the default mappings.
	- res changed the replacer document nodes to use refcounting on the
	  given substitutions and also ensure that the attribute pointers
	  don't change over the lifetime of a node.
	- res changed the GL fixed VP to use ProgramParams internally for
	  light parameters (means those are not limited to shader variables in
	  XML) and changed the parameter specification from attributes to
	  child nodes.
	- res changed the FVP "light number" to be the CS light number, not GL
	  light number.
	- res added a number of other FFP light parameters that can be
	  controlled through FVP shader programs.
	- res removed a redundant buffer change from gl3d.
	- res started to work on a shader to mix GL fixed pipeline lighting
	  and SW lighting through vproc_std. Currently supports GL directional
	  lights.
	- res fixed a variable flippage in the spotlight lighting calculator.
	- res augmented FVP for spotlight-related parameters.
	- res changed the engine lights to compute a proper attenuation vector
	  on attenuation changes.
	- res added arcsin, arccos, arctan to shader expressions.
	- res augmented the vproc_fixed shader to also handle point and spot
	  lights (the latter are somewhat off, though, due CS/GL spotlight
	  differences).
	- swedishcoder added a CEGUI renderer for CS, developed by iceeey and
	  swedishcoder. The actual plugin is located in plugins/gui/cegui and
	  the demonstration application in apps/tests/ceguitest In the
	  ceguitest dir you can also find a short howto. Its currently
	  disabled.
	- swedishcoder removed the cegui howto doc, it was outdated, instead
	  take a look at ceguitest app. Thanks iceeey for pointing that out.
	- Marten made some smaller layout fixes to the CEGUI stuff.
	- iceeey added the missing iCEGUI include file and fixed some Jamfiles.
	- iceeey moved the ceguitest data files into CS/data.
	- iceeey added ceguitest and cegui to Jamfiles, but left them
	  commented.
	- iceeey fixed a bug in ceguitest where it would crash when resized.
2-Sep-2005
	- Jorrit fixed a bug in CS reported by valgrind: In the GL state cache
	  a few fields were not initialized in some cases.
	- Jorrit made the csColliderActor a bit more stable at high speed.
1-Sep-2005
	- Andrew Dai fixed an infinite loop when moving using csColliderActor,
	  this was caused by the collision system and FindIntersection tests
	  disagreeing with each other.
	- res made an optimization/fix to sprcal3d: forgot to update a variable
	  that is checked to avoid unnecessary computations.
	- res made some VC6 compile fixes.
	- res ditched the fragile "built-in wchar_t" detection and allowed
	  support for VC's built-in wchar_t by csUnicodeTransform::Encode()
	  and Decode() by utilizing the special __wchar_t type always present
	  on VC7+.
	- res fixed some VC8 warnings in expparser.cpp.
	- res fixed(mostly blindly) some 64bit issues reported by Mike Gist.
	- res renamed iSpriteCal3DState::GetSubmeshSVC() to
	  GetCoreMeshShaderVarContext() (to be a bit more consistent with the
	  remaining methods and to have a bit more vebose name. Also made it
	  actually work.
	- Eric Sunshine added a couple %ignore directives to cspace.i for the
	  non-const overloads of csEllipsoid::GetCenter() and GetRadius() in
	  order to avoid 'method redefinition' warnings from Java.
31-Aug-2005
	- Jorrit added a new system to iObject/csObject so that you can get
	  notified when an object changes name. To do this you have to
	  implement the iObjectNameChangeListener interface.
	- Jorrit fixed the engine to use this new system for sectors,
	  lights, materials, meshes, and mesh factories. That way changing
	  the name of such an object will no longer cause FindByName() to fail
	  (because the internal hash of that list was not updated after the
	  name change).
	- Eric Sunshine added an important note to the CS_IMPLEMENT_FOREIGN_DLL
	  API documentation stating that it is the responsibility of the DLL's
	  author to ensure that the global iSCF::SCF gets initialized within
	  the DLL's context.
	- res changed the Win32 console -> file redirection from appending to
	  overwriting the log file - otherwise, the log will grow uncontrolled,
	  and for troubleshooting purpose a log of the last run is probably
	  sufficient.
	- res fixed a bug in sprcal3d where HitBeam* would crash if the mesh
	  has not been rendered yet.
30-Aug-2005
	- res overhauled cal3d's render mesh code - the original code was from
	  a time when both OR/NR still existed; now, a number of ORisms were
	  thrown out and some NR features are better utilized.
	- res added per-calmesh shader variables to sprcal3d.
	- res made sprcal3d share indices and texture coordinates between
	  mesh objects.
	- Eric Sunshine excluded the special-purpose csutil/win32/psdk-compat.h
	  from the csutil.h master header.
	- res fixed a crash in sprcal3d when a submesh didn't have texture
	  coordinates.
        - res reinstantiated the GLU check in configure since CgGL depends on
          it on some platforms.
29-Aug-2005
	- res made some more compile fixes for Win64, reported by Mike Gist.
	- res added csutil/win32/psdk-compat.h to concentrate Windows Platform
	  SDK smoothing in a single place (previously, certain same workarounds
	  for PSDK version differences have been duplicated in several source
	  files).
28-Aug-2005
	- Philip Wyett moved some declerations to after a goto jump because the
	  code executed after the jump does not require them.
	- res made a few compile fixes for Win64.
27-Aug-2005
	- res added a tad more functionality to the common document stuff.
	- res augmented the shader conditional template support with the
	  ability to substitute strings in the template. The parameter names
	  are a simple space-delimited list after the name, and strings of the
	  form $Foo$ will later be replaced with the string that is passed
	  at the position of the Foo parameter when invoking the template.
	  Silly example:
	    <?template Foo X Y?>
	      <!-- test $X$ -->
	      <?template $Y$ Z?>
		<!-- another test $$Z$$ -->
	      <?endtemplate?>
	    <?endtemplate?>
	  Invokation with
	    <?Foo baz Bar ?>
	    <?Bar moo?>
	  will lead to:
	    <!-- test baz -->
	    <!-- another test moo -->
26-Aug-2005
	- res added a dummy csPlatformMemoryMapping implementation.
	- res converted the canvases to the new SCF.
	- res did a slight reorganization: created a new directory
	  csplugincommon/iopengl for OpenGL interfaces, renamed iogl.h to
	  openglinterface.h and moved it there.
	- res removed the AsciiArt canvas.
	- res updated unix.jam to only use EMBED_META to decide whether
	  metadata should be embedded.
	- res added iGLDriverDatabase to allow clients to provide custom
	  driver databases in addition to CS' default one.
	- res fixed some mistakenly abstract methods in
	  csDocumentAttributeCommon.
	- res bumped the versions of the canvas-related interfaces that now
	  virtually inherit from iBase.
25-Aug-2005
	- res added some tweaks for software GL to the driver database.
	- Adam Bradley fixed a bug in the Linux joystick driver diagnosed by
	  Marc Price <marcymarcymarc@gmail.com>.
	- Jorrit did several cache manager related changes:
	    - Added new iEngine->SetVFSCacheManager() which is a better way
	      to change the cache manager that the engine is using than
	      the current clumsy construct:
	        vfs->ChDir (...);
		engine->SetCacheManager (0);
		engine->GetCacheManager ();
	    - Added iCacheManager->SetReadOnly() and IsReadOnly(). With
	      SetReadOnly(true) you can force the cache to be read only
	      which means nothing can be written to it.
	    - Removed caching of LOD and normal data in spr3d since calculating
	      this is now fast enough (it was optimized several months ago).
	      The cache is no longer needed.
	- Jorrit removed a few warnings:
	    - A few unused camera_origin warnings in spr3d and bezier.
	    - A reordering of initialization in xmlshader plugin.
	    - Unused var in GL renderer.
	    - In xmlshader a non-POD was passed through ... I temporarily
	      disabled that code as I don't know what the correct code is
	      there.
	- Jorrit did a documentation fix: the pixmap howto was not 100%
	  correct.
	- res changed csLoader::ParseTexture() to enforce texture registration
	  by the loader plugin.
	- res fixed the proctex loaders to register the returned texture.
        - res revamped the memory mapping support. The platform-dependent
          memory mapping was merged into csMemoryMappedIO, which is also a bit
          easier to use (notably, you can request blocks of arbitrary size from
          arbitrary offsets) and simplified (thrown out the block cache for
          emulated memory mapping).
        - res added a metadata reader for ELF binaries (that is, embedding on
          systems that have ELF binaries does not need libbfd any more).
        - res adjusted the metadata embedding checks to account for the
          built-in ELF support.
	- res updated the Win32 memory mapping to the new csMemoryMappedIO.
24-Aug-2005
	- res further worked on lighting support for the fat rl and vproc_std.
	- res added the "simplelights.zip" level to test vertex lighting in
	  the fat rl.
	- Philip Wyett eliminated gcc compiler warning in meshmode.cpp.
	- Eric Sunshine fixed the Linux joystick driver so that it only polls
	  the joystick device on cscmdPreProcess, rather than on
	  cscmdPreProcess, cscmdProcess, cscmdPostProcess, and
	  cscmdFinalProcess, since that was unnecessarily expensive.
	- res augmented the XML shader conditionals with support for symbolic
	  constants to facilitate passing enums etc. from code to shaders
	  (e.g. "<?if vars.someVariable.int == consts.CS_ATTN_NONE?>").
	- res added an int8 etc redefinition (equivalent to the redefinition
	  formerly done in ivaria/ode.h) to odedynam since this is needed on
	  some platforms.
23-Aug-2005
	- Erroroman added "start", "end" and "mode" params to csFog struct.
	- Erroroman added support in csloader for the new fog params.
	- Erroroman added shader variables for new fog params in generic
	  renderloop.
	- Erroroman fixed error in glshader_fixed where wrong parameter was
	  used when loading fog color.
	- Erroroman adopted OpenGL fog in glshader_fixed to use data from
	  csFog. At the moment "mode" is not usable because it is not a shader
	  variable and it can't use mode from csFog. There is still work to get
	  working OpenGL fog as standard CS fog.
	- res removed the dependency of ivaria/ode.h on <ode/ode.h>.
	- res tweaked the fat loop and vproc_std a bit; runs flarge okay now.
	- Peter Amstutz added a new method iVosA3dl to allow fetching the
	  iVosObject3D wrapper for a Vobject given the VOS URL path.
21-Aug-2005
	- res moved csLightShaderVarCache to csgfx.
	- res changed the vertex light calculator to not use iLight* but a
	  struct with the relevant light properties.
	- res changed vproc_std to pull the light information from shader vars.
	- res added some more options to vproc_std.
	- res added some more fat rl tests.
	- res worked around some warnings on VC8.
20-Aug-2005
	- res fixed potential buffer overflows in TinyXML and xmlread, spotted
	  by forum member 'dominic'.
19-Aug-2005
	- Jorrit fixed the rain plugin so that it is possible to query the
	  iParticleState from it. Thanks to 'SR' on the forums to find this.
18-Aug-2005
	- Jorrit added a minimum/maximum range for a mesh object. Outside that
	  range the object will not be rendered. The maximum distance can be
	  used to hide small detail objects that are too far away to matter.
	  The minimum distance can be used to bring in an imposter mesh that
	  replaces a number of smaller objects (which are then removed with
	  the maximum distance). You can set mininum/maximum distance with a
	  constant distance value or else with variables. Using variables gives
	  greater flexibility as you can then control the distance in a setup
	  program (even at runtime). The syntax in a map file is as follows:
	    <meshobj name=...>
	      <params> ... </params>
	      <minrenderdist value="5" />
	      <maxrenderdist var="Test Max Dist" />
	    </meshobj>
17-Aug-2005
	- Eric Sunshine fixed csutil and csgeom unit tests so that they compile
	  successfully again following recent SCF re-engineering.
16-Aug-2005
	- res made some more Doxygen fixes and also expanded the Doxygen info
	  in the coding guidelines a bit.
	- res added Doxygen documentation for the master headers.
	- Vincent Knecht applied mdmkolbe's fix to perlpre.i. This resolves
	  swig errors about _wrap_* functions.
	- res augmented the fat renderloop with the ability to basically render
	  different lights with different shaders. The lights relevant to a
	  mesh are determined and rendered in the quantities and limits given
	  by user and user-specified shaders.
	- res added csShaderVariable::SetName().
	- res added csShaderVariableContext::Clear() and ReplaceVariable().
	- res made csBitArray::SetSize() public.
	- res added csBitArray::GetSize().
	- res changed some more Doxygen comments.
15-Aug-2005
	- res added a hopefully helpful message that is written to the console
	  when csInitializer cannot load the VFS plugin.
	- res dropped "WARNING: " from a couple of messages reported by the
	  plugin manager, as csReport() can add that, too.
	- res made some misc Doxygen fixes.
	- res enabled sorting for Doxygen brief docs.
	- res fixed some GCC complaints in the lighter apps and the document
	  helpers.
	- res made some VC6 compile fixes.
	- res fixed the glshader_fixed plugin for the STANDARD_LIGHT changes.
	- res made csGLGraphics3D::SetMixMode() disable alpha testing.
	- Marten added a fugly hack to SCF to allow querying of
	  base-interfaces.
14-Aug-2005
	- mdmkolbe fixed a divide by zero error in the collider.
	- mdmkolbe removed redundant statements in the python tutorial1.
	- res fixed a couple of Doxygen warnings.
	- res added a "local" flag to csGetPlatformConfigPath.
	- res changed clarified the csUnicodeTransform docs a bit by using
	  'code point' or 'code unit' instead of 'character' where appropriate.
	- res fixed the csShaderVar copy ctor to properly set the pointer
	  members to 0.
	- res changed the names of the "STANDARD_LIGHT_0_FOO" shader variables
	  to "light 0 foo".
	- Marten committed recent work to the lighter. It is right now added
	  as lighter2 but later it will replace the current ligter. Also
	  applied older changes to old lighter.
	- Marten added two helpers which operates on iDocument* structures
	    - RemoveDuplicateChildren method which removes children of a given
	      node which are considered to be duplicates.
	    - FilterDocumentNodeIterator which works as a wrapper around a
	      iDocumentNodeIterator but filters the returned nodes.
	  Both these work with a templated functor as argument to work out
	  which nodes are to be removed/returned.
	- Marten added a iDocumentNode::RemoveNodes (iDocumentNodeIterator*)
	  which removes all child-nodes returned by a given iterator.
13-Aug-2005
	- Peter Amstutz applied a couple of fixes to csThing to prevent
	  crashing when a lightmap is present but uninitialized
	  (which comes up when reading/writing lightmap caches)
12-Aug-2005
	- res added support for spr3d and Thing meshes to the importkit.
	- res applied some compile fixes from mafm.
	- mdmkolbe replaced yesterday's temporary SWIG workaround with a better
	  solution.  Again the Java and Perl bindings were done blind.
11-Aug-2005
	- mdmkolbe cleaned up SWIG to be a bit more type-safe.
	- mdmkolbe changed GetChild in iObject and csObject to return
	  iObject* instead of void* in order to make the SWIG cleanup possible.
	- dfryer changed VFS to expand paths when unmounting paths, instead of
	  only when mounting.  This had caused some inconsistancy.
	- res changed the way static plugins are registered. Previous, they
	  were registered with SCF upon module loading; however, this has the
	  problem that when SCF was shut down, the static plugins were
	  unregistered, but there was no way to re-register them - restarting
	  a statically linked binary was not possible. Now, the static plugin
	  registration information is stored upon startup and scanned every
	  time SCF is initialized, allowing re-registration of them when SCF
	  is restarted.
	- res changed some symbol names in aws2 to prevent symbol name clashes
	  when doing static linking.
	- res made the engine more forgiving(ie not crashing) in case the
	  shader compiler plugin is not found.
	- mdmkolbe refactored some of the SWIG stuff.  The changes to the
	  Java and Perl bindings were done blind and will need to be checked.
	- mdmkolbe added a temporary workaround for %rename placement
	  issues in SWIG.
10-Aug-2005
	- Jorrit fixed the java scripting module in a similar way as how
	  the python module was fixed.
8-Aug-2005
	- Jorrit added a rule to disable texture_rectangle extensions on
	  GF4Go/MX type cards.
	- Andrew Dai made the collision response system in csColliderActor
	  act correctly and fixed an occasional crash in AdjustForCollisions().
	- Marten made a fix to SWIG interface files. Python bindings now works
	  and the sample pyhton files in scripts\python works. Similar fixes
	  are probably needed for java and perl.
6-Aug-2005
	- Jorrit fixed odedynam so it compiles.
	- Jorrit again reverted Piotr's changes to odedynam. They cause
	  phystut to crash. Please commit back the changes after making
	  100% sure they are ok.
5-Aug-2005
	- res made adjustments for the latest cs-win32libs.
	- Jorrit reverted Piotr's changes to ODE physics plugin completely
	  since they totally break it.
	- Mark Sanders fixed a bug with mousewheel wich gave wrong coordinates.
	- res added the "import kit", a wrapper around the loader and mesh
	  factory interfaces to provide an interface for external applications
	  to obtain CS mesh data without much interface juggling. Currently
	  supports simple genmeshes, though support for Things is planned.
	- res added a method to csVfsDirectoryChanger that just pushes the
	  current directory (useful when some "custom" directory changing
	  should be done).
	- res deprecated csStrKey.
	- res simplified some code in glwin32.
	- res fixed cases where SCF factory creation function prototypes didn't
	  match scfFactoryFunc.
4-Aug-2005
	- Jorrit added support for genmesh/submeshes also to factories.
	  The optional submeshes defined in the instance will override
	  the submeshes from the factory (if present).
3-Aug-2005
	- Peter Amstutz added support for csColliderActor to the csvosa3dl
	  plugin
	- Jorrit removed a few unneeded things from csMeshWrapper (like
	  the unused flag to cast hardware shadows and the old renderer
	  functions to draw meshes).
	- Jorrit changed reflect.xml and reflectsphere.xml so that they
	  support objects with mixmode add/alpha/... Changed the teapot
	  in flarge to use add mixmode.
	- Eric Sunshine changed the check for buggy -finline-visibility-hidden
	  in configure.ac so that it merely disables the option entirely for
	  AMD64 since the old test (checking for link error when manipulating a
	  std::basic_string<>) apparently did not catch every buggy
	  installation. For now, this option is disabled for every gcc version
	  on AMD64. If we later find out that it only impacts certain versions,
	  such as 3.4.x and 4.0.x, then we can tighten the heuristic to disable
	  it for only those versions. Alterately, if we can find a reliable way
	  of testing (something along the lines of std::basic_string<>), then
	  we can instead apply that approach.
	- Peter Amstutz applied fixes to iXWindow, iWxWindow and the VOS
	  interfaces to compile with the new SCF implementation
	- Peter Amstutz fixed csThing so that it invalidates the bounding
	  box when HardTransform() is called
2-Aug-2005
	- Marten converted csSector to new SCF implementation.
	- Marten fixed some issues in the plugin loader and object registry
	  caused by the new template interface functions.
	- Jorrit added functions to iLoader to load images and textures
	  from a buffer (iDataBuffer) instead of a filename.
	- Piotr Obrzut added interface which allows to operate on dynamics
	  system colliders more directly
	- Piotr Obrzut added method generating sphere for genmesh (copied
	  from ball mesh)
	- Jorrit added a new data/shader/reflectsphere.xml shader which is
	  like reflect.xml but instead it uses spherical mapping (not
	  cubemap).
	- Jorrit changed the teapot to use reflectsphere. Also moved the
	  teapot to a more visible location.
	- Marten cleaned up scf_implementation.h and removed the paritial
	  connection to csRefTracker. It needs to be done properly.
	- res fixed a size_t vs int warning in AWS.
	- res renamed the DEBUG_BREAK macro to CS_DEBUG_BREAK.
	- res removed the ASSERT, VERIFY_SUCCESS and VERIFY_FAILURE macros from
	  the Win32 csosdefs.h. They were not used (except one place) in CS
	  itself and could interfere when CS was embedded.
	- Jorrit added support for overriding of mixmode in submeshes of
	  genmesh. The loader also supports this now.
	- Marten fixed some more leaks introduced by changes to plugin loader.
1-Aug-2005
	- Jorrit added a missing include to ref.h.
	- mdmkolbe fixed some Swig issues with the new SCF, but more remain.
	- mdmkolbe converted CS/libs/csgeom/ to the new SCF implementation.
31-Jul-2005
	- Peter Amstutz updated the csvosa3dl plugin to compile again
	  with the recent changes made in SCF and CS headers
	- Marten fixed a few bugs and compilation errors in the new SCF
	  implementation.
	- Marten rewrote the plugin loader and object registry to play nice
	  with virtual and/or multiple inheritance.
	- Marten converted csEngine, csLightIt and a few other classes to
	  use new style SCF implementation. Also converted a few interfaces
	  to the new syntax.
	- Marten made some general cleanup of iEngine and csEngine.
30-Jul-2005
	- mdmkolbe added the csQueryRegistry family of helper functions and
	  defined CS_QUERY_REGISTRY et al. in terms of them.
29-Jul-2005
	- Jorrit fixed the light movable->MovePosition() so that it doesn't
	  notify the light listeners anymore. This is done in UpdateMove().
	- Jorrit fixed a problem in odedynam, AttachColliderMesh(). It would
	  crash on empty meshes.
	- res excluded csutil/scf_impl.h from the master headers.
	- Eric Sunshine fixed cssysdef.h so that it again works on MacOS/X.
	- Eric Sunshine eliminated compilation warnings in the custom cursor
	  plugin.
	- Marten cleaned up the new SCF implementation a bit. It is now split
	  in several headers to later allow fewer header-in-header includes.
	  Also using new macros for querying interface, and SCF_VERSION.
	- Eric Sunshine augmented the Python configure check in checkpython.m4
	  so that it adds -L directives to PYTHON.LFLAGS only for directories
	  which actually exist. This eliminates annoying warnings from the
	  MacOS/X linker which complains about non-existent directories
	  specified via -L.
28-Jul-2005
	- mdmkolbe fixed some more fallout from the include cleanup.
	- mdmkolbe fixed some pedantic issues.
	- Jorrit fixed a bug in libs/csutil/documentcommon.cpp. Was using
	  %g for an int.
	- Jorrit changed csColliderActor to have default 9.81 gravity.
	- Jorrit added SetRotation/GetRotation to csColliderActor.
	- Jorrit added SetCD/HasCD to csColliderActor.
	- Jorrit changed walktest to use csColliderActor. This greatly
	  improves readability of the movement system. In addition the
	  handling of disabling gravity, fine tuned movement (ctrl key),
	  and disabling collision detection has also improved.
	- mdmkolbe began implementing CSEP 10: Templated implementation of SCF.
	- mdmkolbe fixed unused parameter warnings in the include directory.
	- res changed the way the clipping rectangle is saved/restored in the
	  framebuffer r2t support. It is now saved/restored when the render
	  target is set/cleared instead of BeginDraw()/FinishDraw(). This works
	  around problems were the clipping rect was restored but the viewport
	  was not yet, causing the clipping to be wrong.
	- res changed csVFS::ChDirAuto() to check whether a file is a .zip by
	  looking at ist content, not it's name.
27-Jul-2005
	- res added support for "templates" to the XML shader conditions.
	  You define them with "<?template SomeTemplate?> ... "<?endtemplate?>"
	  blocks and later invoke them with "<?SomeTemplate?>", which is
	  replaced by the document nodes that appear in the earlier definition.
	- Marten cleaned up some header-in-header includes. More work needed
	  when someone have time.
	- Marten deprecated csPoint and FastSqrt. Use csVector2 resp sqrtf
	  instead.
	- Marten removed some left-overs from terrfunc (since long removed).
	- res added some partial iDocument* implementations with commonly
	  duplicated code to facilitate creation of new iDocument*
	  implementations.
	- res fixed some fallout from the include cleanup.
	- res worked around namespace clashes of the Opcode in CS with the
	  Opcode in ODE.
25-Jul-2005
	- mdmkolbe removed an unused local variable.
	- mdmkolbe added CS_PRIn64 macros for passing to csPrintf et al, and
	  fixed the PRIn64 macros to be more correct.  Places that needed
	  to be using CS_PRIn64 were changed to use it.
	- res fixed the CS_LONG_SIZE to 4 for MSVC.
	- res added MSVC-specific PRIn64 macros (which employ the I64 format
	  modifier as used by the VC runtime).
	- res changed the provided (u)intptr_t type to be dependent on the
	  processor size (ie is 64 bit wide on 64 bit machines).
	- res added provision of PRInPTR macros to csdef.h.
24-Jul-2005
	- Jorrit added a csEllipsoid class which is a variant of
	  csSphere that has a vector as a radius.
	- Jorrit added new versions of the following functions so that they
	  return their result with 'return' instead of a reference parameter.
	  This is a lot easier to use in scripting languages like Java:
	      - csColliderHelper::TraceBeam (returns csTraceBeamResult)
	      - iCamera->Perspective
	      - iCamera->InvPerspective
	      - iMeshWrapper->HitBeamBBox (returns csHitBeamResult)
	      - iMeshWrapper->HitBeamOutline (returns csHitBeamResult)
	      - iMeshWrapper->HitBeamObject (returns csHitBeamResult)
	      - iMeshWrapper->HitBeam (returns csHitBeamResult)
	      - iMeshWrapper->GetRadius (returns csEllipsoid)
	      - iMeshWrapper->GetWorldBoundingBox
	      - iMeshWrapper->GetTransformedBoundingBox
	      - iMeshWrapper->GetScreenBoundingBox (returns csScreenBoxResult)
	  Many (but not all) of the old versions have been marked as
	  deprecated.
	- Jorrit clarified a few api docs.
	- Eric Sunshine added %ignore directives to cspace.i for the older
	  methods HitBeamBBox(), GetRadius(), Perspective(), etc., which were
	  not scripting language-friendly.
	- Vincent Knecht added the "DejaVu" TrueType fonts to the list of
	  files to be installed. Also modified vfs.cfg.template accordingly.
	- res added a 0 check to csMeshFactoryList::FindByName() to avoid a
	  crash when a 0 mesh name is passed.
	- res fixed invalid usage of csStrNCaseCmp() in
	  csString::CompareNoCase (const char* iStr).
23-Jul-2005
	- mdmkolbe added a default radix of 10 to csPrintFormatter::OutputUint.
	- mdmkolbe changed csPrintFormatter::Format to call OutputUint instead
	  of OutputInt for size_t arguments.
	- mdmkolbe fixed some 'void format' warnings in AWS.
22-Jul-2005
	- mdmkolbe removed extraneous semicolens, commas, and qualifiers
	  found with '-ansi -pedantic'
	- mdmkolbe replaced some instances of __int64 with int64.
	- Piotr Obrzut added plane collider parsing to csPhysicsLoader
	- mdmkolbe replaced some instances of 'long long' with 'longlong'
	  and 'unsigned long long' with 'ulonglong'.
	- res removed or conditionalized some superfluous configure check
	  (e.g. we don't use GLU or GLUT, no point to check ALSA on Win32, ...)
	- mdmkolbe fixed non-ISO complient anonymous structs.
21-Jul-2005
	- mdmkolbe fixed a few more warnings in gcc with the '-W -Wall' flags
	- Jorrit added a section to the docs about sprite sockets. Also did
	  a small correction to the sound section.
	- Eric Sunshine fixed several logic flaws introduced by the recent
	  `-W -Wall' changes.
	- Eric Sunshine fixed broken initialization loop in
	  CreateIdentityPalette() in the Windows OpenGL canvas. Reported by
	  Michael D. Adams.
	- Marten added a system for handling of official enhancement proposals
	  within CS. System called CSEP, derived from Pythons PEP.
	  Supportfiles to convert the text source to html as well as a few
	  initial CSEPs have been added.
20-Jul-2005
	- Jorrit made csColliderActor more robust by checking if the other
	  mesh has a collider.
	- Jorrit added SetOnGround() method to csColliderActor.
	- Jorrit added a small note to the csColliderActor documentation
	  about having to call Move() every frame.
	- Jorrit added the ability to csColliderActor to use a camera instead
	  of a mesh.
	- mdmkolbe fixed SWIG warnings related to functions with default
	  arguments getting shadowed.
	- Jorrit fixed a bug in csColliderActor. It was ignoring speed.
	- Jorrit made csColliderActor a bit more robust.
	- Jorrit changed simpmap so that it uses csColliderActor.
	- Jorrit fixed csColliderActor so that it works better for camera
	  (supports tilting up/down of camera and also rotation around
	  z vector).
	- mdmkolbe put an #ifdef guard around a MSVC only #pragma
	- Eric Sunshine eliminated compilation warning in csShaderVariable
	  copy constructor.
	- mdmkolbe fixed several warnings in gcc with the '-W -Wall' flags
19-Jul-2005
	- Jorrit removed the unused GetVisibilityNumber/SetVisibilityNumber.
	- Jorrit fixed the thing plugin so that it does a small correction
	  on lightmap coordinates for impossibly thin polygons. That prevents
	  the GL renderer from crashing on those.
	- Jorrit added a new csColliderActor class. This class handles
	  basic actor collision detection with gravity and sliding with
	  walls. Using it is very easy (and documented in the manual).
18-Jul-2005
	- Eric Sunshine resolved circular inclusion of event headers. Also
	  fixed a few other compilation errors and warnings.
	- Eric Sunshine performed some minor textual cleanup of the AWS2
	  sources: added copyright notices, added missing end-of-file
	  line-terminators, removed errant semi-colons.
	- Eric Sunshine fixed various gcc4-related build problems.
	- Jorrit fixed a bug in the plugin manager that was recently
	  introduced in the rename of iConfig to iPluginConfig.
	- Jorrit converted the following classes in CS so that they no longer
	  use embedded interfaces:
	    - csCamera
	    - csMeshWrapper
	    - csSector
	- Jorrit converted most of csThing so that it no longer uses
	  embedded interfaces.
	- Christopher finished some changes in AWS2 regarding the conversion
	  from std::string to csString.
	- Christopher also added a constructor to csString (and it's parents)
	  allowing it to construct from a C-string and length, instead of just
	  a string.
	- Erroroman made many fixes in genmesh skeletal animation plugin:
	    - time operations and delays are fixed.
	    - "translate" tag is removed from animation script.
	    - added attribute "type" which can be "rel" or "abs" for
	      absolute or relative transforms. If "type" is not defined
	      transformation is absolute.
	    - added tag "loop" for animation script and attribute "times".
	      If "times" is defined animation will stop after repeating
	      defined times.
	    - added attribute "duration" in "frame" tag.
	    - added "repeat" attribute in "frame" tag. It defines how many
	      times frame exists in loop animation.
	    - added "always update" tag in the script definition.
	    - added "bones" and "vertices" tag in always update definition.
          These tags defines how animation updates if mesh is not visible.
	    - adopted all animations to the new syntax.
	    - added offset transform in bone->SetRigidBody. It defines how
	      bone is transformed to the rigid body - this helps for accurate
	      ragdoll physics.
	    - added function GetAnimatedVertices and GetAnimatedVerticesCount
	      in the animation control interface.
	- Erroroman fixed error in stencil2 plugin where it used wrong
	  clipping plane.
17-Jul-2005
	- Eric Sunshine added forward declaration of struct WrapperStackEntry
	  to xmlcompiler/docwrap.h in order to pacify gcc4.
	- Jorrit fixed a bug (as directed by res2k) in csSet.Delete() which
	  would fail for deleting the 0 element.
	- res made the 'length' parameters of csString::SubString() and Slice()
	  optional (symmetrical to the recent scfString changes).
	- res moved the AWS2 'autom' namespace into a namespace 'aws'.
	- res changed the AWS2 aws::autom::iObject interface to better conform
	  to interface guidelines. Particularly, the method names have been
	  changed to CS style, and strings are passed as iString pointers/refs
	  (since the interface will be used in cross-plugin scenarios).
	- res changed internal strings in AWS2 to be stores as csString instead
	  of scfString, mostly because csString has operator<, but scfString
	  doesn't. Also, scfString is mostly a wrapper around csString, so the
	  latter is a bit more lightweight.
	- res renamed the 'iConfig' interface to the more appropriate
	  'iPluginConfig'.
	- res fixed some float truncation warnings on VC in phystut.
16-Jul-2005
	- Eric Sunshine upgraded the MSVC project files to use wxWidgets 2.6.1
	  rather than 2.4.2.
	- res fixed the sector mesh transformation saving in cssaver as
	  reported by Spin.
15-Jul-2005
	- res separated the cs-win32libs detection into its own .m4 file for
	  easier reuse in external projects.
	- Jorrit fixed a bug in iEngine->CreateMeshFactory(classId,name).
	  It would set the name directly on the iObject AFTER adding the
	  factory to the list. This caused the hashmap in the factory list
	  to be invalid for this entry. So FindByName() wouldn't work.
	- Piotr Obrzut fixed his shameless error (he forgot about setting stops
	  and motors for universal joint)
14-Jul-2005
	- Jorrit added a small section about how to draw text to the
	  documentation.
	- Piotr Obrzut fixed a bug in stops/motors methods in ODESliderJoint
	- Jorrit did a big stability fix to the phystut app. Apparently
	  ODE doesn't like it if it is called with variable steps. The phystut
	  app normally calls ode->Step(delta) with delta constant. However
	  there is always a remaining part of the elapsed time that was also
	  done. This could cause instability. To fix this, instead of doing
	  the remaining part immediatelly we store it in a class variable
	  and add it to the elapsed time the next frame. That way we are sure
	  that we always do steps that are exactly 'delta' big but our physics
	  simulation speed is still independent from the framerate. This helps
	  a great deal with stability.
	- Jorrit documented the best way to do physics step simulation in the
	  manual.
        - res changed the framebuffer GL render-to-texture backend to draw
          "persistent" render targets without filtering to fix smearing
          occuring on some hardware.
13-Jul-2005
	- Jorrit optimized csXRotMatrix3, csYRotMatrix3, and csZRotMatrix3
	  by avoiding unneeded extra calls to cos and sin.
12-Jul-2005
	- Eric Sunshine fixed several compilation errors in the aws2 plugin.
	- Christopher Nelson made many changes to AWS2, but since it's a
	  developing plugin he won't detail all of them here.  He will simply
	  note that AWS2 can now load XML definition files.  He also made
	  changes to the awstest application to allow it to provide a testing
	  framework for AWS2.
	- Christopher Nelson "fixed" the API issue regarding len=0 vs.
	  len=(size_t)-1 in scfString.
11-Jul-2005
        - Christopher Nelson made the following AWS modifications:
	    - Changed the header guard name, added some checks to the headers
	      to make sure they're not accidentally BOTH being included.
	    - Made massive changes all over, replacing std::string in many
	      cases with scfString.
        - Christopher Nelson changed scfString so that it has automatic
	  variables for start and len, and added single character append
	  functions.
        - Christopher also added scfString::ReverseSlice() and
	  ReverseSubString(), which are just like their non-reversed
	  counterparts except that the offset for the start parameter is
	  counted from the end.
	- Eric Sunshine added missing forward declaration to cseventq.h which
	  is now needed on account of (nasty) circular inclusion between
	  cseventq.h and csevent.h. :-(
10-Jul-2005
	- Peter Amstutz committed a fix to csQuaternion where initializing
	  it with an identity matrix could cause a divide by zero.
	- Eric Sunshine augmented the Windows joystick driver so that it
	  supports any number of axes rather than being hard-coded for only
	  two.  Also fixed bug where it performed an excessive amount of work
	  per poll.
9-Jul-2005
	- Jorrit added a section about binary XML to the manual.
8-Jul-2005
	- res added the "DejaVu" TrueType fonts. They're based upon the "Vera"
	  family (and shares its liberal license), but features additional
	  non-Latin glyphs.
	- res added some more information to the "alpha" manual page.
	- res adapted the "Efficient Textures" article from the community site
	  for the manual.
	- res made the DDS loader check for the DDSCAPS2_VOLUME flag not only
	  when DDSCAPS_COMPLEX is set, as some files (as reported by Bedrich
	  Zaba) have the former, but not the latter set.
	- caedes added iCommandLineParser and iSoundListener to cspace.i
6-Jul-2005
	- Eric Sunshine updated numerous "Linux" references throughout the
	  project to "GNU/Linux" in order to avoid perpetuating the myth that
	  Linux somehow exists as a full operating environment without the aid
	  of all the GNU-supplied utilities.
	- Eric Sunshine fixed a bunch of image references (via @picture{}) in
	  the Texinfo sources for the CS manual which broke when the
	  documentation was reorganized on 1-Jul-2005.
	- res updated the "external libs" manual page for the new cs-win32libs
	  release.
5-Jul-2005
	- Piotr Obrzut fixed creating/removing of *strict ode joints*
	- Piotr Obrzut added creating function for ode slider joint in cs
	- Peter Amstutz added Get/SetContactMaxCorrectingVel() and
	  Get/SetContactSurfaceLayer() to iODEDynamicSystemState
	- Peter Amstutz committed preliminary physics support in the
	  csvosa3ld plugin (via the ODE plugin) (currently disabled)
	- res fixed an errorneous private inheritance in odedynam.
3-Jul-2005
	- Piotr Obrzut added pop dir on every return path in ParseShaderList
	  in csparser
	- Piotr Obrzut fixed error on reloading cal3d sprite in viewmesh
	- res added csVfsDirectoryChanger, a helper to automatically restore
	  the previous VFS working directory when changing it is required.
	  Made it used by some code that did PushDir()/ChDir()/PopDir()
	  manually.
	- res fixed some aws2 compile errors.
2-Jul-2005
	- Marten did a major cleanup of cstool/pen.h and pen.cpp.
	- Marten removed aws2.h from the master headers for time being. It
	  is broken and incompatible with aws.h
	- Marten did a few asorted fixes:
	    - Added a SetOrigin to csPlane3; It moves the plane so it goes
	      through a given point.
	    - Added a method to csPoly3 to get the main axis of the normal.
	    - Added another constructor and a copy constructor to csVector2
	    - Fixed spelling in job.h
	    - Fixed unittest application generated by jam.
	    - Fixed the pathlist unittest to accualy work on win32.
1-Jul-2005
	- Jorrit did the first phase of the new documentation. All
	  documentation has been moved to a new location. Note that there is no
	  new documentation yet. Everything is still there. Just at other
	  spots.
	- Jorrit did some extra documentation changes:
	    - Changed structure of sprite3d animation chapter.
	    - Replaced old email with jorrit.tyberghein@gmail.com
	    - Added two sections about Blender and 3DSMax.
	- Jorrit did some extra documentation changes:
	    - Fixed a few outdated references.
	    - Added a new lighting section in usingcs and moved a few
	      other documentation parts there.
	    - Moved some other stuff around.
	- Jorrit moved a few howtos to more appropriate places in the
	  documentation.
	- Jorrit fixed the thing mesh object explanation. Things don't support
	  portals anymore.
	- Jorrit fixed lots of outdated information in the docs.
	- Jorrit added a new materials section and an explanation on alpha
	  textures.
	- Jorrit did some index related changes to the docs.
	- res made the jamtemplate-generated application code use
	  csApplicationRunner<>.
	- res fixed a compile problem and csRef<> deletion (don't do that!) in
	  the AWS XML definition parser.
	- res made all OpenGL drivers from "Microsoft" on Win32 be considered
	  as non-accelerated (since it's either software GL or the sucky
	  Direct3d OpenGL).
	- Jorrit did more documentation stuff. Added some information about how
	  to play sounds and fixed a few things.
	- res fixed the walktest Jamfile to generate a proper walkall compile
	  group for VC6.
	- Eric Sunshine moved the RepairNodes rule from docs/texinfo/Jamfile to
	  docs.jam so that it can be used by external projects.
30-Jun-2005
        - Christopher added in the code that he's building back up for AWS2.
          Starting from the original AWS code, and breaking it in a big way.
        - Christopher also added a vector-pen class that can draw various
          2D shapes using the 3D engine.  Currently this does not include
          circles because I have to think about a good way of dealing with
          resolution issues.
        - Christopher added a Raw() getter to csArray in order to get a raw
          buffer which can be passed to the renderer.
29-Jun-2005
	- Eric Sunshine applied a patch to texi2html.pl which allows it to work
	  on Windows by avoding dependence upon the Unix-specific external
	  `pwd' command.
	  https://texi2html.cvshome.org/servlets/ReadMsg?list=dev&msgNo=538
	- Eric Sunshine fixed a few problems afflicting `jam manualinfo' on
	  Windows on account of the somewhat old MSYS `makeinfo'.
	- Eric Sunshine worked around bug in some version of gcc where it
	  complained about one-liner expression in csRedBlackTree::GetColor(),
	  saying that it could not convert Node* to NodeColor.
	- Eric Sunshine modified (hacked) the RunMakeInfo action in docs.jam to
	  work with `makeinfo' 4.2 which ships with MSYS and which does not
	  respect -I (search path) for @image{} directives.
25-Jun-2005
	- Marten fixed a transformation bug in software renderer. The direction
	  / names of transforms needs to be checked at some point (they are
	  probably not correct).
24-Jun-2005
	- Jorrit did a big optimization to genmesh objects that don't use
	  localshadows (i.e. meshes that calculate vertex lighting). These
	  meshes used to calculate lighting again and again every frame
	  even if the lighting conditions didn't change. This is now fixed
	  so that lighting is only recalculated if needed. This optimization
	  is even more worthwhile when you are using submeshes in genmesh
	  because then this lighting would have been recomputed every
	  frame for every submesh (and it would calculate the entire mesh
	  for every submesh anyway).
23-Jun-2005
	- Piotr Obrzut applied fixed fix for get/set transform methods applied
	  before by Erroroman
	- Eric Sunshine eliminated several compilation warnings.
20-Jun-2005
	- mdmkolbe fixed segfaults on exit under Cygwin due to static local
	  variables in functions.
	- res changed TinyXML to write a text node out as CDATA when the value
	  contains CRs or LFs.
	- res cleaned up the shader conditional code a bit and also made the
	  various debug dump options toggleable through the configuration.
	- res made the Cg VP support save a program loading.
18-Jun-2005
	- Jorrit added csColor4 support to genmesh (pretty much untested).
	  That means that mixmode alpha should now work again and it should
	  now also be possible to set alpha per vertex.
	- res disabled NPOTS textures for ATI hardware, as, at the moment,
	  support for it seems to be suboptimal there. (Actually, we should
	  collect some information on how well NPOTS textures work on various
	  ATI hardware versions... based off the little information I got it
	  seems that NPOTS isn't that great on any ATI.)
	- res fixed the walktest logo pixmap creation to not set the renderer
	  dimensions (as really the original dimensions are wanted for
	  coordinate computations etc.)
	- res added support for a "hidden" feature on ATI drivers were NPOTS
	  2D textures can be used (which is also a bit better than RECT on ATI
	  hardware). Still disabled though.
	- res removed the CS_FX_ALPHA hacks from genmesh and spr3d since they
	  aren't needed any more.
	- res added csVector4::Description().
	- Jorrit fixed an initialization bug in sprcal3d with dynamic_ambient.
	- res added fog support to the fat rl.
	- Marten added some more features to the new lighter. Still not close
	  to functional.
17-Jun-2005
	- Jorrit seperated per-sector dynamic ambient from per-object
	  dynamic ambient. Previously if you called
	  sector->SetDynamicAmbientLight() then it would loop over all
	  mesh objects and call SetDynamicAmbientLight() on each mesh object.
	  This is not efficient. Instead the mesh object itself goes to look
	  at the current ambient level of the sector and keeps a counter
	  to check if the ambient level changed. In addition the
	  SetDynamicAmbientLight() in mesh object is reused for mesh object
	  local dynamic ambient that is added to the sector dynamic ambient.
	- Jorrit fixed the bezier curve so that it honors dynamic ambient.
	- Jorrit fixed genmesh so that it honors dynamic ambient.
	- Jorrit cleaned up two big unused UpdateLighting() routines in
	  sprcal3d.
	- Jorrit implemented local dynamic ambient in sprcal3d.
	- Jorrit implemented local dynamic ambient in bruteblock.
	- Jorrit fixed a note with iEngine->CreateTexture().
	- res removed the CS_FX_ALPHA check hack(s) from csfxscr.cpp since
	  they aren't needed any more.
	- res fixed the CS_FX_ALPHA support in the GL renderer for the fact
	  that the "alpha" option actually contains transparency information
	  (as opposed to the usual meaning of 'alpha' as opacity).
	- res added support for user-defined mixmodes to the particles plugin.
16-Jun-2005
	- Jorrit fixed SimpleRoom.java so that it works again. Also
	  added a bit more code to demonstrate how to move objects.
	- Eric Sunshine fixed bug in csApplicationFramework where `restartFlag'
	  instance variable was not being initialized.
	- res changed csFlags::Set() to apply the mask to the 'value'parameter,
	  too. Previously, e.g. specifying a value of ~0 as the value would set
	  all bits, not just those in 'mask', as the documentation stated.
	- res gave the 'value' parameter of iMeshWrapper->SetFlagsRecursive()
	  a default value of ~0. This way all bits in specified in 'mask'
	  will be set (which mirrors the behaviour of the two csFlags::Set()
	  overloads). Also added a bit of documenation.
	- res fixed a typo in win32.cpp.
	- res made csGLGraphics3D::SetupStencil() disable clip planes before
	  drawing the stencil stuff. This has the same effect as Jorrit's
	  earlier fix in some cases, which however, as clip planes were
	  disabled all the time the clipping didn't change, caused clipping
	  issues in other places.
	- res fixed warping portals in the fat rl.
15-Jun-2005
	- res changed the SV context precedence slightly so that user-defined
	  mesh shader vars override SVs provided by the mesh plugin.
	- res fixed the logic to determine whether a mesh wrapper SV context
	  is empty.
	- Jorrit added CS_IS_BROADCAST_EVENT and used that define to change
	  csKeyEventHelper::GetEventData() so that it now also works for
	  broadcast events.
14-Jun-2005
	- res augmented DrawSimpleMesh() to not require an index array; if it
	  is omitted, an array that simply contains vertexCount indices with
	  values 0 to vertexCount-1 is used.
	- res further worked on the fat rl portal support. flarge now works to
	  some extent.
13-Jun-2005
	- res fixed cut-and-paste errors in the ARB fragment program code
	  (where GL_VERTEX_PROGRAM_ARB instead do GL_FRAGMENT_PROGRAM_ARB was
	  used).
	- res made some miscellaneous documentation fixes.
	- res fixed some issues reported by Bedrich Zaba <frogbride@seznam.cz>:
	    - GL DrawSimpleMesh() didn't use the shadervars from the shader.
	    - Shadervars specified in shader programs were not used. "Fixed" it
	      by removing support for SVs in programs. This functionality can
	      be achieved by other means (either by specifying SVs in the
	      shader itself or, for constant values, using variable mappings).
12-Jun-2005
	- res fixed the null renderer to report correct texture dimensions.
	- res added the CS_STRING_TO_WIDE macro. Useful when the value of a
	  macro is to be converted to a wide string.
	- res added csRedBlackTree<>::IsEmpty().
	- res made csShaderVariableContext::PushVariables() fill the new
	  entries in the enlarged 'stacks' array with 0s. Previously, the
	  new entries could contain invalid data.
	- res added some csInputBinder documentation.
11-Jun-2005
	- Piotr Obrzut added motor/stops functions to ODEUniversalJoint.
10-Jun-2005
	- Eric Sunshine eliminated several compilation warnings.
9-Jun-2005
	- Jorrit fixed the new CollideSegment() so that it really works
	  now.
	- Eric Sunshine fixed problem with recent csVector3 optimization which
	  prevented scripting languages from having access to the x, y, and z
	  members (a limitation of Swig).
	- res refined the RECT texture crash workaround by having it controlled
	  by the driver database.
	- res changed the parameter passing to Cg from using the data type of
	  the SV to the parameter type reported by Cg. Apparently, Cg is rather
	  strict and doesn't accept when e.g. a float3 value is set to a
	  float4 parameter (setting the param has no effect). So querying the
	  datatype Cg wants and using that gives a bit more tolerance against
	  type lapses.
8-Jun-2005
	- res moved all OpenGL-relevant config keys, for both canvases and
	  renderers, into r3dopengl.cfg. Also removed opengl.cfg.
	- res fixed the Win32 GL canvas to not throw away the result of the WGL
	  pixel format determination. Makes multisampling work again.
	- Jorrit added a new iCollideSystem->CollideSegment() routine which
	  works similarly as CollideRay() except that it collides with a finite
	  segment instead of an infinite ray. Extended OPCODE to support
	  this new function.
	- res worked around a problem where ATI drivers crash when a generic
	  compressed format is used for a RECT texture.
7-Jun-2005
	- res added support for "simple mappings" to the
	  csUnicodeTransform::MapToSomething() methods. "Simple mappings"
	  always return at most 1 character.
	- res made csKeyboardDriver::SynthesizeCooked() use
	  csUnicodeTransform::MapToUpper().
	- Jorrit did an optimization to the thing mesh with regards to
	  lighting. With both dynamic and pseudo-dynamic lighting it will
	  now detect if the light actually affects any of the polygons. If
	  not then the light will not be added as relevant for the thing.
	  In some situations this can give a huge performance boost (in
	  a level I'm making from 15->80 fps with a very small pseudo
	  dynamic light that is animation and a huge mesh that surrounds
	  it but is not affected by it).
	- Christopher Nelson added four files into the AWS plugin.  Currently
	  they are unused. Added new preferences storage functions, and an
	  XML-based translator.  The XML translator constructs a tree of
	  registries that contain only settings pertinent to the node the
	  settings reside in.  This system is very similar to the one AWS
	  currently uses, except that it has the element.attribute naming
	  system and it parses XML instead of AWS's custom definitions file.
6-Jun-2005
	- Anders fixed several bugs in array SV handling, and added loader
	  functionality for array SVs. Pseudo-syntax is:
	  <sv type="array"><sv .../><sv .../> ... </sv>
	- Eric Sunshine added `manualchm' Jam target to the build system which
	  converts the Crystal Space user manual to CHM (Microsoft's compressed
	  HTML help) format.  For this to work, you will need to have Perl
	  installed (www.activestate.com) and Microsoft's HTML Help
	  Workshop. Although CHM generation relies upon Microsoft's hhc.exe
	  (HTML Help Compiler), it is possible to create CHM format
	  documentation on Linux by running hhc.exe under Wine. The file
	  CS/docs/support/winhelp/README.txt contains instructions explaining
	  how to configure both Windows and Linux installations for CHM
	  generation.
	- Eric Sunshine fixed gristing problem in _Texinfo rule in docs.jam
	  which caused generated files to end up in an incorrect location if an
	  attempt was made by two different targets to convert the same Texinfo
	  sources to the same format.
	- Eric Sunshine augmented the various documentation generation rules in
	  docs.jam so that they return the gristed top-level output file as a
	  convenience to callers.
	- Eric Sunshine fixed bug in the Texi2HTML rule in docs.jam where it
	  failed to respect its `outfile' argument (i.e. it omitted texi2html's
	  -top-file= option).
	- Jorrit added support for x, y, and z relative vector to the node
	  object (iMapNode). This can be used together with map editors
	  (like blender) to export not only a position in a sector but also
	  x, y, and z relative direction. One usage is the ability to export
	  nodes for a spline path where you can encode the forward and up
	  vectors that way.
	- res did more fat rl modularization work.
	- res changed some csRenderContext members to use csRef<> instead of
	  plain pointers.
5-Jun-2005
	- Eric Sunshine fixed a bunch of compilation issues reported by
	  Apple/Tiger's gcc4.
	- Eric Sunshine fixed Swig 1.3.24 issue on Apple/Tiger which resulted
	  in linker complaining that iBase__DynamicCast was undefined.
	- Eric Sunshine augmented the 3DS check in configure.ac so that it also
	  looks for the utility `lib3ds-config', since this is the name of the
	  script installed by the lib3ds build process.
	- Eric Sunshine added check for `hhc.exe', the Microsoft HTML Help
	  compiler to configure.ac.
	- Eric Sunshine fixed bug in apps/tutorial/phystut/Jamfile where it
	  lacked an ExternalLibs invocation for ODE.
	- res added some explicit types at some places where event property bag
	  functions are used for mouse/joystick events to pacify pickier gccs.
	  Also changed some ints to uints where appropriate.
	- Anders added a vertex program rewriter for Cg, since removing the
	  old one caused Cg VPs to break on ATI drivers. The new one is much
	  simpler than the old one though. Arrays may still be borked,
	  so that needs investigation.
4-Jun-2005
	- Eric Sunshine worked around problem where Apple/Tiger's gcc4 rejects
	  -fvisibility-inlines-hidden in Objective-C++ mode. (This fix is
	  somewhat hacky. A cleaner solution will involve having the configure
	  script differentiate between the C++ and Objective-C++ compilers when
	  checking for accepted options.)
	- Eric Sunshine fixed a few compilation warnings reported by gcc4 on
	  Apple/Tiger (though quite a lot still remain for when more time is
	  available).
	- res started to make the fat rl more modular.
	- res added some support for rendering to NPOTS textures. Still
	  untested tho.
	- res made the Opcode plugin properly use a reporter from the object
	  registry to report Opcode issues.
	- res fixed some botched logic from the NPOTS changes above.
3-Jun-2005
	- Eric Sunshine fixed some more problems caused by spurious use of
	  'inline' on some C functions wrapping Objective-C for access by C++,
	  this time in plugins/video/canvas/macosx, which caused linking to
	  fail on account of undefined symbols on Tiger with gcc4.  Earlier
	  related fixes were made on 25-May-2005.
	- res fixed some gcc4 warnings reported by Terry Richards.
	- res updated the cs-win32libs URL in the manual.
2-Jun-2005
	- Jorrit reports: today I found out that there was a bug in blend2cs
	  which incorrectly put the mixmode flag with the thing mesh factory
	  in case there were multiple instances made of that thing. However,
	  instead of fixing blend2cs I decided to adapt Crystal Space to
	  that bug. It is now allowed to put mixmode in thing mesh factories.
	  If that is present then it will be the default mixmode for
	  things created from that factory.
1-Jun-2005
	- res made the following changes:
	    - Made the OpenGL DrawMesh() emit a string marker with the mesh
	      being drawn.
	    - Fixed parsing of the pairing modifier in the PS plugin; lines
	      like "+ mov ..." (notice the space after '+') were not handled
	      correctly.
	    - Added a config option to disable the creation of display lists
	      for NV pixel shader support. Useful for debugging.
	    - Fixed handling of source register component replication for NV
	      pixel shader support.
	    - Changed the NV pixel shader final combiner to something
	      apparently more working.
	    - Made a bunch of PS1 plugin output to be verbose-only and turned
	      some errors to warnings.
	    - Augmented the Cg plugin to also support PS routing on NV
	      hardware. Useful for testing.
	    - Removed some code from the Cg VP class which wasn't needed since
	      rewriting isn't done any more.
